package com.concatsys.tradein.tradein_plugin;


import android.content.Context;
import android.content.Intent;
import android.util.Log;

import androidx.annotation.NonNull;

import com.concatsys.tradein.tradein_plugin.activities.NativeViewActivity;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;

import io.flutter.embedding.android.FlutterActivity;
import io.flutter.embedding.engine.FlutterEngine;
import io.flutter.embedding.engine.plugins.FlutterPlugin;
import io.flutter.plugin.common.BinaryMessenger;
import io.flutter.plugin.common.MethodCall;
import io.flutter.plugin.common.MethodChannel;

public class MainActivity extends FlutterActivity implements FlutterPlugin, MethodChannel.MethodCallHandler {

    private static final String CHANNEL = "tradein_plugin";
    MethodChannel methodChannel;
    Context context;

    @Override
    public void configureFlutterEngine(@NonNull FlutterEngine flutterEngine) {
        super.configureFlutterEngine(flutterEngine);
        methodChannel = new MethodChannel(getFlutterView(), CHANNEL);
        methodChannel.setMethodCallHandler(this);
    }

    @Override
    protected void onDestroy() {
        super.onDestroy();
        methodChannel.setMethodCallHandler(null);
    }

    BinaryMessenger getFlutterView(){
        return getFlutterEngine().getDartExecutor().getBinaryMessenger();
    }

    @Override
    public void onMethodCall(@NonNull MethodCall call, @NonNull MethodChannel.Result result) {
        if (call.method.equals("getPlatformVersion")) {
//            startActivity(new Intent(context, NativeViewActivity.class));
//            result.success(true);
            result.success("Android " + android.os.Build.VERSION.RELEASE);
//            result.success(true);
        }
        if(call.method.equals("loadTradinPluginSDK")){
//            Object map = call.arguments();
//            Log.v("Venky", "call.arguments map "+map);
            TradeInSdk.openTradeInSdk(context);
//            context.startActivity(new Intent(context, NativeViewActivity.class)
//                    .setFlags(Intent.FLAG_ACTIVITY_NEW_TASK)
//                    .putExtra("Name", "venky - "+map)
//            );
            result.success(true);
        }
        if(call.method.equals("screenNavigate")){
//            List<String> stt = call.argument("Name");
//            List<String> stt = call.argument("args");
//            Log.v("Venky", "call.arguments list "+stt);
//            Map<String, ?> map = call.arguments();
////            Map<String, ?> map = call.arguments();
//            Log.v("Venky", "call.arguments map "+map);
            context.startActivity(new Intent(context, NativeViewActivity.class)
                    .setFlags(Intent.FLAG_ACTIVITY_NEW_TASK)
                    .putExtra("Name", "venkydfa")
            );
//            List<String> list = new ArrayList<>();
//            list.add("A");
//            list.add("B");
//            list.add("C");
//            Log.v("Venky", "call.arguments list "+list);
            result.success(true);
        }
//        else {
//            result.notImplemented();
//        }
    }

    @Override
    public void onAttachedToEngine(@NonNull FlutterPluginBinding flutterPluginBinding) {
        methodChannel = new MethodChannel(flutterPluginBinding.getBinaryMessenger(), "tradein_plugin");
        methodChannel.setMethodCallHandler(this);
        this.context = flutterPluginBinding.getApplicationContext();
    }

    @Override
    public void onDetachedFromEngine(@NonNull FlutterPluginBinding binding) {
        methodChannel.setMethodCallHandler(null);
    }
}