package com.concatsys.tradein.tradein_plugin;

import android.app.Activity;
import android.content.Context;
import android.content.Intent;

import androidx.fragment.app.Fragment;

import com.concatsys.tradein.tradein_plugin.activity.AddVehicleActivity;
import com.concatsys.tradein.tradein_plugin.api.ApiService;
import com.concatsys.tradein.tradein_plugin.activity.ConstantsActivity;
import com.concatsys.tradein.tradein_plugin.activity.MyVehicleActivity;
import com.concatsys.tradein.tradein_plugin.api.ConstantsApi;
import com.concatsys.tradein.tradein_plugin.db.ConstantsDB;
import com.concatsys.tradein.tradein_plugin.db.DBOperations;
import com.concatsys.tradein.tradein_plugin.logs.LoggerTradeIn;
import com.concatsys.tradein.tradein_plugin.logscapture.LogsCaptureCalls;
import com.concatsys.tradein.tradein_plugin.sharedpreference.SharedPreferenceTI;

public class TradeInSdk {
    private static final String TAG = "TradeInSdk";
    private static Context mContext;
//    private static Activity mActivity;

    private TradeInSdk(Context context) {
        mContext = context;
    }

    /* Open Sdk With Context */
    public static void openTradeInSdk(Context context) {
        mContext = context;
//        mActivity = (Activity) context;
        startFirstActivity();
    }

    /* Open Sdk With Activity */
    public static void openTradeInSdk(Activity activity) {
        LoggerTradeIn.e(TAG, "openTradeInSdk Activity");
        mContext = activity;
//        mActivity = activity;
        startFirstActivity();
    }

    /* Open Sdk With Fragment */
    public static void openTradeInSdk(Fragment fragment) {
        LoggerTradeIn.e(TAG, "openTradeInSdk Fragment");
        mContext = fragment.getContext();
//        mActivity = (Activity) mContext;
        startFirstActivity();
    }

//    static SharedPreferenceTI sharedPreferenceTI;
    /* Open Sdk With Flag which screen required to start */
    public static void startFirstActivity() {
        LoggerTradeIn.e(TAG, "startFirstActivity");
        SharedPreferenceTI sharedPreferenceTI = SharedPreferenceTI.getInstance();
        ConstantsDB.TABLE_NAME_SCREEN = sharedPreferenceTI.getStringValue(mContext, ConstantsDB.SHARED_PREFS_SCREEN_KEY);
        DBOperations dbOperations = DBOperations.getInstance();
        dbOperations.getMyVehicleSize(mContext);
        if (ConstantsDB.TABLE_NAME_SCREEN.equals(mContext.getString(R.string.add_vehicle))) {
            startFirstIntent(mContext, AddVehicleActivity.class);
        } else if (ConstantsDB.TABLE_NAME_SCREEN.equals(mContext.getString(R.string.my_vehicle))) {
            startFirstIntent(mContext, MyVehicleActivity.class);
        } else {
            startFirstIntent(mContext, MyVehicleActivity.class);
        }
        if (ConstantsActivity.hmDBVehicles.size() < 1) {
            ConstantsApi.FLAG_API_NAME = ConstantsApi.FLAG_API_DROP_DOWN;
            Intent serviceIntent = new Intent(mContext, ApiService.class);
            mContext.startService(serviceIntent);
        }
    }

    /* Common Intent  */
    private static void startFirstIntent(Context context, Class editScreen) {
        Intent intent = new Intent(context, editScreen);
        intent.setFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
        context.startActivity(intent);
//        finish();
    }
}
