package com.concatsys.tradein.tradein_plugin.activity;

import android.app.Activity;
import android.os.Bundle;
import android.view.View;
import android.view.Window;
import android.widget.Button;

import androidx.recyclerview.widget.LinearLayoutManager;
import androidx.recyclerview.widget.RecyclerView;

import com.concatsys.tradein.tradein_plugin.R;
import com.concatsys.tradein.tradein_plugin.adapter.ApiCallsAdapter;
import com.concatsys.tradein.tradein_plugin.api.ApiAsyncTask;
import com.concatsys.tradein.tradein_plugin.api.ApiListOperations;
import com.concatsys.tradein.tradein_plugin.api.ConstantsApi;
import com.concatsys.tradein.tradein_plugin.interfaces.ApiCallback;
import com.concatsys.tradein.tradein_plugin.logs.LoggerTradeIn;
import com.concatsys.tradein.tradein_plugin.utils.NetworkCheck;

public class ApiCallsActivity extends Activity implements ApiCallback, View.OnClickListener {
    private String TAG = getClass().getSimpleName();
    private RecyclerView apiRecyclerView;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        requestWindowFeature(Window.FEATURE_NO_TITLE);
        setContentView(R.layout.activty_api_call);
//        initUI();
        startApiCall();
    }

    private void initUI() {
        Button btn_send_request = findViewById(R.id.btn_send_request);
        btn_send_request.setOnClickListener(this);
    }

    //
    @Override
    protected void onResume() {
        super.onResume();
//        startApiCall();
//        ApiOperations apiOperations = ApiOperations.getInstance();
//        apiOperations.startApiCall();
//        Intent serviceIntent = new Intent(this, ApiCallService.class);
//        startService(serviceIntent);

    }

    private void startApiCall() {
        NetworkCheck networkCheck = NetworkCheck.getInstance();
        if (networkCheck.isNetworkConnected(this)) {
            ApiAsyncTask apiAsyncTask = null;
            if (apiAsyncTask != null) {
                apiAsyncTask.cancel(true);
            }

            if (ConstantsApi.FLAG_API_NAME.equalsIgnoreCase(ConstantsApi.FLAG_API_DROP_DOWN)) {
                ConstantsApi.SUB_URL = ConstantsApi.DROP_DOWN_URL;
            } else if (ConstantsApi.FLAG_API_NAME.equalsIgnoreCase(ConstantsApi.FLAG_API_Model)) {
                ConstantsApi.MODEL_URL = "GetModelWithMake&MAKE_ID="+ConstantsApi.MAKE_ID;
                ConstantsApi.SUB_URL = ConstantsApi.MODEL_URL;
            }
            ConstantsApi.API_CALL_URL = ConstantsApi.BASE_URL + ConstantsApi.SUB_URL;
            apiAsyncTask = ApiAsyncTask.getInstance(this, ConstantsApi.API_CALL_URL);
            apiAsyncTask.execute();
        }
    }

    private void appendDataRecyclerView() {
        apiRecyclerView = findViewById(R.id.api_recycler_view);
        ApiCallsAdapter adapterHL = new ApiCallsAdapter(ConstantsApi.alHMYears, this,R.layout.view_item_api_rv);
        apiRecyclerView.setLayoutManager(new LinearLayoutManager(this));
        apiRecyclerView.setAdapter(adapterHL);
    }

    @Override
    public void onClick(View v) {
        if (v.getId() == R.id.btn_send_request) {
            startApiCall();
        }
    }

    @Override
    public void sendResponse(String strResponse) {
        try {
            LoggerTradeIn.e(TAG, "sendResponse");
            LoggerTradeIn.e(TAG, strResponse);
            ApiListOperations apiListOperations = ApiListOperations.getInstance();
            if (ConstantsApi.FLAG_API_NAME.equalsIgnoreCase(ConstantsApi.FLAG_API_DROP_DOWN)) {
                apiListOperations.jsonOperationAllDropDowns(strResponse.trim());
            } else if (ConstantsApi.FLAG_API_NAME.equalsIgnoreCase(ConstantsApi.FLAG_API_Model)) {
                apiListOperations.jsonOperationModel(strResponse.trim());
            }
            finish();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    //
//    private ArrayList<HashMap<String, String>> alHashMapKeys = new ArrayList<>();
//    private ArrayList<String> alJsonParsing = new ArrayList<>();
//    private ArrayList<ApiDataModel> alContactsModel;

}
