package com.concatsys.tradein.tradein_plugin.activity;

import android.os.Bundle;
import android.view.View;
import android.widget.Button;

import androidx.appcompat.app.AppCompatActivity;
import androidx.recyclerview.widget.LinearLayoutManager;
import androidx.recyclerview.widget.RecyclerView;

import com.concatsys.tradein.tradein_plugin.R;
import com.concatsys.tradein.tradein_plugin.adapter.ApiCallsAdapter;
import com.concatsys.tradein.tradein_plugin.api.ApiAsyncTask;
import com.concatsys.tradein.tradein_plugin.api.ApiJsonParsing;
import com.concatsys.tradein.tradein_plugin.api.ConstantsApi;
import com.concatsys.tradein.tradein_plugin.interfaces.ApiCallback;
import com.concatsys.tradein.tradein_plugin.logs.LoggerTradeIn;
import com.concatsys.tradein.tradein_plugin.utils.NetworkCheck;

import org.json.JSONException;
import org.json.JSONObject;

import java.util.ArrayList;
import java.util.HashMap;

public class ApiCallsActivityV2  extends AppCompatActivity implements ApiCallback, View.OnClickListener {
    private String TAG = getClass().getSimpleName();
    private RecyclerView apiRecyclerView;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activty_api_call);
        initUI();
    }

    private void initUI() {
        Button btn_send_request = findViewById(R.id.btn_send_request);
        btn_send_request.setOnClickListener(this);
    }

    //
    @Override
    protected void onResume() {
        super.onResume();
        startApiCall();
//        ApiOperations apiOperations = ApiOperations.getInstance();
//        apiOperations.startApiCall(this);
//        ProgressDialogData progressDialogData = new ProgressDialogData(this);
//        progressDialogData.show();
    }

    private void startApiCall() {
        NetworkCheck networkCheck = NetworkCheck.getInstance();
        if (networkCheck.isNetworkConnected(this)) {
            ApiAsyncTask apiAsyncTask = null;
            if (apiAsyncTask != null) {
                apiAsyncTask.cancel(true);
            }
//            ConstantsApi.API_CALL_URL = ConstantsApi.BASE_URL+ ConstantsApi.CONTACTS_URL;
            ConstantsApi.API_CALL_URL = ConstantsApi.BASE_URL + ConstantsApi.DROP_DOWN_URL;
            apiAsyncTask = ApiAsyncTask.getInstance(this, ConstantsApi.API_CALL_URL);
//                    AsyncTaskApi asyncTaskApi = new AsyncTaskApi(this, BASE_URL, CONTACTS_URL);
            apiAsyncTask.execute();
        }
    }

    private void appendDataRecyclerView() {
        apiRecyclerView = findViewById(R.id.api_recycler_view);
//        AdapterALStrings adapterALStrings = new AdapterALStrings(alJsonParsing, this);
//        AdapterModelsData adapterModelsData = new AdapterModelsData(alContactsModel,this);
        ApiCallsAdapter adapterHL = new ApiCallsAdapter(alHMYears, this,R.layout.view_item_api_rv);
        apiRecyclerView.setLayoutManager(new LinearLayoutManager(this));
        apiRecyclerView.setAdapter(adapterHL);
    }

    @Override
    public void onClick(View v) {
        if (v.getId() == R.id.btn_send_request) {
            startApiCall();
        }
    }

    @Override
    public void sendResponse(String strResponse) {
        try {
            LoggerTradeIn.e(TAG, "sendResponse");
//            LoggerTradeIn.e(TAG, strResponse);
            jsonOperation(strResponse.trim());
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    //
//    private ArrayList<HashMap<String, String>> alHashMapKeys = new ArrayList<>();
    private ArrayList<HashMap<String, String>> alHMYears = new ArrayList<>();
    private ArrayList<HashMap<String, String>> alHMMake = new ArrayList<>();
    private ArrayList<HashMap<String, String>> alHMTrim = new ArrayList<>();
    private ArrayList<HashMap<String, String>> alHMExteriorColor = new ArrayList<>();
    private ArrayList<HashMap<String, String>> alHMInteriorColor = new ArrayList<>();
    private ArrayList<HashMap<String, String>> alHMTransmissions = new ArrayList<>();
    private ArrayList<HashMap<String, String>> alHMDriveTrains = new ArrayList<>();
    private ArrayList<HashMap<String, String>> alHMBodyStyles = new ArrayList<>();
    private ArrayList<HashMap<String, String>> alHMEngines = new ArrayList<>();
    private ArrayList<HashMap<String, String>> alHMSeatTypes = new ArrayList<>();
    private ArrayList<HashMap<String, String>> alHMVehicleOptions = new ArrayList<>();
    private ArrayList<HashMap<String, String>> alHMInteriorVehicleConditions = new ArrayList<>();
    private ArrayList<HashMap<String, String>> alHMExteriorVehicleConditions = new ArrayList<>();
    private ArrayList<HashMap<String, String>> alHMVehicleSmoke = new ArrayList<>();
    private ArrayList<HashMap<String, String>> alHMVehicleAccident = new ArrayList<>();
//    private ArrayList<String> alJsonParsing = new ArrayList<>();
//    private ArrayList<ApiDataModel> alContactsModel;

    private void jsonOperation(String strResponse) {
        try {
            LoggerTradeIn.e(TAG, "jsonOperation");
            JSONObject jsonResponse = new JSONObject(strResponse);
            String strData = jsonResponse.getString(ConstantsApi.KEYS_DROP_DOWN_PARSE[2]);
            JSONObject jsonResponseDATA = new JSONObject(strData);

            ApiJsonParsing apiJsonParsing = ApiJsonParsing.getInstance();
//            alContacts = jsonParsing.jsonEmptyArrayListParse(jsonResponse.getJSONArray("contacts"));
//            alHashMapRes = jsonParsing.parseJsonHashMapDynamic(jsonResponse);
//            alHashMapKeys = apiJsonParsing.jsonHashMapArrayKeys(jsonResponse.getJSONArray("contacts"), ConstantsApi.KEYS_PARSE);
            alHMYears = apiJsonParsing.jsonHashMapArrayKeys(jsonResponseDATA.getJSONArray(ConstantsApi.KEYS_DROP_DOWN_PARSE[3]), ConstantsApi.KEYS_DROP_DOWN_YEARS);
            alHMMake = apiJsonParsing.jsonHashMapArrayKeys(jsonResponseDATA.getJSONArray(ConstantsApi.KEYS_DROP_DOWN_PARSE[4]), ConstantsApi.KEYS_DROP_DOWN_MAKE);

            alHMTrim = apiJsonParsing.jsonHashMapArrayKeys(jsonResponseDATA.getJSONArray(ConstantsApi.KEYS_DROP_DOWN_PARSE[5]), ConstantsApi.KEYS_DROP_DOWN_TRIM);
            alHMExteriorColor = apiJsonParsing.jsonHashMapArrayKeys(jsonResponseDATA.getJSONArray(ConstantsApi.KEYS_DROP_DOWN_PARSE[6]), ConstantsApi.KEYS_DROP_DOWN_EXTERIOR_COLOR);
            alHMInteriorColor = apiJsonParsing.jsonHashMapArrayKeys(jsonResponseDATA.getJSONArray(ConstantsApi.KEYS_DROP_DOWN_PARSE[7]), ConstantsApi.KEYS_DROP_DOWN_INTERIOR_COLOR);
            alHMTransmissions = apiJsonParsing.jsonHashMapArrayKeys(jsonResponseDATA.getJSONArray(ConstantsApi.KEYS_DROP_DOWN_PARSE[8]), ConstantsApi.KEYS_DROP_DOWN_TRANSMISSION);
            alHMDriveTrains = apiJsonParsing.jsonHashMapArrayKeys(jsonResponseDATA.getJSONArray(ConstantsApi.KEYS_DROP_DOWN_PARSE[9]), ConstantsApi.KEYS_DROP_DOWN_DRIVE_TRAIN);
            alHMBodyStyles = apiJsonParsing.jsonHashMapArrayKeys(jsonResponseDATA.getJSONArray(ConstantsApi.KEYS_DROP_DOWN_PARSE[10]), ConstantsApi.KEYS_DROP_DOWN_BODY_STYLE);
            alHMEngines = apiJsonParsing.jsonHashMapArrayKeys(jsonResponseDATA.getJSONArray(ConstantsApi.KEYS_DROP_DOWN_PARSE[11]), ConstantsApi.KEYS_DROP_DOWN_ENGINE);
            alHMSeatTypes = apiJsonParsing.jsonHashMapArrayKeys(jsonResponseDATA.getJSONArray(ConstantsApi.KEYS_DROP_DOWN_PARSE[12]), ConstantsApi.KEYS_DROP_DOWN_SEAT_TYPE);
            alHMVehicleOptions = apiJsonParsing.jsonHashMapArrayKeys(jsonResponseDATA.getJSONArray(ConstantsApi.KEYS_DROP_DOWN_PARSE[13]), ConstantsApi.KEYS_DROP_DOWN_VEHICLE_OPTION);
            alHMInteriorVehicleConditions = apiJsonParsing.jsonHashMapArrayKeys(jsonResponseDATA.getJSONArray(ConstantsApi.KEYS_DROP_DOWN_PARSE[14]), ConstantsApi.KEYS_DROP_DOWN_INTERIOR_CONDITION);
            alHMExteriorVehicleConditions = apiJsonParsing.jsonHashMapArrayKeys(jsonResponseDATA.getJSONArray(ConstantsApi.KEYS_DROP_DOWN_PARSE[15]), ConstantsApi.KEYS_DROP_DOWN_EXTERIOR_CONDITION);
            alHMVehicleSmoke = apiJsonParsing.jsonHashMapArrayKeys(jsonResponseDATA.getJSONArray(ConstantsApi.KEYS_DROP_DOWN_PARSE[16]), ConstantsApi.KEYS_DROP_DOWN_SMOKE);
            alHMVehicleAccident = apiJsonParsing.jsonHashMapArrayKeys(jsonResponseDATA.getJSONArray(ConstantsApi.KEYS_DROP_DOWN_PARSE[17]), ConstantsApi.KEYS_DROP_DOWN_ACCIDENT);

//            LoggerTradeIn.e(TAG, alHMYears.size() + "");
            LoggerTradeIn.e(TAG, alHMYears.get(0).get(ConstantsApi.KEYS_DROP_DOWN_YEARS[1]) + "");
            LoggerTradeIn.e(TAG, alHMMake.get(0).get(ConstantsApi.KEYS_DROP_DOWN_MAKE[1]) + "");
            LoggerTradeIn.e(TAG, alHMTrim.get(0).get(ConstantsApi.KEYS_DROP_DOWN_TRIM[1]) + "");
            LoggerTradeIn.e(TAG, alHMExteriorColor.get(0).get(ConstantsApi.KEYS_DROP_DOWN_EXTERIOR_COLOR[1]) + "");
            LoggerTradeIn.e(TAG, alHMInteriorColor.get(0).get(ConstantsApi.KEYS_DROP_DOWN_INTERIOR_COLOR[1]) + "");
            LoggerTradeIn.e(TAG, alHMTransmissions.get(0).get(ConstantsApi.KEYS_DROP_DOWN_TRANSMISSION[1]) + "");
            LoggerTradeIn.e(TAG, alHMDriveTrains.get(0).get(ConstantsApi.KEYS_DROP_DOWN_DRIVE_TRAIN[1]) + "");
            LoggerTradeIn.e(TAG, alHMBodyStyles.get(0).get(ConstantsApi.KEYS_DROP_DOWN_BODY_STYLE[1]) + "");
            LoggerTradeIn.e(TAG, alHMEngines.get(0).get(ConstantsApi.KEYS_DROP_DOWN_ENGINE[1]) + "");
            LoggerTradeIn.e(TAG, alHMSeatTypes.get(0).get(ConstantsApi.KEYS_DROP_DOWN_SEAT_TYPE[1]) + "");
            LoggerTradeIn.e(TAG, alHMVehicleOptions.get(0).get(ConstantsApi.KEYS_DROP_DOWN_VEHICLE_OPTION[1]) + "");
            LoggerTradeIn.e(TAG, alHMInteriorVehicleConditions.get(0).get(ConstantsApi.KEYS_DROP_DOWN_INTERIOR_CONDITION[1]) + "");
            LoggerTradeIn.e(TAG, alHMExteriorVehicleConditions.get(0).get(ConstantsApi.KEYS_DROP_DOWN_EXTERIOR_CONDITION[1]) + "");
            LoggerTradeIn.e(TAG, alHMVehicleSmoke.get(0).get(ConstantsApi.KEYS_DROP_DOWN_SMOKE[1]) + "");
            LoggerTradeIn.e(TAG, alHMVehicleAccident.get(0).get(ConstantsApi.KEYS_DROP_DOWN_ACCIDENT[1]) + "");

            appendDataRecyclerView();
        } catch (JSONException e) {
            e.printStackTrace();
        }
    }
}

