package com.concatsys.tradein.tradein_plugin.activity;

import android.Manifest;
import android.app.Service;
import android.content.ContentResolver;
import android.content.Intent;
import android.net.Uri;
import android.os.IBinder;
import android.util.Log;
import android.webkit.MimeTypeMap;

import androidx.annotation.Nullable;

import com.concatsys.tradein.tradein_plugin.backblaze.client.BlazeClient;
import com.concatsys.tradein.tradein_plugin.backblaze.fileuploader.BlazeFileUploader;
import com.concatsys.tradein.tradein_plugin.backblaze.fileuploader.ConstantsBB;
import com.concatsys.tradein.tradein_plugin.backblaze.fileuploader.UploadListener;
import com.concatsys.tradein.tradein_plugin.backblaze.upload_models.UploadResponse;
import com.concatsys.tradein.tradein_plugin.api.ApiService;
import com.concatsys.tradein.tradein_plugin.api.ConstantsApi;

import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.util.ArrayList;
import java.util.Calendar;

public class BlackBaseService extends Service {
    private String TAG = getClass().getSimpleName();
    ArrayList<String> files = new ArrayList<>();
    BlazeClient client;
    private static final int REQUEST_EXTERNAL_STORAGE = 1;
    private static String[] PERMISSIONS_STORAGE = {
            Manifest.permission.READ_EXTERNAL_STORAGE,
            Manifest.permission.WRITE_EXTERNAL_STORAGE
    };
    public static final String BLAZE_APP_KEY_ID = "002896bc535d7040000000004";
    public static final String BLAZE_APP_KEY = "K002oj1DxJjPjdFBnwWjxufl/t4Q7aM";
    public static final String BLAZE_BUCKET_ID = "889946db6c6553857da70014";
    public static final String BLAZE_BUCKET_NAME = "kbtesting";

    @Nullable
    @Override
    public IBinder onBind(Intent intent) {
        return null;
    }

    @Override
    public int onStartCommand(Intent intent, int flags, int startId) {
        startBlackBlaze();
        return super.onStartCommand(intent, flags, startId);
    }

    BlazeFileUploader blazeFileUploader;

    private void startBlackBlaze() {
        Log.e(TAG, "startBlackBlaze");
        client = new BlazeClient(this, BLAZE_APP_KEY_ID, BLAZE_APP_KEY);
        blazeFileUploader =
                new BlazeFileUploader(client, BLAZE_BUCKET_ID);
//        if(ConstantsBB.FLAG_SINGLE_MULTI.equals(ConstantsBB.FLAG_MULTI)){
        Log.e(TAG, ConstantsBB.alMultiFile.size()+" @####");
        if (ConstantsBB.alMultiFile.size() > 1) {
            processMultiFile();
        } else if (ConstantsBB.alMultiFile.size() < 2) {
//            if(ConstantsBB.FLAG_SINGLE_MULTI.equals(ConstantsBB.FLAG_SINGLE)){
            processSingleFile();
//            blazeFileUploader.startUploading(ConstantsBB.singleImageURI, ConstantsBB.IMAGE_NAME_EXTENSION);

        }
        uploadListener();

    }

    private void processSingleFile() {
        Log.e(TAG, "processSingleFile");
        getImageName();
        ConstantsBB.IMAGE_NAME_EXTENSION = ConstantsBB.IMAGE_NAME + "." + ConstantsBB.IMAGE_EXTENSION;
//        blazeFileUploader.startUploading(ConstantsBB.singleImageURI, ConstantsBB.IMAGE_NAME_EXTENSION);
        blazeFileUploader.startUploading(ConstantsBB.alMultiFile.get(0).getFileUri(), ConstantsBB.IMAGE_NAME_EXTENSION);
    }

    private void processMultiFile() {
        Log.e(TAG, "processMultiFile");
        int count = ConstantsBB.alMultiFile.size(); //evaluate the count before the for loop --- otherwise, the count is evaluated every loop.

        if (ConstantsBB.alMultiFile.size() > 0) {
            Log.e("arrayList-size", ConstantsBB.alMultiFile.size() + "");
            blazeFileUploader.startUploadingMultipleFiles(ConstantsBB.alMultiFile);
        }
        for (int i = 0; i < ConstantsBB.alMultiFile.size(); i++) {
            Log.e("arrayList", ConstantsBB.alMultiFile.get(i).getFileUri() + "");
        }
//        uploadListener();
    }

    private void uploadListener() {
        Log.e(TAG, "uploadListener");
        blazeFileUploader.setOnUploadingListener(new UploadListener() {
            @Override
            public void onUploadStarted() {
                Log.e("onUploadStarted", "onUploadStarted");
            }

            @Override
            public void onUploadProgress(int percentage, long progress, long total) {
//                        Log.e("onUploadProgress", percentage + " - " + progress + " - " + total);
            }

            @Override
            public void onUploadFinished(UploadResponse response, boolean allFilesUploaded) {
                Log.e(TAG, "onUploadFinished");
                Log.e(TAG, "response = " + response + "");
                Log.e(TAG, "getContentSha1 = " + response.getContentSha1() + "");
                Log.e(TAG, "allFilesUploaded = " + allFilesUploaded + "");
                if (allFilesUploaded) {
                    stopService();
                    callMediaApi();
                }
            }

            @Override
            public void onUploadFailed(Exception e) {
                Log.e(TAG, "onUploadFailed");
                Log.e(TAG, "Failed - Exception"+ e + "");

            }
        });
    }

    private void callMediaApi() {
        ConstantsApi.FLAG_API_NAME = ConstantsApi.FLAG_API_MEDIA;
        Intent serviceIntent = new Intent(this, ApiService.class);
        startService(serviceIntent);
    }

    private void getImageName() {
        Calendar cal = Calendar.getInstance();
        ConstantsBB.IMAGE_NAME = cal.getTimeInMillis() + "";
        Log.e("IMAGE_NAME", ConstantsBB.IMAGE_NAME + "");
        Log.e("IMAGE_EXTENSION", ConstantsBB.IMAGE_EXTENSION + "");
//        String strFileExtension = getFileExtension(ConstantsBB.singleImageURI);
        String strFileExtension = getFileExtension(ConstantsBB.alMultiFile.get(0).getFileUri());
        ConstantsBB.IMAGE_EXTENSION = strFileExtension;
        Log.e("strFilePath2", strFileExtension + "");
    }

    private String getFileExtension(Uri uri) {
        String extension;
        ContentResolver contentResolver = getContentResolver();
        MimeTypeMap mimeTypeMap = MimeTypeMap.getSingleton();
        extension = mimeTypeMap.getExtensionFromMimeType(contentResolver.getType(uri));
        return extension;
    }

    public byte[] getBytes(InputStream inputStream) throws IOException {
        ByteArrayOutputStream byteBuffer = new ByteArrayOutputStream();
        int bufferSize = 1024;
        byte[] buffer = new byte[bufferSize];

        int len = 0;
        while ((len = inputStream.read(buffer)) != -1) {
            byteBuffer.write(buffer, 0, len);
        }
        return byteBuffer.toByteArray();
    }

    private void stopService() {
        Intent serviceIntent = new Intent(this, BlackBaseService.class);
        stopService(serviceIntent);
    }
}
