package com.concatsys.tradein.tradein_plugin.activity;

import android.Manifest;
import android.app.Activity;
import android.content.ContentResolver;
import android.content.ContentUris;
import android.content.Context;
import android.content.Intent;
import android.content.pm.PackageManager;
import android.database.Cursor;
import android.net.Uri;
import android.os.Build;
import android.os.Bundle;
import android.os.Environment;
import android.os.StrictMode;
import android.provider.DocumentsContract;
import android.provider.MediaStore;
import android.util.Log;
import android.view.View;
import android.webkit.MimeTypeMap;

import androidx.appcompat.app.AppCompatActivity;
import androidx.core.app.ActivityCompat;
import androidx.core.content.ContextCompat;

import com.concatsys.tradein.tradein_plugin.backblaze.FileTypes;
import com.concatsys.tradein.tradein_plugin.backblaze.client.BlazeClient;
import com.concatsys.tradein.tradein_plugin.backblaze.filedownloader.BlazeFileDownloader;
import com.concatsys.tradein.tradein_plugin.backblaze.fileuploader.BlazeFileUploader;
import com.concatsys.tradein.tradein_plugin.backblaze.fileuploader.ConstantsBB;
import com.concatsys.tradein.tradein_plugin.backblaze.fileuploader.MultiFile;
import com.concatsys.tradein.tradein_plugin.backblaze.fileuploader.UploadListener;
import com.concatsys.tradein.tradein_plugin.backblaze.upload_models.UploadResponse;
import com.concatsys.tradein.tradein_plugin.R;

import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStream;
import java.net.URISyntaxException;
import java.net.URLConnection;
import java.util.ArrayList;
import java.util.Calendar;

public class BlackBlazeActivityV1 extends AppCompatActivity {
    ArrayList<String> files = new ArrayList<>();
    BlazeClient client;
    private static final int REQUEST_EXTERNAL_STORAGE = 1;
    private static String[] PERMISSIONS_STORAGE = {
            Manifest.permission.READ_EXTERNAL_STORAGE,
            Manifest.permission.WRITE_EXTERNAL_STORAGE
    };

    /*public static final String BLAZE_APP_KEY_ID = "002c87f3b41af2d0000000001";
    public static final String BLAZE_APP_KEY = "K002r1xuTlrwx1lsr3hugMa6S2rI5Aw";
    public static final String BLAZE_BUCKET_ID = "cc8877ff330b74417acf021d";
    public static final String BLAZE_BUCKET_NAME = "tradein";*/

    public static final String BLAZE_APP_KEY_ID = "002896bc535d7040000000004";
    public static final String BLAZE_APP_KEY = "K002oj1DxJjPjdFBnwWjxufl/t4Q7aM";
    public static final String BLAZE_BUCKET_ID = "889946db6c6553857da70014";
    public static final String BLAZE_BUCKET_NAME = "kbtesting";


    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_black_blaze);

        StrictMode.ThreadPolicy policy = new
                StrictMode.ThreadPolicy.Builder().permitAll().build();
        StrictMode.setThreadPolicy(policy);

        client = new BlazeClient(this, BLAZE_APP_KEY_ID, BLAZE_APP_KEY);

        /*Intent intent;
        intent = new Intent(Intent.ACTION_OPEN_DOCUMENT);
        intent.putExtra(Intent.EXTRA_ALLOW_MULTIPLE, true);
        intent.addFlags(Intent.FLAG_GRANT_PERSISTABLE_URI_PERMISSION);

        intent.putExtra(Intent.EXTRA_LOCAL_ONLY, true);
        intent.addFlags(Intent.FLAG_GRANT_READ_URI_PERMISSION);
        intent.setType("image/*");
      startActivityForResult(Intent.createChooser(intent,""), 10);*/
    }


    private boolean checkPermission() {
        int result = ContextCompat.checkSelfPermission(this,
                Manifest.permission.WRITE_EXTERNAL_STORAGE);
        if (result == PackageManager.PERMISSION_GRANTED) {

            return true;

        } else {

            return false;
        }
    }

    private void requestPermission() {

        ActivityCompat.requestPermissions(this, new String[]{Manifest.permission.WRITE_EXTERNAL_STORAGE}, 4);

    }

    public byte[] getBytes(InputStream inputStream) throws IOException {
        ByteArrayOutputStream byteBuffer = new ByteArrayOutputStream();
        int bufferSize = 1024;
        byte[] buffer = new byte[bufferSize];

        int len = 0;
        while ((len = inputStream.read(buffer)) != -1) {
            byteBuffer.write(buffer, 0, len);
        }
        return byteBuffer.toByteArray();
    }

    public String getPath(Context context, Uri uri) throws URISyntaxException {
        final boolean needToCheckUri = Build.VERSION.SDK_INT >= 19;
        String selection = null;
        String[] selectionArgs = null;
        // Uri is different in versions after KITKAT (Android 4.4), we need to
        // deal with different Uris.
        if (needToCheckUri && DocumentsContract.isDocumentUri(context.getApplicationContext(), uri)) {
            if (isExternalStorageDocument(uri)) {
                final String docId = DocumentsContract.getDocumentId(uri);
                final String[] split = docId.split(":");
                return Environment.getExternalStorageDirectory() + "/" + split[1];
            } else if (isDownloadsDocument(uri)) {
                final String id = DocumentsContract.getDocumentId(uri);
                uri = ContentUris.withAppendedId(
                        Uri.parse("content://downloads/public_downloads"), Long.valueOf(id));
            } else if (isMediaDocument(uri)) {
                final String docId = DocumentsContract.getDocumentId(uri);
                final String[] split = docId.split(":");
                final String type = split[0];
                if ("image".equals(type)) {
                    uri = MediaStore.Images.Media.EXTERNAL_CONTENT_URI;
                } else if ("video".equals(type)) {
                    uri = MediaStore.Video.Media.EXTERNAL_CONTENT_URI;
                } else if ("audio".equals(type)) {
                    uri = MediaStore.Audio.Media.EXTERNAL_CONTENT_URI;
                }
                selection = "_id=?";
                selectionArgs = new String[]{split[1]};
            }
        }
        if ("content".equalsIgnoreCase(uri.getScheme())) {
            String[] projection = {MediaStore.Images.Media.DATA};
            Cursor cursor = null;
            try {
                cursor = context.getContentResolver().query(uri, projection, selection, selectionArgs, null);
                int column_index = cursor.getColumnIndexOrThrow(MediaStore.Images.Media.DATA);
                if (cursor.moveToFirst()) {
                    return cursor.getString(column_index);
                }
            } catch (Exception e) {
            }
        } else if ("file".equalsIgnoreCase(uri.getScheme())) {
            return uri.getPath();
        }
        return null;
    }

    public static boolean isExternalStorageDocument(Uri uri) {
        return "com.android.externalstorage.documents".equals(uri.getAuthority());
    }

    public static boolean isDownloadsDocument(Uri uri) {
        return "com.android.providers.downloads.documents".equals(uri.getAuthority());
    }

    public static boolean isMediaDocument(Uri uri) {
        return "com.android.providers.media.documents".equals(uri.getAuthority());
    }

    private String getFileExtension(Uri uri) {
        String extension;
        ContentResolver contentResolver = getContentResolver();
        MimeTypeMap mimeTypeMap = MimeTypeMap.getSingleton();
        extension = mimeTypeMap.getExtensionFromMimeType(contentResolver.getType(uri));
        return extension;
    }

    public static boolean isImageFile(String path) {
        String mimeType = URLConnection.guessContentTypeFromName(path);
        return mimeType != null && mimeType.startsWith("image");
    }

    public static boolean isVideoFile(String path) {
        String mimeType = URLConnection.guessContentTypeFromName(path);
        return mimeType != null && mimeType.startsWith("video");
    }

    Uri selectedImageURI;

    @Override
    public void onActivityResult(int requestCode, int resultCode, Intent data) {
        super.onActivityResult(requestCode, resultCode, data);
        selectedImageURI = data.getData();
        /*try {
            String strFilePath = getPath(this, selectedImageURI);
            Log.e("strFilePath", strFilePath + "");
            boolean isVideo = isVideoFile(strFilePath);
            Log.e("isVideo", isVideo + "");
        } catch (URISyntaxException e) {
            e.printStackTrace();
        }*/

        ArrayList<MultiFile> alMultiFile = new ArrayList<>();
        if (requestCode == 10) {
            BlazeFileUploader blazeFileUploader =
                    new BlazeFileUploader(client, BLAZE_BUCKET_ID);
            if (resultCode == Activity.RESULT_OK && data != null) {
                if (data.getClipData() != null) {
                    Log.e("if", "if@112");
                    int count = data.getClipData().getItemCount(); //evaluate the count before the for loop --- otherwise, the count is evaluated every loop.
                    for (int i = 0; i < count; i++) {
                        MultiFile multiFile = new MultiFile();
                        Uri imageUri = data.getClipData().getItemAt(i).getUri();
                        InputStream iStream = null;

                        try {
                            iStream = getContentResolver().openInputStream(imageUri);
                            byte[] inputData = getBytes(iStream);
                            multiFile.init(imageUri, new File(imageUri.getPath()).getAbsolutePath(), FileTypes.IMAGE_TYPE);

                            alMultiFile.add(multiFile);
                        } catch (FileNotFoundException e) {
                            e.printStackTrace();
                        } catch (IOException e) {
                            e.printStackTrace();
                        }
                        //getImageFilePath(imageUri);
                    }
                    if (alMultiFile.size() > 0) {
                        Log.e("arrayList", ">0");
                        blazeFileUploader.startUploadingMultipleFiles(alMultiFile);
                    }
                    for (int i = 0; i < alMultiFile.size(); i++) {
                        Log.e("arrayList", alMultiFile.get(i).getFileUri() + "");
                    }

                } else {
                    Log.e("else", "else@137");
                    InputStream iStream = null;
                    selectedImageURI = data.getData();

                    try {
                        iStream = getContentResolver().openInputStream(data.getData());
                        byte[] inputData = getBytes(iStream);
//                        blazeFileUploader.startUploading(data.getData(), "tradein5.png");
                        getImageName();
//                        blazeFileUploader.startUploading(data.getData(), "" + ConstantsBB.IMAGE_NAME + ".png");
//                        blazeFileUploader.startUploading(data.getData(), "" + ConstantsBB.IMAGE_NAME + ".mp4");
//                        blazeFileUploader.startUploading(data.getData(), "" + ConstantsBB.IMAGE_NAME + ".jpg");
//                        blazeFileUploader.startUploading(data.getData(), "" + ConstantsBB.IMAGE_NAME + "."+ConstantsBB.IMAGE_EXTENSION);
                        ConstantsBB.IMAGE_NAME_EXTENSION = ConstantsBB.IMAGE_NAME + "."+ConstantsBB.IMAGE_EXTENSION;
                        blazeFileUploader.startUploading(data.getData(),  ConstantsBB.IMAGE_NAME + "."+ConstantsBB.IMAGE_EXTENSION);

                    } catch (FileNotFoundException e) {
                        e.printStackTrace();
                    } catch (IOException e) {
                        e.printStackTrace();
                    }
                }

                blazeFileUploader.setOnUploadingListener(new UploadListener() {
                    @Override
                    public void onUploadStarted() {
                        Log.e("onUploadStarted", "onUploadStarted");
                    }

                    @Override
                    public void onUploadProgress(int percentage, long progress, long total) {
//                        Log.e("onUploadProgress", percentage + " - " + progress + " - " + total);
                    }

                    @Override
                    public void onUploadFinished(UploadResponse response, boolean allFilesUploaded) {
                        Log.e("onUploadFinished", "onUploadFinished");
                        Log.e("UploadResponse", response + "");
                        Log.e("getContentSha1", response.getContentSha1() + "");
                        Log.e("allFilesUploaded", allFilesUploaded + "");
                    }

                    @Override
                    public void onUploadFailed(Exception e) {
                        Log.e("onUploadFailed", "onUploadFailed");
                        Log.e("Failed - Exception", e + "");

                    }
                });

            }
        }

    }

    private void getImageName() {
        Calendar cal = Calendar.getInstance();
        ConstantsBB.IMAGE_NAME = cal.getTimeInMillis() + "";
        Log.e("IMAGE_NAME", ConstantsBB.IMAGE_NAME + "");
        Log.e("IMAGE_EXTENSION", ConstantsBB.IMAGE_EXTENSION + "");
        String strFileExtension = getFileExtension(selectedImageURI);
        ConstantsBB.IMAGE_EXTENSION = strFileExtension;
        Log.e("strFilePath2", strFileExtension + "");
    }


    @Override
    public void onRequestPermissionsResult(int requestCode, String permissions[], int[] grantResults) {
        super.onRequestPermissionsResult(requestCode, permissions, grantResults);
        switch (requestCode) {
            case 4:
                if (grantResults.length > 0 && grantResults[0] == PackageManager.PERMISSION_GRANTED) {

                    BlazeClient client = new BlazeClient(this, BLAZE_APP_KEY_ID, BLAZE_APP_KEY);

                    BlazeFileDownloader blazeFileDownloader = new BlazeFileDownloader(client);
                    blazeFileDownloader.startDownloading(BLAZE_BUCKET_NAME, "Beavis-1.png");
//                    blazeFileDownloader.startDownloading(BLAZE_BUCKET_NAME, ConstantsBB.IMAGE_NAME + ".png");
                } else {


                }
                break;
        }
    }


    public void gallery(View view) {
        if (ContextCompat.checkSelfPermission(BlackBlazeActivityV1.this, Manifest.permission.WRITE_EXTERNAL_STORAGE)
                != PackageManager.PERMISSION_GRANTED || ContextCompat.checkSelfPermission(BlackBlazeActivityV1.this, Manifest.permission.READ_EXTERNAL_STORAGE)
                != PackageManager.PERMISSION_GRANTED) {
            ActivityCompat.requestPermissions(
                    this,
                    PERMISSIONS_STORAGE,
                    REQUEST_EXTERNAL_STORAGE
            );
        } else {
            /*Intent intent;
//            intent = new Intent(Intent.ACTION_OPEN_DOCUMENT);
            intent = new Intent(Intent.ACTION_GET_CONTENT);
            intent.putExtra(Intent.EXTRA_ALLOW_MULTIPLE, true);
            intent.addFlags(Intent.FLAG_GRANT_PERSISTABLE_URI_PERMISSION);

//            intent.putExtra(Intent.EXTRA_MIME_TYPES, new String[] {"image/*", "video/*"});
            intent.putExtra(Intent.EXTRA_LOCAL_ONLY, true);
//            intent.setType("image/*");
//            intent.setType("video/*, image/*");
            intent.setType("image/* video/*");
            intent.setAction(Intent.ACTION_GET_CONTENT);
//            startActivityForResult(Intent.createChooser(intent,"Select Picture"), 1);
            startActivityForResult(Intent.createChooser(intent, "Select Picture"), 10);
*/
            Intent mediaChooser = new Intent(Intent.ACTION_PICK, android.provider.MediaStore.Images.Media.EXTERNAL_CONTENT_URI);
            mediaChooser.setType("video/*, image/*");
            mediaChooser.putExtra(Intent.EXTRA_ALLOW_MULTIPLE, true);
            startActivityForResult(mediaChooser, 10);
        }
    }
}
// extension
/*try {
            String strFilePath = getPath(this,selectedImageURI);
            Log.e("strFilePath", strFilePath+"");
            int index = strFilePath.lastIndexOf('.');
            String strFileExtension = strFilePath.substring(index + 1);
            Log.e("strFileExtension", strFileExtension+"");
//            Uri file = Uri.fromFile(new File(filePath));
            String fileExt = MimeTypeMap.getFileExtensionFromUrl(selectedImageURI.toString());
            Log.e("fileExt", fileExt+"");
        } catch (URISyntaxException e) {
            e.printStackTrace();
        }*/

