package com.concatsys.tradein.tradein_plugin.activity;

import android.content.Intent;
import android.os.Bundle;
import android.view.View;
import android.view.WindowManager;
import android.widget.EditText;
import android.widget.TextView;

import com.concatsys.tradein.tradein_plugin.R;
import com.concatsys.tradein.tradein_plugin.api.ApiService;
import com.concatsys.tradein.tradein_plugin.api.ConstantsApi;
import com.concatsys.tradein.tradein_plugin.logs.LoggerTradeIn;

public class ContactUsActivity extends BaseActivity implements View.OnClickListener {
    private String TAG = getClass().getSimpleName();

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        ConstantsActivity.ACTIVITY_TITLES = getString(R.string.contact_us);
        super.setLayout(R.layout.activity_contact_us);
        super.onCreate(savedInstanceState);
        initUI();
    }

    private EditText etContactUsName, etContactUsEmail, etContactUsMessage;
    private TextView tvContactUsSubmit;

    /* Initialize UI */
    private void initUI() {
        etContactUsName = findViewById(R.id.et_contact_us_name);
        etContactUsEmail = findViewById(R.id.et_contact_us_email);
        etContactUsMessage = findViewById(R.id.et_contact_us_message);
        tvContactUsSubmit = findViewById(R.id.tv_contact_us_submit);
        tvContactUsSubmit.setOnClickListener(this);

        this.getWindow().setSoftInputMode(WindowManager.LayoutParams.SOFT_INPUT_STATE_HIDDEN);
    }

    /* On Click  */
    @Override
    public void onClick(View v) {
        LoggerTradeIn.e(TAG, "View Clicked");
        if (v.getId() == R.id.tv_contact_us_submit) {
            String nameCU = etContactUsName.getText().toString().trim();
            String emailCU = etContactUsEmail.getText().toString().trim();
            String messageCU = etContactUsMessage.getText().toString().trim();

            ConstantsApi.CONTACT_US_NAME = nameCU;
            ConstantsApi.CONTACT_US_EMAIL = emailCU;
            ConstantsApi.CONTACT_US_MESSAGE = messageCU;

            ConstantsApi.CONTACT_US_URL = "SaveContactUs" +
                    "&LEAD_KEY=" + ConstantsApi.LEAD_KEY_UP_URL +
                    "&NAME=" + ConstantsApi.CONTACT_US_NAME +
                    "&EMAIL=" + ConstantsApi.CONTACT_US_EMAIL +
                    "&MESSAGE=" + ConstantsApi.CONTACT_US_MESSAGE;

            ConstantsApi.FLAG_API_NAME = ConstantsApi.FLAG_API_CONTACT_US;
            Intent serviceIntent = new Intent(this, ApiService.class);
            startService(serviceIntent);
            finish();

        }
    }
}
