package com.concatsys.tradein.tradein_plugin.activity;

import android.annotation.SuppressLint;
import android.content.SharedPreferences;
import android.os.Bundle;
import android.view.View;
import android.widget.Button;
import android.widget.CompoundButton;
import android.widget.LinearLayout;
import android.widget.Switch;
import android.widget.TextView;

import androidx.annotation.Nullable;
import androidx.appcompat.app.AppCompatActivity;

import com.concatsys.tradein.tradein_plugin.R;
import com.concatsys.tradein.tradein_plugin.logscapture.LogsCaptureCalls;
import com.concatsys.tradein.tradein_plugin.logscapture.LogsCaptureUtils;

import java.text.SimpleDateFormat;
import java.util.Date;

public class LogsCaptureSettingsActivityV2 extends AppCompatActivity {
    LogsCaptureCalls logsCaptureCalls;
    private Button sendLogsToServer;
    private boolean flagPosition = false;
    String strSize = "";

    private SharedPreferences.Editor edit;
    private SharedPreferences sharedPreferences;

    @Override
    protected void onCreate(@Nullable Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
//        requestWindowFeature(Window.FEATURE_NO_TITLE);
//        getWindow().setFlags(WindowManager.LayoutParams.FLAG_FULLSCREEN, WindowManager.LayoutParams.FLAG_FULLSCREEN);
//        getSupportActionBar().hide();
        setContentView(R.layout.activity_logs_capture);
        sharedPreferences = getSharedPreferences(LogsCaptureUtils.preferencesName, 0);
        edit = sharedPreferences.edit();

        checkboxSetting();

        flagPosition = true;


        logsCaptureCalls = new LogsCaptureCalls();
        logsCaptureCalls.init(this);
        logsCaptureCalls.getPermissionFiles();

    }

    private void checkboxSetting() {
        LinearLayout backLayout = findViewById(R.id.logs_back_layout);
        backLayout.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                finish();
            }
        });

        if (sharedPreferences.getString("LogStartStatus", "").equalsIgnoreCase("Started")) {
            ((Switch) findViewById(R.id.logs_switch)).setChecked(true);
            findViewById(R.id.logInfo_layout).setVisibility(
                    View.VISIBLE);
            ((TextView) findViewById(R.id.logs_tv_start_date)).setText(sharedPreferences
                    .getString("LogStartDate", ""));
            ((TextView) findViewById(R.id.logs_tv_end_date)).setText(sharedPreferences
                    .getString("LogEndDate", ""));
        } else if (sharedPreferences.getString("LogStartStatus", "").equalsIgnoreCase(
                "Completed")) {
            ((Switch) findViewById(R.id.logs_switch)).setChecked(false);
            findViewById(R.id.logInfo_layout).setVisibility(
                    View.VISIBLE);
            ((TextView) findViewById(R.id.logs_tv_start_date)).setText(sharedPreferences.getString("LogStartDate", ""));
            ((TextView) findViewById(R.id.logs_tv_end_date)).setText(sharedPreferences.getString("LogEndDate", ""));
        } else {
            ((Switch) findViewById(R.id.logs_switch)).setChecked(false);
        }

        ((Switch) findViewById(R.id.logs_switch))
                .setOnCheckedChangeListener(new CompoundButton.OnCheckedChangeListener() {

                    @SuppressLint("SimpleDateFormat")
                    @Override
                    public void onCheckedChanged(CompoundButton buttonView,
                                                 boolean isChecked) {

                        logsCaptureCalls.checkFlag(isChecked);
                        if (isChecked) {
                            findViewById(R.id.logInfo_layout)
                                    .setVisibility(View.VISIBLE);
                            ((TextView) findViewById(R.id.logs_tv_start_date))
                                    .setText(sharedPreferences.getString("LogStartDate",
                                            ""));
                            ((TextView) findViewById(R.id.logs_tv_end_date))
                                    .setText(sharedPreferences.getString("LogEndDate",
                                            ""));
                        } else {
                            SimpleDateFormat mDateFormat = new SimpleDateFormat(
                                    "dd MMM yyyy HH:mm:ss");
                            String enddate = mDateFormat.format(new Date());
                            findViewById(R.id.logInfo_layout)
                                    .setVisibility(View.VISIBLE);
                            ((TextView) findViewById(R.id.logs_tv_end_date))
                                    .setText(enddate);
                        }

                    }
                });

        sendLogsToServer = findViewById(R.id.logs_btn_share);
        sendLogsToServer.setOnClickListener(new View.OnClickListener() {

            @Override
            public void onClick(View v) {
                // TODO Auto-generated method stub
                SendLogs(v);
            }
        });
    }

    @SuppressLint("StringFormatInvalid")
    public void SendLogs(View v) {
        logsCaptureCalls.shareLogs();
    }

    @SuppressLint("ApplySharedPref")
    private void onSaveUserPass() {
        SharedPreferences sharedPreferences = getSharedPreferences(LogsCaptureUtils.preferencesName, 0);
        SharedPreferences.Editor editor = sharedPreferences.edit();
        editor.remove("LoginStatus");
        editor.remove("SelectedRooftopID");
        editor.commit();
    }

}