package com.concatsys.tradein.tradein_plugin.activity;

import android.os.Bundle;
import android.view.View;
import android.widget.Toast;

import androidx.annotation.NonNull;
import androidx.recyclerview.widget.ItemTouchHelper;
import androidx.recyclerview.widget.LinearLayoutManager;
import androidx.recyclerview.widget.RecyclerView;

import com.concatsys.tradein.tradein_plugin.R;
import com.concatsys.tradein.tradein_plugin.adapter.DummyDataAdapter;
import com.concatsys.tradein.tradein_plugin.db.ConstantsDB;
import com.concatsys.tradein.tradein_plugin.db.DBOperations;
import com.concatsys.tradein.tradein_plugin.db.DBVehiclesModel;
import com.concatsys.tradein.tradein_plugin.logs.LoggerTradeIn;

public class MessageChatActivity extends BaseActivity implements View.OnClickListener {
    private String TAG = getClass().getSimpleName();
    private RecyclerView rvMyMessageDb;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        ConstantsActivity.ACTIVITY_TITLES = getString(R.string.message);
        super.setLayout(R.layout.activity_message_chat);
        super.onCreate(savedInstanceState);
        initUI();
    }

    /* Initialize UI */
    private void initUI() {
        LoggerTradeIn.e(TAG, "initUI");
        recyclerViewDisplay();
//        initSharedPrefs(ConstantsDB.SHARED_PREFS_SCREEN_KEY, getString(R.string.message));
    }

    /* Initialize Recycler UI */
    private void recyclerViewDisplay() {
        //setting layout manager to our adapter class.
        LoggerTradeIn.e(TAG, "recyclerViewDisplay");
        rvMyMessageDb = findViewById(R.id.rv_message_db);
        rvMyMessageDb.setLayoutManager(new LinearLayoutManager(this));
        rvMyMessageDb.setHasFixedSize(true);
        //initializing for recycler view.
//        final DBMessageAdapter adapterRV = new DBMessageAdapter();
        //setting  class for recycler view.
//        rvMyMessageDb.setAdapter(adapterRV);

        final DummyDataAdapter adapterRV;
        adapterRV = new DummyDataAdapter(this, ConstantsActivity.AL_RADIO_CHECK_OPTIONS, ConstantsActivity.AL_CONDITION_INTERIOR_TWO,R.layout.view_item_message_chat);

        rvMyMessageDb.setAdapter(adapterRV);

        ConstantsDB.listVehiclesModel.clear();
        DBOperations dbOperations = DBOperations.getInstance();
        dbOperations.getMyVehicleSize(this);

//        adapterRV.submitList(ConstantsDB.listVehiclesModel);

       /* adapterRV.setOnItemClickListener(new DBMessageAdapter.OnItemClickListener() {
            @Override
            public void onItemClick(DBVehiclesModel dbModelUpdate) {
                int id = dbModelUpdate.getVehicle_id();
                displayRoom(dbModelUpdate);
            }
        });*/

        //below method is use to add swipe to delete method for item of recycler view.
        new ItemTouchHelper(new ItemTouchHelper.SimpleCallback(0, ItemTouchHelper.LEFT | ItemTouchHelper.RIGHT) {
            @Override
            public boolean onMove(@NonNull RecyclerView recyclerView, @NonNull RecyclerView.ViewHolder viewHolder, @NonNull RecyclerView.ViewHolder target) {
                LoggerTradeIn.e(TAG, " onMove");
                return false;
            }

            @Override
            public void onSwiped(@NonNull RecyclerView.ViewHolder viewHolder, int direction) {
                //on recycler view item swiped then we are deleting the item of our recycler view.
//                deleteRoom(dataBaseAdapter.getValuesInAt(viewHolder.getAdapterPosition()));
            }
        }).attachToRecyclerView(rvMyMessageDb);
    }

    private void displayRoom(DBVehiclesModel DBVehiclesModelDisplay) {
        LoggerTradeIn.e(TAG, "displayRoom");
        String strOne = DBVehiclesModelDisplay.getVehicle_id() + "";
        Toast.makeText(this, "ID - " + strOne, Toast.LENGTH_SHORT).show();
    }

    /* On Click  */
    @Override
    public void onClick(View v) {
        LoggerTradeIn.e(TAG, " Click");
    }
}
