package com.concatsys.tradein.tradein_plugin.activity;

import android.os.Bundle;
import android.view.View;

import androidx.recyclerview.widget.LinearLayoutManager;
import androidx.recyclerview.widget.RecyclerView;

import com.concatsys.tradein.tradein_plugin.R;
import com.concatsys.tradein.tradein_plugin.adapter.DBVehiclesAdapter;
import com.concatsys.tradein.tradein_plugin.api.ConstantsApi;
import com.concatsys.tradein.tradein_plugin.db.ConstantsDB;
import com.concatsys.tradein.tradein_plugin.db.DBOperations;
import com.concatsys.tradein.tradein_plugin.db.DBVehiclesModel;
import com.concatsys.tradein.tradein_plugin.interfaces.ActivityCallBack;
import com.concatsys.tradein.tradein_plugin.logs.LoggerTradeIn;
import com.concatsys.tradein.tradein_plugin.sharedpreference.SharedPreferenceTI;

import java.util.ArrayList;
import java.util.HashMap;

public class MyProfileActivity extends BaseActivity implements View.OnClickListener, ActivityCallBack {
    private String TAG = getClass().getSimpleName();
    private RecyclerView rvMyVehicleDb;
    public static MyProfileActivity myProfileActivity;
    DBOperations dbOperations;
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        ConstantsActivity.ACTIVITY_TITLES = getString(R.string.my_profile);
        super.setLayout(R.layout.activity_my_profile);
        super.onCreate(savedInstanceState);
        myProfileActivity = this;
        dbOperations = DBOperations.getInstance();
//        getDbValues();
        sharedPreferenceTI = SharedPreferenceTI.getInstance();
        initUI();

    }

    private void getDbId(){
        DBOperations dbOperations = DBOperations.getInstance();
        dbOperations.getVehicleId(this);
        dbOperations.getUserId(this);
        dbOperations.getVehicleIdsList(this);
    }

    private void getDbValues(){
        DBOperations dbOperations = DBOperations.getInstance();
        dbOperations.getMyVehicleSize(this);
        LoggerTradeIn.e(TAG, ConstantsDB.listVehiclesModel.size()+" @44");
//        LoggerTradeIn.e(TAG, ConstantsDB.dbVehicleIndex+" @44");
//        ConstantsDB.dbVehicleIndex = ConstantsDB.listVehiclesModel.size();
//        ConstantsApi.alHMMYVEHICLES.get(1).get("year") = ConstantsDB.listVehiclesModel.get(0).getVehicle_year()+"";
//        ConstantsApi.alHMMYVEHICLES = getDbList(ConstantsApi.KEYS_DROP_DOWN_YEARS);
        getDbList(ConstantsApi.KEYS_DROP_DOWN_YEARS);
    }

    public ArrayList<HashMap<String, String>> getDbList(String[] keysDb){
        ArrayList<HashMap<String, String>> contactList = new ArrayList<>();
        HashMap<String, String> hashMapValues= new HashMap<>();
//        hashMapValues.put("","");
        for (int j = 0; j < keysDb.length-1; j++) {
//            String valueResponse = jsonObject.getString(keys[j]);
            hashMapValues.put(keysDb[j], ConstantsDB.listVehiclesModel.get(j).getVehicle_year());
            LoggerTradeIn.e(TAG, ConstantsDB.listVehiclesModel.get(j).getVehicle_year() +" @66");
        }
        return contactList;
    }
    /* Initialize UI */
    private void initUI() {
        LoggerTradeIn.e(TAG, "initUI");
        initSharedPrefs(ConstantsDB.SHARED_PREFS_SCREEN_KEY, getString(R.string.my_vehicle));
        recyclerViewDisplay();
    }

    @Override
    protected void onResume() {
        super.onResume();
        if(ConstantsActivity.flagUpdateEdit){
            ConstantsActivity.flagUpdateEdit = false;
            initSharedPrefs(ConstantsDB.SHARED_PREFS_SCREEN_KEY, getString(R.string.my_vehicle));
            recyclerViewDisplay();
        }
    }

    /* Initialize Recycler UI */
    private void recyclerViewDisplay() {
        //setting layout manager to our adapter class.
        LoggerTradeIn.e(TAG, "recyclerViewDisplay");
        rvMyVehicleDb = findViewById(R.id.rv_my_vehicle_db);
        rvMyVehicleDb.setLayoutManager(new LinearLayoutManager(this));
        rvMyVehicleDb.setHasFixedSize(true);
        //initializing for recycler view.
        final DBVehiclesAdapter DBVehiclesAdapter = new DBVehiclesAdapter();
        rvMyVehicleDb.setAdapter(DBVehiclesAdapter);

        ConstantsDB.listVehiclesModel.clear();
        DBOperations dbOperations = DBOperations.getInstance();
        dbOperations.getMyVehicleSize(this);

        DBVehiclesAdapter.submitList(ConstantsDB.listVehiclesModel);
        DBVehiclesAdapter.setOnItemClickListener(new DBVehiclesAdapter.OnItemClickListener() {
            @Override
            public void onItemClick(DBVehiclesModel dbModelUpdate) {
                int id = dbModelUpdate.getVehicle_id();
                displayRoom(dbModelUpdate);
            }
        });

    }

    private void displayRoom(DBVehiclesModel DBVehiclesModelDisplay) {
        LoggerTradeIn.e(TAG, "displayRoom");
        String strDisplayRoom = DBVehiclesModelDisplay.getVehicle_id() + "";
        LoggerTradeIn.e(TAG, "strDisplayRoom " +strDisplayRoom);
//        Toast.makeText(this, "ID - " + strDisplayRoom, Toast.LENGTH_SHORT).show();
    }

    /* On Click  */
    @Override
    public void onClick(View v) {
        LoggerTradeIn.e(TAG, "Button Click");
    }

    @Override
    public void callActivity(String strResponse) {
        LoggerTradeIn.e(TAG, strResponse + " @120");
        initUI();
    }
}
