package com.concatsys.tradein.tradein_plugin.activity;

import android.content.Intent;
import android.os.Bundle;
import android.view.View;
import android.widget.TextView;

import androidx.recyclerview.widget.LinearLayoutManager;
import androidx.recyclerview.widget.RecyclerView;

import com.concatsys.tradein.tradein_plugin.R;
import com.concatsys.tradein.tradein_plugin.adapter.DBVehiclesAdapter;
import com.concatsys.tradein.tradein_plugin.adapter.MyVehiclesAdapter;
import com.concatsys.tradein.tradein_plugin.api.ApiService;
import com.concatsys.tradein.tradein_plugin.api.ConstantsApi;
import com.concatsys.tradein.tradein_plugin.db.ConstantsDB;
import com.concatsys.tradein.tradein_plugin.db.DBOperations;
import com.concatsys.tradein.tradein_plugin.db.DBVehiclesModel;
import com.concatsys.tradein.tradein_plugin.interfaces.ActivityCallBack;
import com.concatsys.tradein.tradein_plugin.logs.LoggerTradeIn;
import com.concatsys.tradein.tradein_plugin.sharedpreference.SharedPreferenceTI;

import java.util.ArrayList;
import java.util.HashMap;

public class MyVehicleActivityV2 extends BaseActivity implements View.OnClickListener, ActivityCallBack {
    private String TAG = getClass().getSimpleName();
    private RecyclerView rvMyVehicleDb, rvMyVehicleApi;
    private TextView tvMyVehicleAdd;
    public static MyVehicleActivityV2 myVehicleActivity;
    DBOperations dbOperations;
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        ConstantsActivity.ACTIVITY_TITLES = getString(R.string.my_vehicle);
        super.setLayout(R.layout.activity_my_vehicle_v2);
        super.onCreate(savedInstanceState);
        myVehicleActivity = this;
        dbOperations = DBOperations.getInstance();
//        getDbValues();
        sharedPreferenceTI = SharedPreferenceTI.getInstance();
        ConstantsApi.LEAD_KEY_UP_URL = sharedPreferenceTI.getStringValue(this, ConstantsDB.SHARED_PREFS_LEAD_KEY);
//        ConstantsApi.VEHICLE_KEY_UP_URL = sharedPreferenceTI.getStringValue(this, ConstantsDB.SHARED_PREFS_VEHICLE_KEY);
        LoggerTradeIn.e(TAG,ConstantsApi.LEAD_KEY_UP_URL+" @**LKey1");
        LoggerTradeIn.e(TAG,ConstantsApi.VEHICLE_KEY_UP_URL+" @**VKey1");
        if(ConstantsApi.LEAD_KEY_UP_URL.equals(getString(R.string.add_vehicle))){
            ConstantsApi.LEAD_KEY_UP_URL = "";
            initUI();
        }else{
            ConstantsApi.FLAG_API_NAME = ConstantsApi.FLAG_API_GET_ALL_VEHICLE;
            Intent serviceIntent = new Intent(this, ApiService.class);
            startService(serviceIntent);
        }
    }

    private void getDbId(){
        DBOperations dbOperations = DBOperations.getInstance();
        dbOperations.getVehicleId(this);
        dbOperations.getUserId(this);
        dbOperations.getVehicleIdsList(this);
    }

    private void getDbValues(){
        DBOperations dbOperations = DBOperations.getInstance();
        dbOperations.getMyVehicleSize(this);
        LoggerTradeIn.e(TAG, ConstantsDB.listVehiclesModel.size()+" @44");
//        LoggerTradeIn.e(TAG, ConstantsDB.dbVehicleIndex+" @44");
//        ConstantsDB.dbVehicleIndex = ConstantsDB.listVehiclesModel.size();
//        ConstantsApi.alHMMYVEHICLES.get(1).get("year") = ConstantsDB.listVehiclesModel.get(0).getVehicle_year()+"";
//        ConstantsApi.alHMMYVEHICLES = getDbList(ConstantsApi.KEYS_DROP_DOWN_YEARS);
        getDbList(ConstantsApi.KEYS_DROP_DOWN_YEARS);
    }

    public ArrayList<HashMap<String, String>> getDbList(String[] keysDb){
        ArrayList<HashMap<String, String>> contactList = new ArrayList<>();
        HashMap<String, String> hashMapValues= new HashMap<>();
//        hashMapValues.put("","");
        for (int j = 0; j < keysDb.length-1; j++) {
//            String valueResponse = jsonObject.getString(keys[j]);
            hashMapValues.put(keysDb[j], ConstantsDB.listVehiclesModel.get(j).getVehicle_year());
            LoggerTradeIn.e(TAG, ConstantsDB.listVehiclesModel.get(j).getVehicle_year() +" @66");
        }
        return contactList;
    }
    /* Initialize UI */
    private void initUI() {
        LoggerTradeIn.e(TAG, "initUI");
        tvMyVehicleAdd = findViewById(R.id.tv_my_vehicle_add);
        tvMyVehicleAdd.setOnClickListener(this);
        initSharedPrefs(ConstantsDB.SHARED_PREFS_SCREEN_KEY, getString(R.string.my_vehicle));
        recyclerViewDisplay();
    }

    @Override
    protected void onResume() {
        super.onResume();
        if(ConstantsActivity.flagUpdateEdit){
            ConstantsActivity.flagUpdateEdit = false;
            initSharedPrefs(ConstantsDB.SHARED_PREFS_SCREEN_KEY, getString(R.string.my_vehicle));
            recyclerViewDisplay();
        }
    }

    /* Initialize Recycler UI */
    private void recyclerViewDisplay() {
        //setting layout manager to our adapter class.
        LoggerTradeIn.e(TAG, "recyclerViewDisplay");
        rvMyVehicleDb = findViewById(R.id.rv_my_vehicle_db);
        rvMyVehicleDb.setLayoutManager(new LinearLayoutManager(this));
        rvMyVehicleDb.setHasFixedSize(true);
        //initializing for recycler view.
        final DBVehiclesAdapter DBVehiclesAdapter = new DBVehiclesAdapter();
        rvMyVehicleDb.setAdapter(DBVehiclesAdapter);

        rvMyVehicleApi = findViewById(R.id.rv_my_vehicle_api);
        rvMyVehicleApi.setLayoutManager(new LinearLayoutManager(this));
        rvMyVehicleApi.setHasFixedSize(true);

        MyVehiclesAdapter myVehiclesAdapter = new MyVehiclesAdapter(ConstantsApi.alHMMYVEHICLES,this,R.layout.view_item_db_vehicles);
        rvMyVehicleApi.setAdapter(myVehiclesAdapter);

        ConstantsDB.listVehiclesModel.clear();
        DBOperations dbOperations = DBOperations.getInstance();
        dbOperations.getMyVehicleSize(this);

        DBVehiclesAdapter.submitList(ConstantsDB.listVehiclesModel);
        DBVehiclesAdapter.setOnItemClickListener(new DBVehiclesAdapter.OnItemClickListener() {
            @Override
            public void onItemClick(DBVehiclesModel dbModelUpdate) {
                int id = dbModelUpdate.getVehicle_id();
                displayRoom(dbModelUpdate);
            }
        });

        //below method is use to add swipe to delete method for item of recycler view.
        /*new ItemTouchHelper(new ItemTouchHelper.SimpleCallback(0, ItemTouchHelper.LEFT | ItemTouchHelper.RIGHT) {
            @Override
            public boolean onMove(@NonNull RecyclerView recyclerView, @NonNull RecyclerView.ViewHolder viewHolder, @NonNull RecyclerView.ViewHolder target) {
                return false;
            }

            @Override
            public void onSwiped(@NonNull RecyclerView.ViewHolder viewHolder, int direction) {
                //on recycler view item swiped then we are deleting the item of our recycler view.
//                deleteRoom(dataBaseAdapter.getValuesInAt(viewHolder.getAdapterPosition()));
            }
        }).attachToRecyclerView(rvMyVehicleDb);*/
    }

    private void displayRoom(DBVehiclesModel DBVehiclesModelDisplay) {
        LoggerTradeIn.e(TAG, "displayRoom");
        String strDisplayRoom = DBVehiclesModelDisplay.getVehicle_id() + "";
        LoggerTradeIn.e(TAG, "strDisplayRoom " +strDisplayRoom);
//        Toast.makeText(this, "ID - " + strDisplayRoom, Toast.LENGTH_SHORT).show();
    }

    /* On Click  */
    @Override
    public void onClick(View v) {
        LoggerTradeIn.e(TAG, "Button Click");
        if (v.getId() == R.id.tv_my_vehicle_add) {
            LoggerTradeIn.e(TAG, "Add Vehicle Click");
            LoggerTradeIn.e(TAG, ConstantsDB.listVehiclesModel.size()+" @size");
//            ConstantsDB.dbVehicleIndex = ConstantsDB.listVehiclesModel.size() + 1;
            ConstantsDB.dbVehicleIndex = dbOperations.getMyVehicleSize2(this)+1;
//            ConstantsDB.dbVehicleIndex = ConstantsDB.dbVehicleIndex + 1;
//            ConstantsDB.dbVehicleIndex = 5;
//            ConstantsDB.dbUserIndex = ConstantsDB.listVehiclesModel.size() + 1;
            ConstantsDB.dbUserIndex = dbOperations.getMyUserSize2(this)+1;
            ConstantsDB.dbMediaIndex = dbOperations.getMyMediaSize2(this)+1;
//            ConstantsDB.dbUserIndex = ConstantsDB.dbUserIndex + 1;
            LoggerTradeIn.e(TAG, ConstantsDB.dbVehicleIndex+" @vehicle");
            LoggerTradeIn.e(TAG, ConstantsDB.dbUserIndex+" @user");
            LoggerTradeIn.e(TAG, ConstantsDB.dbMediaIndex+" @media");
            Intent intent = new Intent(getApplicationContext(), AddVehicleActivity.class);
            startActivity(intent);
            finish();
        }
    }

    @Override
    public void callActivity(String strResponse) {
        LoggerTradeIn.e(TAG, strResponse + " @120");
        initUI();
    }
}
