package com.concatsys.tradein.tradein_plugin.activity;

import android.content.Intent;
import android.os.Bundle;
import android.view.View;
import android.widget.TextView;

import androidx.recyclerview.widget.LinearLayoutManager;
import androidx.recyclerview.widget.RecyclerView;

import com.concatsys.tradein.tradein_plugin.R;
import com.concatsys.tradein.tradein_plugin.adapter.MyVehiclesAdapter;
import com.concatsys.tradein.tradein_plugin.api.ApiService;
import com.concatsys.tradein.tradein_plugin.api.ConstantsApi;
import com.concatsys.tradein.tradein_plugin.db.ConstantsDB;
import com.concatsys.tradein.tradein_plugin.db.DBOperations;
import com.concatsys.tradein.tradein_plugin.interfaces.ActivityCallBack;
import com.concatsys.tradein.tradein_plugin.logs.LoggerTradeIn;
import com.concatsys.tradein.tradein_plugin.sharedpreference.SharedPreferenceTI;

public class MyVehicleActivityV3  extends BaseActivity implements View.OnClickListener, ActivityCallBack {
    private String TAG = getClass().getSimpleName();
    private RecyclerView rvMyVehicleApi;
    private TextView tvMyVehicleAdd;
    public static MyVehicleActivityV3 myVehicleActivity;
    DBOperations dbOperations;
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        ConstantsActivity.ACTIVITY_TITLES = getString(R.string.my_vehicle);
        super.setLayout(R.layout.activity_my_vehicle);
        super.onCreate(savedInstanceState);

        /*ConstantsApi.FLAG_API_NAME = ConstantsApi.FLAG_API_GET_USER;
        Intent serviceIntent = new Intent(this, ApiService.class);
        startService(serviceIntent);*/

        myVehicleActivity = this;
        dbOperations = DBOperations.getInstance();
        sharedPreferenceTI = SharedPreferenceTI.getInstance();
        ConstantsApi.LEAD_KEY_UP_URL = sharedPreferenceTI.getStringValue(this, ConstantsDB.SHARED_PREFS_LEAD_KEY);
//        ConstantsApi.VEHICLE_KEY_UP_URL = sharedPreferenceTI.getStringValue(this, ConstantsDB.SHARED_PREFS_VEHICLE_KEY);
        LoggerTradeIn.e(TAG,ConstantsApi.LEAD_KEY_UP_URL+" @**LKey1");
//        LoggerTradeIn.e(TAG,ConstantsApi.VEHICLE_KEY_UP_URL+" @**VKey1");
        if(ConstantsApi.LEAD_KEY_UP_URL.equals(getString(R.string.add_vehicle))){
            ConstantsApi.LEAD_KEY_UP_URL = "";
            initUI();
        }else{
            ConstantsApi.FLAG_API_NAME = ConstantsApi.FLAG_API_GET_ALL_VEHICLE;
            Intent serviceIntent = new Intent(this, ApiService.class);
            startService(serviceIntent);
        }
    }

    /* Initialize UI */
    private void initUI() {
        LoggerTradeIn.e(TAG, "initUI");
        tvMyVehicleAdd = findViewById(R.id.tv_my_vehicle_add);
        tvMyVehicleAdd.setOnClickListener(this);
        initSharedPrefs(ConstantsDB.SHARED_PREFS_SCREEN_KEY, getString(R.string.my_vehicle));
        recyclerViewDisplay();
    }

    @Override
    protected void onResume() {
        super.onResume();
        if(ConstantsActivity.flagUpdateEdit){
            ConstantsActivity.flagUpdateEdit = false;
            initSharedPrefs(ConstantsDB.SHARED_PREFS_SCREEN_KEY, getString(R.string.my_vehicle));
            recyclerViewDisplay();
        }
    }

    /* Initialize Recycler UI */
    private void recyclerViewDisplay() {
        //setting layout manager to our adapter class.
        LoggerTradeIn.e(TAG, "recyclerViewDisplay");

        rvMyVehicleApi = findViewById(R.id.rv_my_vehicle_api);
        rvMyVehicleApi.setLayoutManager(new LinearLayoutManager(this));
        rvMyVehicleApi.setHasFixedSize(true);

        MyVehiclesAdapter myVehiclesAdapter = new MyVehiclesAdapter(ConstantsApi.alHMMYVEHICLES,this,R.layout.view_item_db_vehicles);
        rvMyVehicleApi.setAdapter(myVehiclesAdapter);

        ConstantsDB.listVehiclesModel.clear();
        DBOperations dbOperations = DBOperations.getInstance();
        dbOperations.getMyVehicleSize(this);

    }

    /* On Click  */
    @Override
    public void onClick(View v) {
        LoggerTradeIn.e(TAG, "Button Click");
        if (v.getId() == R.id.tv_my_vehicle_add) {
            LoggerTradeIn.e(TAG, "Add Vehicle Click");
            LoggerTradeIn.e(TAG, ConstantsDB.listVehiclesModel.size()+" @size");
//            ConstantsDB.dbVehicleIndex = ConstantsDB.listVehiclesModel.size() + 1;
//            ConstantsDB.dbVehicleIndex = ConstantsDB.dbVehicleIndex + 1;
//            ConstantsDB.dbVehicleIndex = 5;
//            ConstantsDB.dbUserIndex = ConstantsDB.listVehiclesModel.size() + 1;
            ConstantsDB.dbVehicleIndex = dbOperations.getMyVehicleSize2(this)+1;
            ConstantsDB.dbUserIndex = dbOperations.getMyUserSize2(this)+1;
            ConstantsDB.dbMediaIndex = dbOperations.getMyMediaSize2(this)+1;
//            ConstantsDB.dbUserIndex = ConstantsDB.dbUserIndex + 1;
            LoggerTradeIn.e(TAG, ConstantsDB.dbVehicleIndex+" @vehicle");
            LoggerTradeIn.e(TAG, ConstantsDB.dbUserIndex+" @user");
            LoggerTradeIn.e(TAG, ConstantsDB.dbMediaIndex+" @media");
            Intent intent = new Intent(getApplicationContext(), AddVehicleActivity.class);
            startActivity(intent);
            finish();
        }
    }

    @Override
    public void callActivity(String strResponse) {
        LoggerTradeIn.e(TAG, strResponse + " @120");
        if(ConstantsApi.FLAG_API_NAME.equals(ConstantsApi.FLAG_API_GET_ALL_VEHICLE)){
            initUI();
        }
    }
}

