package com.concatsys.tradein.tradein_plugin.activity;

import android.content.Intent;
import android.os.Bundle;
import android.view.View;
import android.widget.Toast;

import androidx.annotation.NonNull;
import androidx.recyclerview.widget.ItemTouchHelper;
import androidx.recyclerview.widget.LinearLayoutManager;
import androidx.recyclerview.widget.RecyclerView;

import com.concatsys.tradein.tradein_plugin.R;
import com.concatsys.tradein.tradein_plugin.adapter.ApiCallsAdapter;
import com.concatsys.tradein.tradein_plugin.api.ApiService;
import com.concatsys.tradein.tradein_plugin.api.ConstantsApi;
import com.concatsys.tradein.tradein_plugin.db.ConstantsDB;
import com.concatsys.tradein.tradein_plugin.db.DBOperations;
import com.concatsys.tradein.tradein_plugin.db.DBVehiclesModel;
import com.concatsys.tradein.tradein_plugin.interfaces.ActivityCallBack;
import com.concatsys.tradein.tradein_plugin.logs.LoggerTradeIn;

public class OffersActivity extends BaseActivity implements View.OnClickListener, ActivityCallBack{
    private String TAG = getClass().getSimpleName();
    private RecyclerView rvMyOffersDb;
    public static OffersActivity offersActivity;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        ConstantsActivity.ACTIVITY_TITLES = getString(R.string.offers);
        super.setLayout(R.layout.activity_offers);
        super.onCreate(savedInstanceState);
        offersActivity = this;
        ConstantsApi.FLAG_API_NAME = ConstantsApi.FLAG_API_OFFERS;
        Intent serviceIntent = new Intent(this, ApiService.class);
        startService(serviceIntent);

    }

    /* Initialize UI */
    private void initUI() {
        LoggerTradeIn.e(TAG, "initUI");
        recyclerViewDisplay();
//        initSharedPrefs(ConstantsDB.SHARED_PREFS_SCREEN_KEY, getString(R.string.offers));
    }

    /* Initialize Recycler UI */
    private void recyclerViewDisplay() {
        //setting layout manager to our adapter class.
        LoggerTradeIn.e(TAG, "recyclerViewDisplay");
        rvMyOffersDb = findViewById(R.id.rv_offers_db);
        rvMyOffersDb.setLayoutManager(new LinearLayoutManager(this));
        rvMyOffersDb.setHasFixedSize(true);
        //initializing for recycler view.
//        final DBOffersAdapter adapterRV = new DBOffersAdapter();
        //setting  class for recycler view.
//        rvMyOffersDb.setAdapter(adapterRV);

       /* final DummyDataAdapter adapterRV;
        adapterRV = new DummyDataAdapter(this, ConstantsActivity.AL_RADIO_CHECK_OPTIONS, ConstantsActivity.AL_CONDITION_INTERIOR_TWO,R.layout.view_item_offers);
        rvMyOffersDb.setAdapter(adapterRV);*/

        ApiCallsAdapter apiCallsAdapter = new ApiCallsAdapter(ConstantsApi.alHMOffers,this,R.layout.view_item_offers);
        rvMyOffersDb.setAdapter(apiCallsAdapter);

        ConstantsDB.listVehiclesModel.clear();
        DBOperations dbOperations = DBOperations.getInstance();
        dbOperations.getMyVehicleSize(this);
        /*adapterRV.submitList(ConstantsDB.listVehiclesModel);

        adapterRV.setOnItemClickListener(new DBOffersAdapter.OnItemClickListener() {
            @Override
            public void onItemClick(DBVehiclesModel dbModelUpdate) {
                int id = dbModelUpdate.getVehicle_id();
                displayRoom(dbModelUpdate);
            }
        });*/

        //below method is use to add swipe to delete method for item of recycler view.
        new ItemTouchHelper(new ItemTouchHelper.SimpleCallback(0, ItemTouchHelper.LEFT | ItemTouchHelper.RIGHT) {
            @Override
            public boolean onMove(@NonNull RecyclerView recyclerView, @NonNull RecyclerView.ViewHolder viewHolder, @NonNull RecyclerView.ViewHolder target) {
                return false;
            }

            @Override
            public void onSwiped(@NonNull RecyclerView.ViewHolder viewHolder, int direction) {
                //on recycler view item swiped then we are deleting the item of our recycler view.
//                deleteRoom(dataBaseAdapter.getValuesInAt(viewHolder.getAdapterPosition()));
            }
        }).attachToRecyclerView(rvMyOffersDb);
    }

    private void displayRoom(DBVehiclesModel DBVehiclesModelDisplay) {
        LoggerTradeIn.e(TAG, "displayRoom");
        String strOne = DBVehiclesModelDisplay.getVehicle_id() + "";
        Toast.makeText(this, "ID - " + strOne, Toast.LENGTH_SHORT).show();
    }

    /* On Click  */
    @Override
    public void onClick(View v) {
        LoggerTradeIn.e(TAG, " Click");
    }

    @Override
    public void callActivity(String strResponse) {
        LoggerTradeIn.e(TAG, strResponse + " @109");
        initUI();
    }
}