package com.concatsys.tradein.tradein_plugin.activity;

import android.content.Intent;
import android.os.Bundle;
import android.view.View;
import android.widget.ImageView;
import android.widget.LinearLayout;

import com.concatsys.tradein.tradein_plugin.R;
import com.concatsys.tradein.tradein_plugin.api.ConstantsApi;
import com.concatsys.tradein.tradein_plugin.db.ConstantsDB;
import com.concatsys.tradein.tradein_plugin.db.DBOperations;
import com.concatsys.tradein.tradein_plugin.logs.LoggerTradeIn;

public class ProfileStatusActivity extends BaseActivity implements View.OnClickListener {
    private String TAG = getClass().getSimpleName();
    private ImageView ivProfileStatus1, ivProfileStatus2, ivProfileStatus3, ivProfileStatus4, ivProfileStatus5, ivProfileStatus6;
    private View viewProfileStatus1, viewProfileStatus2, viewProfileStatus3, viewProfileStatus4, viewProfileStatus5;
    private LinearLayout lytProfileStatus1, lytProfileStatus2, lytProfileStatus3, lytProfileStatus4, lytProfileStatus5, lytProfileStatus6;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        ConstantsActivity.ACTIVITY_TITLES = getString(R.string.profile);
        super.setLayout(R.layout.activity_profile_track);
        super.onCreate(savedInstanceState);
        initUI();
    }

    /* Initialize UI */
    private void initUI() {
        LoggerTradeIn.e(TAG, "initUI");
        ivProfileStatus1 = findViewById(R.id.iv_profile_status_1);
        ivProfileStatus2 = findViewById(R.id.iv_profile_status_2);
        ivProfileStatus3 = findViewById(R.id.iv_profile_status_3);
        ivProfileStatus4 = findViewById(R.id.iv_profile_status_4);
        ivProfileStatus5 = findViewById(R.id.iv_profile_status_5);
        ivProfileStatus6 = findViewById(R.id.iv_profile_status_6);

        lytProfileStatus1 = findViewById(R.id.lyt_profile_status_1);
        lytProfileStatus2 = findViewById(R.id.lyt_profile_status_2);
        lytProfileStatus3 = findViewById(R.id.lyt_profile_status_3);
        lytProfileStatus4 = findViewById(R.id.lyt_profile_status_4);
        lytProfileStatus5 = findViewById(R.id.lyt_profile_status_5);
        lytProfileStatus6 = findViewById(R.id.lyt_profile_status_6);

        viewProfileStatus1 = findViewById(R.id.view_profile_status_1);
        viewProfileStatus2 = findViewById(R.id.view_profile_status_2);
        viewProfileStatus3 = findViewById(R.id.view_profile_status_3);
        viewProfileStatus4 = findViewById(R.id.view_profile_status_4);
        viewProfileStatus5 = findViewById(R.id.view_profile_status_5);

        lytProfileStatus1.setOnClickListener(this);
        lytProfileStatus2.setOnClickListener(this);
        lytProfileStatus3.setOnClickListener(this);
        lytProfileStatus4.setOnClickListener(this);
        lytProfileStatus5.setOnClickListener(this);
        lytProfileStatus6.setOnClickListener(this);

        setUIValues();
        if (ConstantsActivity.ACTIVITY_UPDATE_FLAG.equals(ConstantsActivity.ACTIVITY_UPDATE_FLAG_DB)) {
            dbValues();
        }
    }

    private void setUIValues() {
        LoggerTradeIn.e(TAG, "setUIValues");
        ivProfileStatus1.setImageResource(R.drawable.ic_step_1_gray);
        ivProfileStatus1.setBackgroundResource(R.drawable.bg_ring_gray);
        viewProfileStatus1.setBackgroundColor(getColor(R.color.common_gray_color));

        setStatusLayouts(1);
    }

    private void setStatusLayouts(int flagUIColors) {
        LoggerTradeIn.e(TAG, "setStatusLayouts");
        for (int i = 1; i <= flagUIColors; i++) {
            if (i == 1) {
                ivProfileStatus1.setImageResource(R.drawable.ic_step_1_blue);
                ivProfileStatus1.setBackgroundResource(R.drawable.bg_ring_blue);
                viewProfileStatus1.setBackgroundColor(getColor(R.color.app_theme_color));
            } else if (i == 2) {
                ivProfileStatus2.setImageResource(R.drawable.ic_step_2_blue);
                ivProfileStatus2.setBackgroundResource(R.drawable.bg_ring_blue);
                viewProfileStatus2.setBackgroundColor(getColor(R.color.app_theme_color));
            } else if (i == 3) {
                ivProfileStatus3.setImageResource(R.drawable.ic_step_3_blue);
                ivProfileStatus3.setBackgroundResource(R.drawable.bg_ring_blue);
                viewProfileStatus3.setBackgroundColor(getColor(R.color.app_theme_color));
            } else if (i == 4) {
                ivProfileStatus4.setImageResource(R.drawable.ic_step_4_blue);
                ivProfileStatus4.setBackgroundResource(R.drawable.bg_ring_blue);
                viewProfileStatus4.setBackgroundColor(getColor(R.color.app_theme_color));
            } else if (i == 5) {
                ivProfileStatus5.setImageResource(R.drawable.ic_step_5_blue);
                ivProfileStatus5.setBackgroundResource(R.drawable.bg_ring_blue);
                viewProfileStatus5.setBackgroundColor(getColor(R.color.app_theme_color));
            } else if (i == 6) {
                ivProfileStatus6.setImageResource(R.drawable.ic_step_6_blue);
                ivProfileStatus6.setBackgroundResource(R.drawable.bg_ring_blue);
//                viewProfileStatus6.setBackgroundColor(getColor(R.color.app_theme_color));
            }
        }

    }

    /* On Click  */
    @Override
    public void onClick(View v) {
        LoggerTradeIn.e(TAG, "Button Click");
        if (v.getId() == R.id.lyt_profile_status_1) {
            LoggerTradeIn.e(TAG, "Step1 Click");
            profileEdit(VehicleInfoOneActivity.class);
        } else if (v.getId() == R.id.lyt_profile_status_2) {
            LoggerTradeIn.e(TAG, "Step2 Click");
            profileEdit(VehicleOptionsActivity.class);
        } else if (v.getId() == R.id.lyt_profile_status_3) {
            LoggerTradeIn.e(TAG, "Step3 Click");
            profileEdit(VehicleConditionActivity.class);
        } else if (v.getId() == R.id.lyt_profile_status_4) {
            LoggerTradeIn.e(TAG, "Step4 Click");
            profileEdit(VehicleMediaActivity.class);
        } else if (v.getId() == R.id.lyt_profile_status_5) {
            LoggerTradeIn.e(TAG, "Step5 Click");
            profileEdit(UserProfileActivity.class);
        } else if (v.getId() == R.id.lyt_profile_status_6) {
            LoggerTradeIn.e(TAG, "Step6 Click");
            profileEdit(SummaryActivity.class);
        }
    }

    /* Db Values INIT */
    private void dbValues() {
        LoggerTradeIn.e(TAG, "dbValues");
//        ConstantsActivity.ACTIVITY_UPDATE_FLAG = ConstantsActivity.ACTIVITY_UPDATE_FLAG_DB;
        ConstantsActivity.alVMGridStr.clear();
        ConstantsActivity.alVMGridUri.clear();
        ConstantsActivity.hmDBVehicles.clear();
        ConstantsActivity.hmUsers.clear();

        LoggerTradeIn.e(TAG, "dbVehicleIndex = " + ConstantsDB.dbVehicleIndex);
        DBOperations dbOperations = DBOperations.getInstance();
        dbOperations.getVehicleMediaValues(this);
        dbOperations.getVehicleValues(this);
        dbOperations.getUserValues(this);
//        setDBValuesToUI();

        ConstantsActivity.STR_VI_YEAR = ConstantsActivity.hmDBVehicles.get(ConstantsApi.KEYS_VEHICLE_ONE_ARRAY[4]) + "";
        ConstantsActivity.STR_VI_MAKE = ConstantsActivity.hmDBVehicles.get(ConstantsApi.KEYS_VEHICLE_ONE_ARRAY[5]) + "";
        ConstantsActivity.STR_VI_MAKE_NAME = ConstantsActivity.hmDBVehicles.get(ConstantsApi.KEYS_VEHICLE_ONE_ARRAY[27]) + "";
        ConstantsActivity.STR_VI_MODEL = ConstantsActivity.hmDBVehicles.get(ConstantsApi.KEYS_VEHICLE_ONE_ARRAY[6]) + "";
        ConstantsActivity.STR_VI_MODEL_NAME = ConstantsActivity.hmDBVehicles.get(ConstantsApi.KEYS_VEHICLE_ONE_ARRAY[26]) + "";
        ConstantsActivity.STR_VI_TRIM = ConstantsActivity.hmDBVehicles.get(ConstantsApi.KEYS_VEHICLE_ONE_ARRAY[7]) + "";
        ConstantsActivity.STR_VI_MILEAGE = ConstantsActivity.hmDBVehicles.get(ConstantsApi.KEYS_VEHICLE_ONE_ARRAY[8]) + "";
        ConstantsActivity.STR_VI_VIN = ConstantsActivity.hmDBVehicles.get(ConstantsApi.KEYS_VEHICLE_ONE_ARRAY[9]) + "";
        ConstantsActivity.STR_VI_EXTERIOR_COLOR = ConstantsActivity.hmDBVehicles.get(ConstantsApi.KEYS_VEHICLE_ONE_ARRAY[10]) + "";

        ConstantsActivity.STR_VI_INTERIOR_COLOR = ConstantsActivity.hmDBVehicles.get(ConstantsApi.KEYS_VEHICLE_ONE_ARRAY[11]) + "";
        ConstantsActivity.STR_VI_TRANSMISSION = ConstantsActivity.hmDBVehicles.get(ConstantsApi.KEYS_VEHICLE_ONE_ARRAY[12]) + "";
        ConstantsActivity.STR_VI_DRIVETRAIN = ConstantsActivity.hmDBVehicles.get(ConstantsApi.KEYS_VEHICLE_ONE_ARRAY[13]) + "";
        ConstantsActivity.STR_VI_BODY_STYLE = ConstantsActivity.hmDBVehicles.get(ConstantsApi.KEYS_VEHICLE_ONE_ARRAY[14]) + "";
        ConstantsActivity.STR_VI_ENGINE = ConstantsActivity.hmDBVehicles.get(ConstantsApi.KEYS_VEHICLE_ONE_ARRAY[15]) + "";
        ConstantsActivity.STR_VI_SEAT_TYPE = ConstantsActivity.hmDBVehicles.get(ConstantsApi.KEYS_VEHICLE_ONE_ARRAY[16]) + "";

        String strOptionsDB, strOptionsNames, strOptionsIDS;
        strOptionsDB = ConstantsActivity.hmDBVehicles.get("vehicle_options") + "";
        LoggerTradeIn.e(TAG, strOptionsDB + " @163");
        if (ConstantsActivity.hmDBVehicles.size() > 0) {
            String[] strOptionsArray = strOptionsDB.split("--");
            if (strOptionsArray.length > 1) {
//        ConstantsActivity.STR_VO_VEHICLE_OPTIONS = ConstantsActivity.hmDBVehicles.get(ConstantsApi.KEYS_VEHICLE_ONE_ARRAY[4])+"";
                ConstantsActivity.STR_VO_VEHICLE_OPTIONS_IDS = strOptionsArray[1] + "";
//        ConstantsActivity.STR_VO_VEHICLE_OPTIONS_NAMES = ConstantsActivity.hmDBVehicles.get("vehicle_options")+"";
                ConstantsActivity.STR_VO_VEHICLE_OPTIONS_NAMES = strOptionsArray[0] + "";
                LoggerTradeIn.e(TAG, ConstantsActivity.STR_VO_VEHICLE_OPTIONS_IDS + " @163");
                LoggerTradeIn.e(TAG, ConstantsActivity.STR_VO_VEHICLE_OPTIONS_NAMES + " @163");
            }
        }
        ConstantsActivity.STR_VO_PACKAGES = ConstantsActivity.hmDBVehicles.get(ConstantsApi.KEYS_VEHICLE_ONE_ARRAY[17]) + "";

        ConstantsActivity.STR_VC_INTERIOR_CONDITIONS = ConstantsActivity.hmDBVehicles.get(ConstantsApi.KEYS_VEHICLE_ONE_ARRAY[18]) + "";
        ConstantsActivity.STR_VC_EXTERIOR_CONDITIONS = ConstantsActivity.hmDBVehicles.get(ConstantsApi.KEYS_VEHICLE_ONE_ARRAY[19]) + "";
        ConstantsActivity.STR_VC_SMOKED = ConstantsActivity.hmDBVehicles.get(ConstantsApi.KEYS_VEHICLE_ONE_ARRAY[20]) + "";
        ConstantsActivity.STR_VC_ACCIDENT = ConstantsActivity.hmDBVehicles.get(ConstantsApi.KEYS_VEHICLE_ONE_ARRAY[21]) + "";
        ConstantsActivity.STR_VC_COMMENT = ConstantsActivity.hmDBVehicles.get(ConstantsApi.KEYS_VEHICLE_ONE_ARRAY[28]) + "";

        ConstantsActivity.STR_VM_MEDIA_URLS = ConstantsActivity.hmDBVehicles.get(ConstantsApi.KEYS_VEHICLE_ONE_ARRAY[4]) + "";

        ConstantsActivity.STR_UP_FIRST_NAME = ConstantsActivity.hmUsers.get(ConstantsApi.KEYS_VEHICLE_ONE_USER_ARRAY[1]) + "";
        ConstantsActivity.STR_UP_LAST_NAME = ConstantsActivity.hmUsers.get(ConstantsApi.KEYS_VEHICLE_ONE_USER_ARRAY[2]) + "";
        ConstantsActivity.STR_UP_EMAIL = ConstantsActivity.hmUsers.get(ConstantsApi.KEYS_VEHICLE_ONE_USER_ARRAY[3]) + "";
        ConstantsActivity.STR_UP_PHONE = ConstantsActivity.hmUsers.get(ConstantsApi.KEYS_VEHICLE_ONE_USER_ARRAY[4]) + "";
        ConstantsActivity.STR_UP_ZIP = ConstantsActivity.hmUsers.get(ConstantsApi.KEYS_VEHICLE_ONE_USER_ARRAY[5]) + "";

    }

    /* Common Intent  */
    private void profileEdit(Class editScreen) {
        LoggerTradeIn.e(TAG, "profileEdit");
        ConstantsActivity.flagUpdateEdit = true;
        Intent intent = new Intent(this, editScreen);
        startActivity(intent);
        finish();
    }
}
