package com.concatsys.tradein.tradein_plugin.activity;

import android.app.Activity;
import android.content.Context;
import android.content.Intent;
import android.os.Bundle;
import android.view.View;
import android.widget.Button;

import androidx.recyclerview.widget.LinearLayoutManager;
import androidx.recyclerview.widget.RecyclerView;

import com.concatsys.tradein.tradein_plugin.R;
import com.concatsys.tradein.tradein_plugin.adapter.RadioCustomAdapter;
import com.concatsys.tradein.tradein_plugin.dialogsandviews.ToastCustomize;
import com.concatsys.tradein.tradein_plugin.logs.LoggerTradeIn;

import java.util.ArrayList;
import java.util.HashMap;

public class RadioCustomActivity extends BaseActivity implements View.OnClickListener {
    private String TAG = getClass().getSimpleName();
    private Context mContext;
    private RadioCustomAdapter radioCustomAdapter;
    private int selectedRadioButton;
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.setLayout(R.layout.activity_radio_custom);
        super.onCreate(savedInstanceState);
        Intent intent = getIntent();
//        ConstantsActivity.AL_RADIO_CHECK_OPTIONS = intent.getStringArrayListExtra(ConstantsActivity.SELECT_OPTION_PASS);
        ConstantsActivity.AL_NEW_RADIO_CHECK_OPTIONS = (ArrayList<HashMap<String, String>>) intent.getSerializableExtra(ConstantsActivity.SELECT_OPTION_PASS);
        mContext = this;
        initUI();
        populateCustomRadioRecyclerView();
    }

    private void initUI() {
        LoggerTradeIn.e(TAG, "initUI");
        Button btnCustomRadioSave = findViewById(R.id.btn_custom_radio_save);
        btnCustomRadioSave.setOnClickListener(this);
    }

    private void populateCustomRadioRecyclerView() {
        LoggerTradeIn.e(TAG, "populateCustomRadioRecyclerView");
        flagRadio = false;
        if (ConstantsActivity.STR_RADIO_VALUE.length() > 0) {
            getRadioIndex();
        }
        RecyclerView customRadioRecyclerView = findViewById(R.id.rv_custom_radio);
        customRadioRecyclerView.setHasFixedSize(true);
        LinearLayoutManager linearLayoutManager = new LinearLayoutManager(mContext);
        customRadioRecyclerView.setLayoutManager(linearLayoutManager);
        radioCustomAdapter = new RadioCustomAdapter(mContext, ConstantsActivity.AL_NEW_RADIO_CHECK_OPTIONS, ConstantsActivity.AL_CONDITION_INTERIOR_TWO);
        customRadioRecyclerView.setAdapter(radioCustomAdapter);
    }
    public static int radioPosition = 0;
    public static boolean flagRadio = false;
    private int getRadioIndex() {
        flagRadio = true;
        ArrayList<String> indexData = new ArrayList<>();
        for (int i = 0; i < ConstantsActivity.AL_NEW_RADIO_CHECK_OPTIONS.size(); i++) {
            indexData.add(ConstantsActivity.AL_NEW_RADIO_CHECK_OPTIONS.get(i).get(ConstantsActivity.SELECT_OPTION_PASS));
        }
//        radioPosition = indexData.indexOf(ConstantsActivity.STR_VI_YEAR);
        radioPosition = indexData.indexOf(ConstantsActivity.STR_RADIO_VALUE);
        LoggerTradeIn.e(TAG, "radioPosition = " + radioPosition + "");
        return radioPosition;
    }
    @Override
    public void onClick(View v) {
        LoggerTradeIn.e(TAG, "onClick");
        if (v.getId() == R.id.btn_custom_radio_save) {
            LoggerTradeIn.e(TAG, "Save");
            selectedRadioButton = radioCustomAdapter.getSelectedItem().length();
            if (selectedRadioButton < 1) {
                ToastCustomize.displayToast(getApplicationContext(), getString(R.string.select_option));
                return;
            }
//        adapter.getSelectedItem()
//        adapter.deleteSelectedPosition();
            Intent returnIntent = new Intent();
//        returnIntent.putExtra(ConstantsActivity.SELECT_OPTION_PASS, ConstantsActivity.AL_RADIO_OPTIONS.get(selectedRadioButton));
//        returnIntent.putExtra(ConstantsActivity.SELECT_OPTION_PASS, alRadioOptionsReturn.get(selectedRadioButton));
            returnIntent.putExtra(ConstantsActivity.SELECT_OPTION_PASS, radioCustomAdapter.getSelectedItem());
            setResult(Activity.RESULT_OK, returnIntent);
            finish();
        }
    }
}
