package com.concatsys.tradein.tradein_plugin.activity;

import android.content.Intent;
import android.os.Bundle;
import android.view.View;
import android.widget.ImageView;
import android.widget.TextView;

import com.concatsys.tradein.tradein_plugin.backblaze.fileuploader.ConstantsBB;
import com.bumptech.glide.Glide;
import com.bumptech.glide.request.RequestOptions;
import com.concatsys.tradein.tradein_plugin.R;
import com.concatsys.tradein.tradein_plugin.api.ApiService;
import com.concatsys.tradein.tradein_plugin.api.ConstantsApi;
import com.concatsys.tradein.tradein_plugin.db.ConstantsDB;
import com.concatsys.tradein.tradein_plugin.db.DBOperations;
import com.concatsys.tradein.tradein_plugin.dialogsandviews.ConstantsDialog;
import com.concatsys.tradein.tradein_plugin.dialogsandviews.DialogCustomize;
import com.concatsys.tradein.tradein_plugin.interfaces.ActivityCallBack;
import com.concatsys.tradein.tradein_plugin.interfaces.DialogCallBack;
import com.concatsys.tradein.tradein_plugin.logs.LoggerTradeIn;
import com.concatsys.tradein.tradein_plugin.sharedpreference.SharedPreferenceTI;

public class SummaryActivity extends BaseActivity implements View.OnClickListener, DialogCallBack, ActivityCallBack {
    private String TAG = getClass().getSimpleName();
    public static SummaryActivity summaryActivity;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        ConstantsActivity.ACTIVITY_TITLES = getString(R.string.summary);
        super.setLayout(R.layout.activity_summary);
        super.onCreate(savedInstanceState);
        summaryActivity = this;
        sharedPreferenceTI = SharedPreferenceTI.getInstance();
        ConstantsApi.LEAD_KEY_UP_URL = sharedPreferenceTI.getStringValue(this, ConstantsDB.SHARED_PREFS_LEAD_KEY);
        LoggerTradeIn.e(TAG, ConstantsApi.LEAD_KEY_UP_URL + " @35");
        LoggerTradeIn.e(TAG, ConstantsApi.LEAD_KEY + " @**LKey1");

        initUI();
        dbValues();
    }

    @Override
    protected void onResume() {
        super.onResume();
        if (ConstantsActivity.flagUpdateEdit) {
            ConstantsActivity.flagUpdateEdit = false;
            initSharedPrefs(ConstantsDB.SHARED_PREFS_SCREEN_KEY, getString(R.string.summary));
            dbValues();
        }
        ConstantsDB.TABLE_NAME_SCREEN = getString(R.string.summary);
    }

    private ImageView ivSummaryVI, ivSummaryVO, ivSummaryVC, ivSummaryUP, ivSummaryMedia, ivSummary0ne, ivSummaryTwo, ivSummaryThree;
    private TextView tvSummarySave, tvSummaryCancel, tvSummaryYear, tvSummaryMake, tvSummaryModel, tvSummaryOption1, tvSummaryOption2, tvSummaryOption3, tvSummaryOption4, tvSummaryOption5, tvSummaryOption6, tvSummaryConditionExterior, tvSummaryConditionInterior, tvSummaryUserFirstName, tvSummaryUserEmail;

    /* Initialize UI */
    private void initUI() {
        LoggerTradeIn.e(TAG, "initUI");
        LoggerTradeIn.e(TAG, "dbVehicleIndex = " + ConstantsDB.dbVehicleIndex + "");
        ivSummaryVI = findViewById(R.id.iv_summary_vi);
        ivSummaryVO = findViewById(R.id.iv_summary_vo);
        ivSummaryVC = findViewById(R.id.iv_summary_vc);
        ivSummaryUP = findViewById(R.id.iv_summary_up);
        ivSummaryMedia = findViewById(R.id.iv_summary_media);

        tvSummaryYear = findViewById(R.id.tv_summary_year);
        tvSummaryMake = findViewById(R.id.tv_summary_make);
        tvSummaryModel = findViewById(R.id.tv_summary_model);
        tvSummaryOption1 = findViewById(R.id.tv_summary_option1);
        tvSummaryOption2 = findViewById(R.id.tv_summary_option2);
        tvSummaryOption3 = findViewById(R.id.tv_summary_option3);
        tvSummaryOption4 = findViewById(R.id.tv_summary_option4);
        tvSummaryOption5 = findViewById(R.id.tv_summary_option5);
        tvSummaryOption6 = findViewById(R.id.tv_summary_option6);
        tvSummaryConditionExterior = findViewById(R.id.tv_summary_condition_exterior);
        tvSummaryConditionInterior = findViewById(R.id.tv_summary_condition_interior);
        tvSummaryUserFirstName = findViewById(R.id.tv_summary_user_first_name);
        tvSummaryUserEmail = findViewById(R.id.tv_summary_user_email);
        tvSummarySave = findViewById(R.id.tv_summary_save);
        tvSummaryCancel = findViewById(R.id.tv_summary_cancel);

        ivSummaryVI.setOnClickListener(this);
        ivSummaryVO.setOnClickListener(this);
        ivSummaryVC.setOnClickListener(this);
        ivSummaryUP.setOnClickListener(this);
        ivSummaryMedia.setOnClickListener(this);
        tvSummaryCancel.setOnClickListener(this);
        tvSummarySave.setOnClickListener(this);

        ivSummary0ne = findViewById(R.id.iv_summary_one);
        ivSummaryTwo = findViewById(R.id.iv_summary_two);
        ivSummaryThree = findViewById(R.id.iv_summary_three);

        initSharedPrefs(ConstantsDB.SHARED_PREFS_SCREEN_KEY, getString(R.string.summary));

    }

    /* Db Values INIT */
    private void dbValues() {
        LoggerTradeIn.e(TAG, "dbValues");
        ConstantsActivity.alVMGridStr.clear();
        ConstantsActivity.alVMGridUri.clear();
        ConstantsActivity.hmDBVehicles.clear();
        ConstantsActivity.hmUsers.clear();
        ConstantsBB.alMultiFile.clear();

        LoggerTradeIn.e(TAG, "dbVehicleIndex = " + ConstantsDB.dbVehicleIndex);
        DBOperations dbOperations = DBOperations.getInstance();
        dbOperations.getVehicleMediaValues(this);
        dbOperations.getVehicleValues(this);
        dbOperations.getUserValues(this);
        setDBValuesToUI();
    }

    /* Db Values Assign to UI */
    private void setDBValuesToUI() {
        LoggerTradeIn.e(TAG, "setDBValuesToUI");
        setImageGallery();
        setVehicleInfo();
        setVehicleOptions();
        setVehicleConditions();
        setVehicleOwner();
    }

    /* Text View Value Assign */
    private void setVehicleOwner() {
        LoggerTradeIn.e(TAG, "setVehicleOwner");
        tvSummaryUserFirstName.setText(ConstantsActivity.hmUsers.get(ConstantsApi.KEYS_VEHICLE_ONE_USER_ARRAY[1]));
        tvSummaryUserEmail.setText(ConstantsActivity.hmUsers.get(ConstantsApi.KEYS_VEHICLE_ONE_USER_ARRAY[3]));
    }

    /* Text View Value Assign */
    private void setVehicleConditions() {
        LoggerTradeIn.e(TAG, "setVehicleConditions");
        tvSummaryConditionExterior.setText(ConstantsActivity.hmDBVehicles.get(ConstantsApi.KEYS_VEHICLE_ONE_ARRAY[19]));
        tvSummaryConditionInterior.setText(ConstantsActivity.hmDBVehicles.get(ConstantsApi.KEYS_VEHICLE_ONE_ARRAY[18]));
    }

    /* Text View Value Assign */
    private void setVehicleOptions() {
        LoggerTradeIn.e(TAG, "setVehicleOptions");
//        String strVehicleOptions = ConstantsActivity.hmDBVehicles.get("options");
        String strVehicleOptions = ConstantsActivity.hmDBVehicles.get("vehicle_options");
        LoggerTradeIn.e(TAG, strVehicleOptions + " @259");
        if (null == strVehicleOptions) {
            return;
        }
        if (strVehicleOptions.equals("--")) {
            return;
        }
        String aryOptions[] = strVehicleOptions.split("--");
//        String strOptions = ConstantsActivity.hmVehicles.get("options");
        String strOptions = aryOptions[0];
        String strOptionsArray[] = strOptions.split(",");
        if (strOptionsArray.length == 0) {
            return;
        }
        tvSummaryOption1.setText(strOptionsArray[0]);
        if (strOptionsArray.length == 1) {
            return;
        }
        tvSummaryOption2.setText(strOptionsArray[1]);
        if (strOptionsArray.length == 2) {
            return;
        }
        tvSummaryOption3.setText(strOptionsArray[2]);
        if (strOptionsArray.length == 3) {
            return;
        }
        tvSummaryOption4.setText(strOptionsArray[3]);
        if (strOptionsArray.length == 4) {
            return;
        }
        tvSummaryOption5.setText(strOptionsArray[4]);
        if (strOptionsArray.length == 5) {
            return;
        }
    }

    /* Text View Value Assign */
    private void setVehicleInfo() {
        LoggerTradeIn.e(TAG, "setVehicleInfo");
        tvSummaryYear.setText(ConstantsActivity.hmDBVehicles.get(ConstantsApi.KEYS_VEHICLE_ONE_ARRAY[4]));
//        tvSummaryMake.setText(ConstantsActivity.hmVehicles.get("make"));
//        tvSummaryModel.setText(ConstantsActivity.hmVehicles.get("model"));
        tvSummaryMake.setText(ConstantsActivity.hmDBVehicles.get("make_name"));
        tvSummaryModel.setText(ConstantsActivity.hmDBVehicles.get("model_name"));
    }

    /* Image View Value Assign */
    private void setImageGallery() {
        LoggerTradeIn.e(TAG, "setImageGallery");
        int mediaImgWidthHeight = 100;
        //        ivSummary0ne.setImageURI(ConstantsActivity.alVMGridUri.get(0));
//        Glide.with(this).load(ConstantsActivity.alVMGridUri.get(0)).into(ivSummary0ne);
        if (ConstantsActivity.alVMGridUri.size() == 0) {
            return;
        }
        Glide.with(this).load(ConstantsActivity.alVMGridUri.get(0))
                .apply(new RequestOptions().override(mediaImgWidthHeight, mediaImgWidthHeight))
                .into(ivSummary0ne);
        if (ConstantsActivity.alVMGridUri.size() == 1) {
            return;
        }
        Glide.with(this).load(ConstantsActivity.alVMGridUri.get(1))
                .apply(new RequestOptions().override(mediaImgWidthHeight, mediaImgWidthHeight))
                .into(ivSummaryTwo);
        if (ConstantsActivity.alVMGridUri.size() == 2) {
            return;
        }
        Glide.with(this).load(ConstantsActivity.alVMGridUri.get(2))
                .apply(new RequestOptions().override(mediaImgWidthHeight, mediaImgWidthHeight))
                .into(ivSummaryThree);
    }

    /* On Click  */
    @Override
    public void onClick(View v) {
        LoggerTradeIn.e(TAG, "Button Clicked");
        if (v.getId() == R.id.tv_summary_cancel) {
            LoggerTradeIn.e(TAG, "Cancel Clicked");
            DialogCustomize dialogCustomize = DialogCustomize.getInstance();
            dialogCustomize.displayCancelDialog(this, ConstantsDialog.FLAG_DIALOG_DISPLAY, "", "");
        } else if (v.getId() == R.id.tv_summary_save) {
            LoggerTradeIn.e(TAG, "Save Clicked");
            DialogCustomize dialogCustomize = DialogCustomize.getInstance();
            dialogCustomize.displayValidationDialog(this, ConstantsDialog.FLAG_DIALOG_DISPLAY, "", getString(R.string.vehicle_submit_msg));
        } else if (v.getId() == R.id.iv_summary_vi) {
            LoggerTradeIn.e(TAG, "VEHICLE INFO Clicked");
            summaryEdit(VehicleInfoOneActivity.class);
        } else if (v.getId() == R.id.iv_summary_vo) {
            LoggerTradeIn.e(TAG, "VEHICLE OPTIONS Clicked");
            summaryEdit(VehicleOptionsActivity.class);
        } else if (v.getId() == R.id.iv_summary_vc) {
            LoggerTradeIn.e(TAG, "VEHICLE CONDITIONS Clicked");
            summaryEdit(VehicleConditionActivity.class);
        } else if (v.getId() == R.id.iv_summary_up) {
            LoggerTradeIn.e(TAG, "VEHICLE PROFILE Clicked");
            summaryEdit(UserProfileActivity.class);
        } else if (v.getId() == R.id.iv_summary_media) {
            LoggerTradeIn.e(TAG, "VEHICLE MEDIA Clicked");
            summaryEdit(VehicleMediaActivity.class);
        }
    }

    /* Common Intent  */
    private void summaryEdit(Class editScreen) {
        ConstantsActivity.flagUpdateEdit = true;
        LoggerTradeIn.e(TAG, "summaryEdit");
        Intent intent = new Intent(this, editScreen);
        startActivity(intent);
    }

    /* Dialog Operations  */
    @Override
    public void sendDialogFlag(int flag) {
        LoggerTradeIn.e(TAG, "sendDialogFlag");
        if (flag == ConstantsDialog.FLAG_DIALOG_SUBMIT_VEHICLE) {
            callSaveVehicleApi();
        }
    }

    private void callSaveVehicleApi() {

        ConstantsApi.SUMMARY_VEHICLE_CLIENT_ID = "11";
        ConstantsApi.SUMMARY_VEHICLE_LEAD_ID = "12";
        ConstantsApi.SUMMARY_YEAR = ConstantsActivity.hmDBVehicles.get(ConstantsApi.KEYS_VEHICLE_ONE_ARRAY[4]);
        ConstantsApi.SUMMARY_VEHICLE_MAKE_ID = ConstantsActivity.hmDBVehicles.get(ConstantsApi.KEYS_VEHICLE_ONE_ARRAY[5]);
        ConstantsApi.SUMMARY_VEHICLE_MAKE_NAME = ConstantsActivity.hmDBVehicles.get(ConstantsApi.KEYS_VEHICLE_ONE_ARRAY[27]);
        ConstantsApi.SUMMARY_VEHICLE_MODEL_ID = ConstantsActivity.hmDBVehicles.get(ConstantsApi.KEYS_VEHICLE_ONE_ARRAY[6]);
        ConstantsApi.SUMMARY_VEHICLE_MODEL_NAME = ConstantsActivity.hmDBVehicles.get(ConstantsApi.KEYS_VEHICLE_ONE_ARRAY[26]);
        ConstantsApi.SUMMARY_TRIM = ConstantsActivity.hmDBVehicles.get(ConstantsApi.KEYS_VEHICLE_ONE_ARRAY[7]);
        ConstantsApi.SUMMARY_MILEAGE = ConstantsActivity.hmDBVehicles.get(ConstantsApi.KEYS_VEHICLE_ONE_ARRAY[8]);
        ConstantsApi.SUMMARY_VIN = ConstantsActivity.hmDBVehicles.get(ConstantsApi.KEYS_VEHICLE_ONE_ARRAY[9]);
        ConstantsApi.SUMMARY_EXT_COLOR = ConstantsActivity.hmDBVehicles.get(ConstantsApi.KEYS_VEHICLE_ONE_ARRAY[10]);

        ConstantsApi.SUMMARY_INTERIOR_COLOR = ConstantsActivity.hmDBVehicles.get(ConstantsApi.KEYS_VEHICLE_ONE_ARRAY[11]);
        ConstantsApi.SUMMARY_TRANSMISSION = ConstantsActivity.hmDBVehicles.get(ConstantsApi.KEYS_VEHICLE_ONE_ARRAY[12]);
        ConstantsApi.SUMMARY_DRIVE_TRAIN = ConstantsActivity.hmDBVehicles.get(ConstantsApi.KEYS_VEHICLE_ONE_ARRAY[13]);
        ConstantsApi.SUMMARY_BODY_STYLE = ConstantsActivity.hmDBVehicles.get(ConstantsApi.KEYS_VEHICLE_ONE_ARRAY[14]);
        ConstantsApi.SUMMARY_ENGINE = ConstantsActivity.hmDBVehicles.get(ConstantsApi.KEYS_VEHICLE_ONE_ARRAY[15]);
        ConstantsApi.SUMMARY_SEAT_TYPE = ConstantsActivity.hmDBVehicles.get(ConstantsApi.KEYS_VEHICLE_ONE_ARRAY[16]);

//        String strVehicleOptions = ConstantsActivity.hmDBVehicles.get("options");
        String strVehicleOptions = ConstantsActivity.hmDBVehicles.get("vehicle_options");
        LoggerTradeIn.e(TAG, strVehicleOptions + " @259");
        if (strVehicleOptions.equals("--")) {
            ConstantsApi.SUMMARY_VEHICLE_OPTION_NAMES = "";
            ConstantsApi.SUMMARY_VEHICLE_OPTION_IDS = "";
        } else {
            String aryOptions[] = strVehicleOptions.split("--");
//        ConstantsActivity.SELECT_OPTION_RETURN_VALUE_IDS = ConstantsActivity.SELECT_OPTION_RETURN_VALUE_IDS.replace(", ",",");
//        ConstantsApi.SUMMARY_VEHICLE_OPTIONS = "1,2,3,4";
//        ConstantsApi.SUMMARY_VEHICLE_OPTIONS = ConstantsActivity.SELECT_OPTION_RETURN_VALUE_IDS;
//        ConstantsApi.SUMMARY_VEHICLE_OPTION_NAMES = "Sunroof,DVD Entertainment System,Lane Assist,Premium Audio";
//        ConstantsApi.SUMMARY_VEHICLE_OPTION_NAMES = ConstantsActivity.hmVehicles.get("options");
            ConstantsApi.SUMMARY_VEHICLE_OPTION_NAMES = aryOptions[0];
            ConstantsApi.SUMMARY_VEHICLE_OPTION_NAMES = ConstantsApi.SUMMARY_VEHICLE_OPTION_NAMES.replace(", ", ",");
            ConstantsApi.SUMMARY_VEHICLE_OPTION_IDS = aryOptions[1];
            ConstantsApi.SUMMARY_VEHICLE_OPTION_IDS = ConstantsApi.SUMMARY_VEHICLE_OPTION_IDS.replace(", ", ",");
        }
        LoggerTradeIn.e(TAG, ConstantsApi.SUMMARY_VEHICLE_OPTION_NAMES + " @269");
        LoggerTradeIn.e(TAG, ConstantsApi.SUMMARY_VEHICLE_OPTION_IDS + " @270");

        ConstantsApi.SUMMARY_VEHICLE_PACKAGE = ConstantsActivity.hmDBVehicles.get(ConstantsApi.KEYS_VEHICLE_ONE_ARRAY[17]);

        ConstantsApi.SUMMARY_INT_VEH_CONDITION = ConstantsActivity.hmDBVehicles.get(ConstantsApi.KEYS_VEHICLE_ONE_ARRAY[18]);
        ConstantsApi.SUMMARY_EXT_VEH_CONDITION = ConstantsActivity.hmDBVehicles.get(ConstantsApi.KEYS_VEHICLE_ONE_ARRAY[19]);
        ConstantsApi.SUMMARY_VEHICLE_SMOKE = ConstantsActivity.hmDBVehicles.get(ConstantsApi.KEYS_VEHICLE_ONE_ARRAY[20]);
        ConstantsApi.SUMMARY_VEHICLE_ACCIDENT = ConstantsActivity.hmDBVehicles.get(ConstantsApi.KEYS_VEHICLE_ONE_ARRAY[21]);
        ConstantsApi.SUMMARY_VEHICLE_COMMENT = ConstantsActivity.hmDBVehicles.get(ConstantsApi.KEYS_VEHICLE_ONE_ARRAY[28]);

        /*ConstantsApi.SUMMARY_YEAR = ConstantsActivity.hmDBVehicles.get("year");
        ConstantsApi.SUMMARY_VEHICLE_MAKE_ID = ConstantsActivity.hmDBVehicles.get("make");
        ConstantsApi.SUMMARY_VEHICLE_MODEL_ID = ConstantsActivity.hmDBVehicles.get("model");
        ConstantsApi.SUMMARY_TRIM = ConstantsActivity.hmDBVehicles.get("trim");
        ConstantsApi.SUMMARY_MILEAGE = ConstantsActivity.hmDBVehicles.get("mileage");
        ConstantsApi.SUMMARY_VIN = ConstantsActivity.hmDBVehicles.get("vin");
        ConstantsApi.SUMMARY_EXT_COLOR = ConstantsActivity.hmDBVehicles.get("exterior_color");
        ConstantsApi.SUMMARY_INTERIOR_COLOR = ConstantsActivity.hmDBVehicles.get("interior_color");
        ConstantsApi.SUMMARY_TRANSMISSION = ConstantsActivity.hmDBVehicles.get("transmission");
        ConstantsApi.SUMMARY_DRIVE_TRAIN = ConstantsActivity.hmDBVehicles.get("drive_train");
        ConstantsApi.SUMMARY_BODY_STYLE = ConstantsActivity.hmDBVehicles.get("body_style");
        ConstantsApi.SUMMARY_ENGINE = ConstantsActivity.hmDBVehicles.get("engine");
        ConstantsApi.SUMMARY_SEAT_TYPE = ConstantsActivity.hmDBVehicles.get("seat_type");
       */
        /*ConstantsApi.SUMMARY_VEHICLE_PACKAGE = ConstantsActivity.hmDBVehicles.get("packages");
        ConstantsApi.SUMMARY_INT_VEH_CONDITION = ConstantsActivity.hmDBVehicles.get("interior_condition");
        ConstantsApi.SUMMARY_EXT_VEH_CONDITION = ConstantsActivity.hmDBVehicles.get("exterior_condition");
        ConstantsApi.SUMMARY_VEHICLE_SMOKE = ConstantsActivity.hmDBVehicles.get("smoked");
        ConstantsApi.SUMMARY_VEHICLE_ACCIDENT = ConstantsActivity.hmDBVehicles.get("accident");*/

        ConstantsApi.LEAD_KEY_UP_URL = sharedPreferenceTI.getStringValue(this, ConstantsDB.SHARED_PREFS_LEAD_KEY);
        LoggerTradeIn.e(TAG, ConstantsApi.LEAD_KEY_UP_URL + " @285");
        LoggerTradeIn.e(TAG, ConstantsApi.SUMMARY_TRANSMISSION + " @302");

//        ConstantsApi.VEHICLE_KEY_UP_URL = "";
        ConstantsApi.SAVE_VEHICLE_URL = "SaveVehicle" +
                "&LEAD_KEY=" + ConstantsApi.LEAD_KEY_UP_URL +
                "&VEHICLE_CLIENT_ID=" + ConstantsApi.SUMMARY_VEHICLE_CLIENT_ID +
                "&VEHICLE_FKEY=" + ConstantsApi.VEHICLE_KEY_UP_URL +
                "&VEHICLE_LEAD_ID=" + ConstantsApi.SUMMARY_VEHICLE_LEAD_ID +
                "&YEAR=" + ConstantsApi.SUMMARY_YEAR +
                "&VEHICLE_MAKE_ID=" + ConstantsApi.SUMMARY_VEHICLE_MAKE_ID +
                "&VEHICLE_MODEL_ID=" + ConstantsApi.SUMMARY_VEHICLE_MODEL_ID +
                "&TRIM=" + ConstantsApi.SUMMARY_TRIM +
                "&MILEAGE=" + ConstantsApi.SUMMARY_MILEAGE +
                "&VIN=" + ConstantsApi.SUMMARY_VIN +
                "&EXT_COLOR=" + ConstantsApi.SUMMARY_EXT_COLOR +
                "&INTERIOR_COLOR=" + ConstantsApi.SUMMARY_INTERIOR_COLOR +
                "&TRANSMISSION=" + ConstantsApi.SUMMARY_TRANSMISSION +
                "&DRIVE_TRAIN=" + ConstantsApi.SUMMARY_DRIVE_TRAIN +
                "&BODY_STYLE=" + ConstantsApi.SUMMARY_BODY_STYLE +
                "&ENGINE=" + ConstantsApi.SUMMARY_ENGINE +
                "&SEAT_TYPE=" + ConstantsApi.SUMMARY_SEAT_TYPE +
                "&VEHICLE_OPTIONS=" + ConstantsApi.SUMMARY_VEHICLE_OPTION_IDS +
                "&VEHICLE_OPTION_NAMES=" + ConstantsApi.SUMMARY_VEHICLE_OPTION_NAMES +
                "&VEHICLE_PACKAGE=" + ConstantsApi.SUMMARY_VEHICLE_PACKAGE +
                "&INT_VEH_CONDITION=" + ConstantsApi.SUMMARY_INT_VEH_CONDITION +
                "&EXT_VEH_CONDITION=" + ConstantsApi.SUMMARY_EXT_VEH_CONDITION +
                "&VEHICLE_SMOKE=" + ConstantsApi.SUMMARY_VEHICLE_SMOKE +
                "&VEHICLE_SMOKE=" + ConstantsApi.SUMMARY_VEHICLE_SMOKE +
                "&VEHICLE_ACCIDENT=" + ConstantsApi.SUMMARY_VEHICLE_ACCIDENT +
                "&COMMENT=" + ConstantsApi.SUMMARY_VEHICLE_COMMENT +
                "&PERCENTAGE=50";

        ConstantsApi.FLAG_API_NAME = ConstantsApi.FLAG_API_SAVE_VEHICLE;
        Intent serviceIntent = new Intent(this, ApiService.class);
        startService(serviceIntent);
    }

    /* Activity Discard Intent  */
    public void activityDiscard() {
        DBOperations dbOperations = DBOperations.getInstance();
        dbOperations.dbSubmitCall(this);
    }

    @Override
    public void callActivity(String strResponse) {
        LoggerTradeIn.e(TAG, strResponse + " @250");
        DBOperations dbOperations = DBOperations.getInstance();
//        dbOperations.dbUpdateFlag(this);
        dbOperations.updateVehicleFlag(this, ConstantsDB.dbVehicleIndex, "gone", MyVehicleActivity.class, false);

//        activityDiscard();
//        initSharedPrefs(ConstantsDB.SHARED_PREFS_VEHICLE_KEY, ConstantsApi.SUMMARY_VEHICLE_KEY);
        Intent in = new Intent(this, MyVehicleActivity.class);
        in.setFlags(Intent.FLAG_ACTIVITY_NEW_TASK | Intent.FLAG_ACTIVITY_CLEAR_TASK);
        startActivity(in);

        if (ConstantsBB.alMultiFile.size() > 0) {
            ConstantsApi.VEHICLE_KEY_UP_URL = ConstantsApi.SUMMARY_VEHICLE_KEY;
            Intent serviceIntent = new Intent(this, BlackBaseService.class);
            startService(serviceIntent);
        }
        finish();

    }
}
