package com.concatsys.tradein.tradein_plugin.activity;

import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;
import android.text.Editable;
import android.text.TextWatcher;
import android.util.Log;
import android.view.Gravity;
import android.view.View;
import android.view.WindowManager;
import android.widget.Button;
import android.widget.CheckBox;
import android.widget.CompoundButton;
import android.widget.EditText;
import android.widget.LinearLayout;

import com.concatsys.tradein.tradein_plugin.R;
import com.concatsys.tradein.tradein_plugin.api.ConstantsApi;
import com.concatsys.tradein.tradein_plugin.dialogsandviews.ToastCustomize;
import com.concatsys.tradein.tradein_plugin.logs.LoggerTradeIn;

import java.util.ArrayList;
import java.util.HashMap;

public class VehicleCheckBoxActivity extends BaseActivity implements View.OnClickListener {
    private String TAG = getClass().getSimpleName();

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.setLayout(R.layout.activity_vehicle_checkbox);
        super.onCreate(savedInstanceState);
        Intent intent = getIntent();
        ConstantsActivity.AL_NEW_RADIO_CHECK_OPTIONS = (ArrayList<HashMap<String, String>>) intent.getSerializableExtra(ConstantsActivity.SELECT_OPTION_PASS);
        if (!ConstantsActivity.ACTIVITY_UPDATE_FLAG.equals(ConstantsActivity.ACTIVITY_UPDATE_FLAG_NEW)) {
            getAlCheckValues(ConstantsActivity.AL_NEW_RADIO_CHECK_OPTIONS);
        }
        initUI();
        addCheckBoxes(ConstantsActivity.AL_NEW_RADIO_CHECK_OPTIONS);
    }

    private void searchFilterOptions(String strSearch) {
        ConstantsActivity.AL_NEW_RADIO_CHECK_OPTIONS_FILTER.clear();
        for (int i = 0; i < ConstantsActivity.AL_NEW_RADIO_CHECK_OPTIONS.size(); i++) {
            String strArrayItemValue = ConstantsActivity.AL_NEW_RADIO_CHECK_OPTIONS.get(i).get(ConstantsActivity.SELECT_OPTION_PASS);
            if (strArrayItemValue.contains(strSearch)) {
                HashMap<String, String> hm = new HashMap<>();
                hm.put(ConstantsActivity.SELECT_OPTION_PASS, strArrayItemValue);
                ConstantsActivity.AL_NEW_RADIO_CHECK_OPTIONS_FILTER.add(hm);
            }
        }
        addCheckBoxes(ConstantsActivity.AL_NEW_RADIO_CHECK_OPTIONS_FILTER);
    }

    private ArrayList<String> arrayListCheckBox = new ArrayList<>();
    private ArrayList<String> arrayListCheckBoxIds = new ArrayList<>();
    private String strCheckBoxValues = "";

    //    Year
    private int selectedRadioCheckButton;
    private LinearLayout lytCheckBox;
    private ArrayList<HashMap<String, String>> alCheckBoxOptions = new ArrayList<>();

    /* Checkbox assign */
    private void addCheckBoxes(ArrayList<HashMap<String, String>> alAddOptions) {
        alCheckBoxOptions = alAddOptions;
        lytCheckBox = findViewById(R.id.lyt_add_check_box);
        lytCheckBox.removeAllViews();
        int radioCommonPadding = 30;
        for (int i = 0; i < alAddOptions.size(); i++) {
            CheckBox checkBox = new CheckBox(this);
//            checkBox.setId(View.generateViewId());
            checkBox.setId(i);
//            checkBox.setTag(i);
            checkBox.setText(alAddOptions.get(i).get(ConstantsActivity.SELECT_OPTION_PASS));
            if(alCheckIdsBoolean.size()>0){
                checkBox.setChecked(alCheckIdsBoolean.get(i));
            }
            LinearLayout.LayoutParams params = new LinearLayout.LayoutParams(LinearLayout.LayoutParams.MATCH_PARENT, LinearLayout.LayoutParams.WRAP_CONTENT, 1f);
            checkBox.setLayoutParams(params);
            checkBox.setLayoutDirection(View.LAYOUT_DIRECTION_RTL);
            checkBox.setGravity(Gravity.LEFT | Gravity.CENTER_VERTICAL);
            checkBox.setTextAppearance(android.R.style.TextAppearance_Small);
            checkBox.setButtonDrawable(R.drawable.check_box_selector);
            checkBox.setPadding(0, radioCommonPadding, 0, radioCommonPadding);

            checkBox.setOnCheckedChangeListener(new CompoundButton.OnCheckedChangeListener() {
                @Override
                public void onCheckedChanged(CompoundButton buttonView, boolean isChecked) {
                    handleCheckBox(buttonView.getId(), checkBox.getText().toString(), isChecked);
                }
            });
            lytCheckBox.addView(checkBox);
        }
    }

//  Check Id Options
    ArrayList <Boolean> alCheckIdsBoolean = new ArrayList<>();
    boolean isCheckOption = false;
    private void getAlCheckValues(ArrayList<HashMap<String, String>> alAddOptionsTwo) {
        try {
            for (int i = 0; i < alAddOptionsTwo.size(); i++) {

                for (int j = 0; j < ConstantsApi.alHMOneVehicleOptions.get(0).size(); j++){
                    int checkPosition = Integer.parseInt(ConstantsApi.alHMOneVehicleOptions.get(j).get(ConstantsApi.KEYS_VEHICLE_ONE_OPTIONS_ARRAY[0]));
                    if(i == checkPosition){
                        isCheckOption = true;
                        alCheckIdsBoolean.add(true);
                    }
                }

                if(!isCheckOption){
                    alCheckIdsBoolean.add(false);
                }
                isCheckOption = false;
            }
        } catch (Exception e) {

        }
    }

    private HashMap<Integer, String> hashMapCheckBox = new HashMap<>();

    private void handleCheckBox(int position, String checkBoxText, boolean isChecked) {
//        LoggerTradeIn.e(TAG, checkBoxText+"");
        if (isChecked) {
            hashMapCheckBox.put(position, checkBoxText);
        } else {
            hashMapCheckBox.remove(position);
        }
    }
    private EditText etSearchCheckOptions;

    /* Initialize UI */
    private void initUI() {
        LoggerTradeIn.e(TAG, "initUI");
        etSearchCheckOptions = findViewById(R.id.et_check_box_search);
        Button btnCheckBoxSubmit = findViewById(R.id.btn_check_box_submit);
        btnCheckBoxSubmit.setOnClickListener(this);
        LinearLayout lytCheckSearchOptions = findViewById(R.id.lyt_check_box_search);
        int flagSearchLength = 5;
        if (ConstantsActivity.AL_RADIO_CHECK_OPTIONS.size() < flagSearchLength) {
            lytCheckSearchOptions.setVisibility(View.GONE);
        }

        /*etSearchCheckOptions.setOnEditorActionListener(new TextView.OnEditorActionListener() {
            @Override
            public boolean onEditorAction(TextView v, int actionId, KeyEvent event) {
                if (actionId == EditorInfo.IME_ACTION_SEARCH) {
                    // Your piece of code on keyboard search click
                    searchFilterOptions(etSearchRadioOptions.getText()+"");
                    return true;
                }
                return false;
            }
        });*/
        etSearchCheckOptions.addTextChangedListener(new TextWatcher() {
            @Override
            public void beforeTextChanged(CharSequence s, int start, int count, int after) {

            }

            @Override
            public void onTextChanged(CharSequence s, int start, int before, int count) {

            }

            @Override
            public void afterTextChanged(Editable s) {
                searchFilterOptions(etSearchCheckOptions.getText() + "");
            }
        });

        this.getWindow().setSoftInputMode(WindowManager.LayoutParams.SOFT_INPUT_STATE_HIDDEN);
    }

    @Override
    public void onClick(View v) {
        LoggerTradeIn.e(TAG, "onClick");
        if (v.getId() == R.id.btn_check_box_submit) {
            LoggerTradeIn.e(TAG, "onClick Submit");
            selectedRadioCheckButton = hashMapCheckBox.size();
            if (selectedRadioCheckButton < 1) {
                ToastCustomize.displayToast(getApplicationContext(), getString(R.string.select_option));
                return;
            }
            for (HashMap.Entry<Integer, String> set : hashMapCheckBox.entrySet()) {
                LoggerTradeIn.e(TAG, set.getKey() + getString(R.string.comma_space_string) + set.getValue() + "");
                arrayListCheckBox.add(set.getValue());
                arrayListCheckBoxIds.add(set.getKey() + "");
//                LoggerTradeIn.e(TAG,arrayListCheckBox.get(0) + "");
                strCheckBoxValues += set.getValue() + getString(R.string.comma_space_string);
            }
            strCheckBoxValues = strCheckBoxValues.replaceAll(getString(R.string.replace_dollar_string), "");
            Intent returnIntent = new Intent();
            returnIntent.putExtra(ConstantsActivity.SELECT_OPTION_PASS, arrayListCheckBox);
            returnIntent.putExtra(ConstantsActivity.SELECT_OPTION_PASS_IDS, arrayListCheckBoxIds);
//        returnIntent.putExtra(ConstantsActivity.SELECT_OPTION_PASS_TWO, strCheckBoxValues);
            setResult(Activity.RESULT_OK, returnIntent);
            finish();
        }
    }
}

