package com.concatsys.tradein.tradein_plugin.activity;

import android.app.Activity;
import android.content.Context;
import android.content.Intent;
import android.graphics.Color;
import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.view.WindowManager;
import android.widget.EditText;
import android.widget.LinearLayout;
import android.widget.TextView;

import androidx.activity.result.ActivityResult;
import androidx.activity.result.ActivityResultCallback;
import androidx.activity.result.ActivityResultLauncher;
import androidx.activity.result.contract.ActivityResultContracts;

import com.concatsys.tradein.tradein_plugin.R;
import com.concatsys.tradein.tradein_plugin.api.ConstantsApi;
import com.concatsys.tradein.tradein_plugin.db.ConstantsDB;
import com.concatsys.tradein.tradein_plugin.db.DBOperations;
import com.concatsys.tradein.tradein_plugin.dialogsandviews.ConstantsDialog;
import com.concatsys.tradein.tradein_plugin.dialogsandviews.DialogCustomize;
import com.concatsys.tradein.tradein_plugin.interfaces.DialogCallBack;
import com.concatsys.tradein.tradein_plugin.logs.LoggerTradeIn;

import java.util.ArrayList;
import java.util.HashMap;

public class VehicleConditionActivity extends BaseActivity implements View.OnClickListener, DialogCallBack {
    private String TAG = getClass().getSimpleName();

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        ConstantsActivity.ACTIVITY_TITLES = getString(R.string.vehicle_condition);
        super.setLayout(R.layout.activity_vehicle_condition);
        super.onCreate(savedInstanceState);
        initUI();
    }

    private TextView textViewHolder, tvVCInterior, tvVCExterior, tvVCSmoke, tvVCAccident, tvVCSmokeYes, tvVCSmokeNo, tvVCAccidentYes, tvVCAccidentNo, tvVCCancel, tvVCSave;
    private EditText etVCComments;
    private LinearLayout lytVCSmokeYesNoList, lytVCAccidentYesNoList, lytVCSmokeYesNo, lytVCAccidentYesNo, lytVCInterior, lytVCExterior, lytVCSmokeClick, lytVCAccidentClick;

    /* Initialize UI */
    private void initUI() {
        LoggerTradeIn.e(TAG, "initUI");
        tvVCInterior = findViewById(R.id.tv_vehicle_condition_interior);
        tvVCExterior = findViewById(R.id.tv_vehicle_condition_exterior);
        tvVCSmoke = findViewById(R.id.tv_vehicle_condition_smoke);
        tvVCAccident = findViewById(R.id.tv_vehicle_condition_accident);
        tvVCSmokeYes = findViewById(R.id.tv_vc_smoke_yes);
        tvVCSmokeNo = findViewById(R.id.tv_vc_smoke_no);
        tvVCAccidentYes = findViewById(R.id.tv_vc_accident_yes);
        tvVCAccidentNo = findViewById(R.id.tv_vc_accident_no);
        tvVCCancel = findViewById(R.id.tv_vc_cancel);
        tvVCSave = findViewById(R.id.tv_vc_save);

        etVCComments = findViewById(R.id.et_vehicle_condition_comments);
        lytVCSmokeYesNo = findViewById(R.id.lyt_vc_smoke_yes_no);
        lytVCSmokeYesNoList = findViewById(R.id.lyt_vc_smoke_yes_no_list);
        lytVCAccidentYesNo = findViewById(R.id.lyt_vc_accident_yes_no);
        lytVCAccidentYesNoList = findViewById(R.id.lyt_vc_accident_yes_no_list);

        lytVCInterior = findViewById(R.id.lyt_vc_interior);
        lytVCExterior = findViewById(R.id.lyt_vc_exterior);
        lytVCSmokeClick = findViewById(R.id.lyt_vc_smoke_click);
        lytVCAccidentClick = findViewById(R.id.lyt_vc_accident_click);

        tvVCSave.setOnClickListener(this);
        tvVCCancel.setOnClickListener(this);
        tvVCSmokeYes.setOnClickListener(this);
        tvVCSmokeNo.setOnClickListener(this);
        tvVCAccidentYes.setOnClickListener(this);
        tvVCAccidentNo.setOnClickListener(this);
        lytVCInterior.setOnClickListener(this);
        lytVCExterior.setOnClickListener(this);
        lytVCSmokeClick.setOnClickListener(this);
        lytVCAccidentClick.setOnClickListener(this);
        this.getWindow().setSoftInputMode(WindowManager.LayoutParams.SOFT_INPUT_STATE_HIDDEN);
        initSharedPrefs(ConstantsDB.SHARED_PREFS_SCREEN_KEY,getString(R.string.vehicle_condition));
//        setDBValuesToUI();
        initSharedPrefs(ConstantsDB.SHARED_PREFS_SCREEN_KEY,getString(R.string.vehicle_condition));
        setUpdateValuesToUI();
        setSmokeAccidentApiData();
    }
    private void setSmokeAccidentApiData(){
        for (int i = 0; i < ConstantsApi.alHMVehicleSmoke.size(); i++) {
            setSmokeOptions(i);
        }
        for (int i = 0; i < ConstantsApi.alHMVehicleAccident.size(); i++) {
            setAccidentOptions(i);
        }

       /* for (int i = 0; i < ConstantsApi.alHMVehicleAccident.size(); i++) {
            setSmokeAccidentOptions(lytVCSmokeYesNoList,tvVCSmoke,
                    ConstantsApi.alHMVehicleSmoke,ConstantsApi.KEYS_DROP_DOWN_SMOKE[1],i);
        }*/
    }
    /* Smoke Options Assign to UI */
    private void setSmokeOptions(int position){
//        lyt_vc_smoke_yes_no_list
        LayoutInflater inflater =(LayoutInflater)getSystemService(Context.LAYOUT_INFLATER_SERVICE);
        View vehicleConditionsView = inflater.inflate(R.layout.view_layout_conditions_yes_no, null);
        lytVCSmokeYesNoList.addView(vehicleConditionsView);
        TextView tvItemConditionsYesNo = vehicleConditionsView.findViewById(R.id.tv_item_conditions_yes_no);
        tvItemConditionsYesNo.setId(position);
        tvItemConditionsYesNo.setText(ConstantsApi.alHMVehicleSmoke.get(position).get(ConstantsApi.KEYS_DROP_DOWN_SMOKE[1]));
        tvItemConditionsYesNo.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                setVisibilityLayout(lytVCSmokeYesNoList);
                setTextYesNo(tvVCSmoke, ConstantsApi.alHMVehicleSmoke.get(v.getId()).get(ConstantsApi.KEYS_DROP_DOWN_SMOKE[1]));
            }
        });
    }
    /* Accident Options Assign to UI */
    private void setAccidentOptions(int position){
//        lyt_vc_smoke_yes_no_list
        LayoutInflater inflater =(LayoutInflater)getSystemService(Context.LAYOUT_INFLATER_SERVICE);
        View vehicleConditionsView = inflater.inflate(R.layout.view_layout_conditions_yes_no, null);
        lytVCAccidentYesNoList.addView(vehicleConditionsView);
        TextView tvItemConditionsYesNo = vehicleConditionsView.findViewById(R.id.tv_item_conditions_yes_no);
        tvItemConditionsYesNo.setId(position);
        tvItemConditionsYesNo.setText(ConstantsApi.alHMVehicleAccident.get(position).get(ConstantsApi.KEYS_DROP_DOWN_ACCIDENT[1]));
        tvItemConditionsYesNo.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                setVisibilityLayout(lytVCAccidentYesNoList);
                setTextYesNo(tvVCAccident, ConstantsApi.alHMVehicleAccident.get(v.getId()).get(ConstantsApi.KEYS_DROP_DOWN_ACCIDENT[1]));
            }
        });
    }
    /* Api Data Assign to UI */
    private void setSmokeAccidentOptions(LinearLayout lytSmokeAccident, TextView tvSmokeAccident, ArrayList<HashMap<String, String>> alHMSmokeAccident, String KeyValue, int position){
        LayoutInflater inflater =(LayoutInflater)getSystemService(Context.LAYOUT_INFLATER_SERVICE);
        View vehicleConditionsView = inflater.inflate(R.layout.view_layout_conditions_yes_no, null);
        lytSmokeAccident.addView(vehicleConditionsView);
        TextView tv_item_conditions_yes = vehicleConditionsView.findViewById(R.id.tv_item_conditions_yes_no);
        tv_item_conditions_yes.setId(position);
        tv_item_conditions_yes.setText(alHMSmokeAccident.get(position).get(KeyValue));
        tv_item_conditions_yes.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                setVisibilityLayout(lytSmokeAccident);
                setTextYesNo(tvSmokeAccident, alHMSmokeAccident.get(v.getId()).get(KeyValue));
            }
        });

    }
    /* Db Values Assign to UI */
    private void setDBValuesToUI() {
        LoggerTradeIn.e(TAG, "setDBValuesToUI");
        if (ConstantsActivity.hmDBVehicles.size() == 0) {
            initSharedPrefs(ConstantsDB.SHARED_PREFS_SCREEN_KEY,getString(R.string.vehicle_condition));
            return;
        }
        setDBValue(tvVCInterior, ConstantsActivity.hmDBVehicles.get("interior_condition"));
        setDBValue(tvVCExterior, ConstantsActivity.hmDBVehicles.get("exterior_condition"));
        String strTrueFalse = "";
        if(ConstantsActivity.hmDBVehicles.get("smoked").equalsIgnoreCase("true")){
            strTrueFalse = "Yes";
        }else {
            strTrueFalse = "No";
        }
//        setDBValue(tvVCSmoke, ConstantsActivity.hmVehicles.get("smoked"));
        setDBValue(tvVCSmoke, strTrueFalse);
        if(ConstantsActivity.hmDBVehicles.get("accident").equalsIgnoreCase("true")){
            strTrueFalse = "Yes";
        }else {
            strTrueFalse = "No";
        }
//        setDBValue(tvVCAccident, ConstantsActivity.hmVehicles.get("accident"));
        setDBValue(tvVCAccident, strTrueFalse);
        setDBValue(etVCComments, ConstantsActivity.hmDBVehicles.get("comment"));
    }

    /*  Values Assign to UI */
    private void setUpdateValuesToUI() {
        if (ConstantsActivity.ACTIVITY_UPDATE_FLAG.equals(ConstantsActivity.ACTIVITY_UPDATE_FLAG_NEW)) {
            return;
        }
        setDBValue(tvVCInterior, ConstantsActivity.STR_VC_INTERIOR_CONDITIONS);
        setDBValue(tvVCExterior, ConstantsActivity.STR_VC_EXTERIOR_CONDITIONS);
//        String strTrueFalse = ConstantsActivity.STR_VC_SMOKED+"";
        String strTrueFalse = "";
        if(ConstantsActivity.STR_VC_SMOKED.equalsIgnoreCase("true")){
            strTrueFalse = "Yes";
        }else {
            strTrueFalse = "No";
        }
        setDBValue(tvVCSmoke, strTrueFalse);
        if(ConstantsActivity.STR_VC_ACCIDENT.equalsIgnoreCase("true")){
            strTrueFalse = "Yes";
        }else {
            strTrueFalse = "No";
        }
        setDBValue(tvVCAccident, strTrueFalse);
        setDBValue(etVCComments, ConstantsActivity.STR_VC_COMMENT);
    }
    /* Text View Value Assign */
    private void setDBValue(TextView textViewDB, String dbValue) {
        LoggerTradeIn.e(TAG, "setDBValue TextView");
        textViewDB.setText(dbValue);
        textViewDB.setTextColor(Color.BLACK);
    }
    /* Edit Text Value Assign */
    private void setDBValue(EditText editTextDB, String dbValue) {
        LoggerTradeIn.e(TAG, "setDBValue EditText");
        editTextDB.setText(dbValue);
        editTextDB.setTextColor(Color.BLACK);
    }
    //
    /* Common Intent  */
   /* private void intentKeyValueTwo(String key, ArrayList<String> listValue) {
        LoggerTradeIn.e(TAG, key + " Click ");
        Intent intent = new Intent(getApplicationContext(), RadioCustomActivity.class);
        intent.putStringArrayListExtra(key, listValue);
//        startActivityForResult(intent,1);
        mStartForResult.launch(intent);
    }*/
    /* Common Intent  */
    private void intentKeyValue(String key, ArrayList<HashMap<String, String>> listValue) {
        LoggerTradeIn.e(TAG, key + " Clicked");
        Intent intent = new Intent(getApplicationContext(), RadioCustomActivity.class);
        intent.putExtra(key, listValue);
        mStartForResult.launch(intent);
    }

    /* On Result Intent  */
    ActivityResultLauncher<Intent> mStartForResult = registerForActivityResult(new ActivityResultContracts.StartActivityForResult(),
            new ActivityResultCallback<ActivityResult>() {
                @Override
                public void onActivityResult(ActivityResult result) {
                    LoggerTradeIn.e(TAG, "onActivityResult ");
                    if (result.getResultCode() == Activity.RESULT_OK) {
                        Intent intent = result.getData();
                        // Handle the Intent
                        ConstantsActivity.SELECT_OPTION_RETURN_VALUE = intent.getStringExtra(ConstantsActivity.SELECT_OPTION_PASS);
                        setValue(ConstantsActivity.SELECT_OPTION_PASS, ConstantsActivity.SELECT_OPTION_RETURN_VALUE);
                    }
                }
            });

    /* Text View Value Assign */
    private void setValue(String passValue, String returnValue) {
        LoggerTradeIn.e(TAG, "setValue ");
        textViewHolder.setText(returnValue);
        textViewHolder.setTextColor(Color.BLACK);
    }

    /* Dialog Operations  */
    @Override
    public void sendDialogFlag(int flag) {
        LoggerTradeIn.e(TAG, "sendDialogFlag");
        if (flag == ConstantsDialog.FLAG_DIALOG_CANCEL_YES) {
//            finish();
        }
    }

    /* Layout Visibility Assign */
    private void setVisibilityLayout(LinearLayout lyt) {
        LoggerTradeIn.e(TAG, "setVisibilityLayout");
        if (lyt.getVisibility() == View.VISIBLE) {
            lyt.setVisibility(View.GONE);
        } else {
            lyt.setVisibility(View.VISIBLE);
        }
    }

    /* Text View Value Assign */
    private void setTextYesNo(TextView textViewYesNo, String strYesNo) {
        LoggerTradeIn.e(TAG, "setTextYesNo");
        textViewYesNo.setText(strYesNo);
        textViewYesNo.setTextColor(Color.BLACK);
    }

    /* On Click  */
    @Override
    public void onClick(View v) {
        LoggerTradeIn.e(TAG, "onClick");
        if (v.getId() == R.id.lyt_vc_interior) {
            LoggerTradeIn.e(TAG, "Click Interior");
            ConstantsActivity.ACTIVITY_TITLES = getString(R.string.select_interior_condition);
            textViewHolder = tvVCInterior;
//            ConstantsActivity.SELECT_OPTION_PASS = ConstantsActivity.SELECT_OPTION_PASS_CONDITION_INTERIOR;
//            intentKeyValueTwo(ConstantsActivity.SELECT_OPTION_PASS, ConstantsActivity.AL_CONDITION_INTERIOR);
            ConstantsActivity.SELECT_OPTION_PASS = ConstantsApi.KEYS_DROP_DOWN_INTERIOR_CONDITION[1];
//            ConstantsActivity.STR_RADIO_VALUE = ConstantsActivity.STR_VC_INTERIOR_CONDITIONS;
            ConstantsActivity.STR_RADIO_VALUE = tvVCInterior.getText().toString();
            intentKeyValue(ConstantsActivity.SELECT_OPTION_PASS, ConstantsApi.alHMInteriorVehicleConditions);
        } else if (v.getId() == R.id.lyt_vc_exterior) {
            LoggerTradeIn.e(TAG, "Click Exterior");
            ConstantsActivity.ACTIVITY_TITLES = getString(R.string.select_exterior_condition);
            textViewHolder = tvVCExterior;
            ConstantsActivity.SELECT_OPTION_PASS = ConstantsApi.KEYS_DROP_DOWN_EXTERIOR_CONDITION[1];
//            ConstantsActivity.STR_RADIO_VALUE = ConstantsActivity.STR_VC_EXTERIOR_CONDITIONS;
            ConstantsActivity.STR_RADIO_VALUE = tvVCExterior.getText().toString();
            intentKeyValue(ConstantsActivity.SELECT_OPTION_PASS, ConstantsApi.alHMExteriorVehicleConditions);
        } else if (v.getId() == R.id.lyt_vc_smoke_click) {
            LoggerTradeIn.e(TAG, "Click Smoke");
//            setVisibilityLayout(lytVCSmokeYesNo);
            setVisibilityLayout(lytVCSmokeYesNoList);
        } else if (v.getId() == R.id.lyt_vc_accident_click) {
            LoggerTradeIn.e(TAG, "Click Accident");
//            setVisibilityLayout(lytVCAccidentYesNo);
            setVisibilityLayout(lytVCAccidentYesNoList);
        } else if (v.getId() == R.id.tv_vc_smoke_yes) {
            LoggerTradeIn.e(TAG, "Click Smoke Yes");
            setVisibilityLayout(lytVCSmokeYesNo);
            setTextYesNo(tvVCSmoke, getString(R.string.yes));
        } else if (v.getId() == R.id.tv_vc_smoke_no) {
            LoggerTradeIn.e(TAG, "Click Smoke No");
            setVisibilityLayout(lytVCSmokeYesNo);
            setTextYesNo(tvVCSmoke, getString(R.string.no));
        } else if (v.getId() == R.id.tv_vc_accident_yes) {
            LoggerTradeIn.e(TAG, "Click Accident Yes");
            setVisibilityLayout(lytVCAccidentYesNo);
            setTextYesNo(tvVCAccident, getString(R.string.yes));
        } else if (v.getId() == R.id.tv_vc_accident_no) {
            LoggerTradeIn.e(TAG, "Click Accident No");
            setVisibilityLayout(lytVCAccidentYesNo);
            setTextYesNo(tvVCAccident, getString(R.string.no));
        } else if (v.getId() == R.id.tv_vc_cancel) {
            LoggerTradeIn.e(TAG, "Click Cancel");
            DialogCustomize dialogCustomize = DialogCustomize.getInstance();
            dialogCustomize.displayCancelDialog(this, ConstantsDialog.FLAG_DIALOG_DISPLAY, "", "");
        } else if (v.getId() == R.id.tv_vc_save) {
            LoggerTradeIn.e(TAG, "save click");
            String interiorVC = tvVCInterior.getText().toString();
            String exteriorVC = tvVCExterior.getText().toString();
            String smokeVC = tvVCSmoke.getText().toString();
            String accidentVC = tvVCAccident.getText().toString();
            String commentsVC = etVCComments.getText().toString().trim();

            if (interiorVC.length() < 1 || exteriorVC.length() < 1 || smokeVC.length() < 1
                    || accidentVC.length() < 1 || commentsVC.length() < 1
                    || interiorVC.contains(getString(R.string.select_space)) || exteriorVC.contains(getString(R.string.select_space))
                    || smokeVC.contains(getString(R.string.select_space)) || accidentVC.contains(getString(R.string.select_space))
                    || exteriorVC.contains(getString(R.string.select_space))) {

                if (commentsVC != null) {
                    commentsVC = "";
                }
                if (interiorVC.contains(getString(R.string.select_space))) {
                    interiorVC = "";
                }
                if (exteriorVC.contains(getString(R.string.select_space))) {
                    exteriorVC = "";
                }
                if (smokeVC.contains(getString(R.string.select_space))) {
                    smokeVC = "";
                }
                if (accidentVC.contains(getString(R.string.select_space))) {
                    accidentVC = "";
                }

//                ConstantsActivity.ERROR_MESSAGE_VALIDATE = getString(R.string.error_message_validate);
//                DialogCustomize dialogCustomize = DialogCustomize.getInstance();
//                dialogCustomize.displayValidationDialog(this, ConstantsDialog.FLAG_DIALOG_DISPLAY, "", ConstantsActivity.ERROR_MESSAGE_VALIDATE);
//                return;
            }

            DBOperations dbOperations = DBOperations.getInstance();
            dbOperations.updateVehicleCondition(this, ConstantsDB.dbVehicleIndex, ConstantsDB.dbUserIndex, "", false, 0.0,
                    interiorVC, exteriorVC, smokeVC, accidentVC, commentsVC);

            int vehicleInfoPercentage = (int) Math.round(ConstantsDB.dbVehiclePercentage);
            if (vehicleInfoPercentage < 81) {
                ConstantsDB.dbVehiclePercentage = 80;
                dbOperations.updateVehiclePercentage(this, ConstantsDB.dbVehicleIndex, ConstantsDB.dbVehiclePercentage);
            }

            /*if(ConstantsActivity.flagUpdateEdit){
                finish();
                return;
            }*/
            Intent in = new Intent(getApplicationContext(), VehicleMediaActivity.class);
            startActivity(in);
//            finish();
        }
    }
}
