package com.concatsys.tradein.tradein_plugin.activity;

import android.Manifest;
import android.app.Activity;
import android.content.ContentResolver;
import android.content.ContentValues;
import android.content.Context;
import android.content.Intent;
import android.content.pm.PackageManager;
import android.net.Uri;
import android.os.Build;
import android.os.Bundle;
import android.provider.MediaStore;
import android.util.Log;
import android.view.View;
import android.view.WindowManager;
import android.widget.ImageView;
import android.widget.TextView;

import androidx.activity.result.ActivityResult;
import androidx.activity.result.ActivityResultCallback;
import androidx.activity.result.ActivityResultLauncher;
import androidx.activity.result.contract.ActivityResultContracts;
import androidx.annotation.NonNull;
import androidx.annotation.RequiresApi;
import androidx.recyclerview.widget.GridLayoutManager;
import androidx.recyclerview.widget.LinearLayoutManager;
import androidx.recyclerview.widget.RecyclerView;

import com.concatsys.tradein.tradein_plugin.backblaze.FileTypes;
import com.concatsys.tradein.tradein_plugin.backblaze.fileuploader.ConstantsBB;
import com.concatsys.tradein.tradein_plugin.backblaze.fileuploader.MultiFile;
import com.concatsys.tradein.tradein_plugin.R;
import com.concatsys.tradein.tradein_plugin.adapter.VehicleMediaAdapter;
import com.concatsys.tradein.tradein_plugin.db.ConstantsDB;
import com.concatsys.tradein.tradein_plugin.db.DBOperations;
import com.concatsys.tradein.tradein_plugin.dialogsandviews.ConstantsDialog;
import com.concatsys.tradein.tradein_plugin.dialogsandviews.DialogCustomize;
import com.concatsys.tradein.tradein_plugin.interfaces.ActivityCallBack;
import com.concatsys.tradein.tradein_plugin.interfaces.DialogCallBack;
import com.concatsys.tradein.tradein_plugin.logs.LoggerTradeIn;
import com.concatsys.tradein.tradein_plugin.utils.DateAndTimeUtils;

import java.io.File;
import java.net.URLConnection;
import java.util.Iterator;
import java.util.Set;

public class VehicleMediaActivity extends BaseActivity implements View.OnClickListener, ActivityCallBack, DialogCallBack {
    private String TAG = getClass().getSimpleName();
    public static VehicleMediaActivity vehicleMediaActivity;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        ConstantsActivity.ACTIVITY_TITLES = getString(R.string.vehicle_media);
        super.setLayout(R.layout.activity_vehicle_media);
        super.onCreate(savedInstanceState);
        LoggerTradeIn.e(TAG, "alVMGridUri = " + ConstantsActivity.alVMGridUri.size());
        vehicleMediaActivity = this;
        mContext = this;
        initUI();
        checkPermissions();
    }

    private ImageView ivVMGallery, ivVMCamera;
    private TextView tvVMCancel, tvVMSave;

    /* Initialize UI */
    private void initUI() {
        LoggerTradeIn.e(TAG, "initUI");
        ivVMGallery = findViewById(R.id.iv_vm_gallery);
        ivVMGallery.setOnClickListener(this);
        ivVMCamera = findViewById(R.id.iv_vm_camera);
        ivVMCamera.setOnClickListener(this);
        tvVMCancel = findViewById(R.id.tv_vm_cancel);
        tvVMSave = findViewById(R.id.tv_vm_save);
        tvVMCancel.setOnClickListener(this);
        tvVMSave.setOnClickListener(this);
        this.getWindow().setSoftInputMode(WindowManager.LayoutParams.SOFT_INPUT_STATE_HIDDEN);

        if (ConstantsActivity.ACTIVITY_UPDATE_FLAG.equals(ConstantsActivity.ACTIVITY_UPDATE_FLAG_API)) {
            return;
        }
        setDBValuesToUI();
    }

    /* Text View Value Assign */
    private void setDBValuesToUI() {
        LoggerTradeIn.e(TAG, "setDBValuesToUI");
        if (ConstantsActivity.hmDBVehicles.size() == 0) {
            ConstantsActivity.alVMGridUri.clear();
            ConstantsActivity.alVMGridStr.clear();
            ConstantsBB.alMultiFile.clear();
            initSharedPrefs(ConstantsDB.SHARED_PREFS_SCREEN_KEY, getString(R.string.vehicle_media));
            return;
        }
    }

    //
    private void cameraImages() {
        LoggerTradeIn.e(TAG, "cameraImages");
//        Intent intentCamera = new Intent("android.media.action.IMAGE_CAPTURE");
        Intent intentCamera = new Intent(MediaStore.ACTION_IMAGE_CAPTURE);
        mCameraForResult.launch(intentCamera);
    }

    /* On Click  */
    @RequiresApi(api = Build.VERSION_CODES.N)
    @Override
    public void onClick(View v) {
        LoggerTradeIn.e(TAG, "View Clicked");
        if (v.getId() == R.id.iv_vm_gallery) {
            LoggerTradeIn.e(TAG, "Gallery Clicked");
            galleryImages();
        } else if (v.getId() == R.id.iv_vm_camera) {
            LoggerTradeIn.e(TAG, "Camera Clicked");
//            cameraImages();
//            startCameraImage();
            DialogCustomize dialogCustomize = DialogCustomize.getInstance();
            dialogCustomize.displayDialogCamera(this, ConstantsDialog.FLAG_DIALOG_DISPLAY, "", "");

//            startCameraVideo();
//            startCameraImageVideo();
//            startCameraImageVideo2();
//            startCameraImageVideo3();

        } else if (v.getId() == R.id.tv_vm_cancel) {
            LoggerTradeIn.e(TAG, "Cancel Clicked");
            DialogCustomize dialogCustomize = DialogCustomize.getInstance();
            dialogCustomize.displayCancelDialog(this, ConstantsDialog.FLAG_DIALOG_DISPLAY, "", "");
        } else if (v.getId() == R.id.tv_vm_save) {
            LoggerTradeIn.e(TAG, "Save Clicked");
            ConstantsActivity.alVMGridUri.forEach(uri -> ConstantsActivity.alVMGridStr.add(uri.toString()));

//            alVMGridStr = alVMGridUri;
            DBOperations dbOperations = DBOperations.getInstance();
            dbOperations.updateVehicleMediaContext(this, ConstantsDB.dbVehicleIndex, ConstantsDB.dbUserIndex, "",
                    "", ConstantsActivity.alVMGridStr, "", "", false, DateAndTimeUtils.getDateTimeFormat(), DateAndTimeUtils.getDateTimeFormat());

            int vehicleInfoPercentage = (int) Math.round(ConstantsDB.dbVehiclePercentage);
            if (vehicleInfoPercentage < 91) {
                ConstantsDB.dbVehiclePercentage = 90;
                dbOperations.updateVehiclePercentage(this, ConstantsDB.dbVehicleIndex, ConstantsDB.dbVehiclePercentage);
            }

            if (ConstantsActivity.flagUpdateEdit) {
//                finish();
//                return;
            }
            /*ConstantsApi.FLAG_API_NAME = ConstantsApi.FLAG_API_MEDIA;
            Intent serviceIntent = new Intent(this, ApiService.class);
            startService(serviceIntent);*/
            Intent in = new Intent(getApplicationContext(), UserProfileActivity.class);
            startActivity(in);
        }
    }

    /* Image Operations */
    private void galleryImages() {
        LoggerTradeIn.e(TAG, "Gallery Images");
//        Intent mediaChooser = new Intent(Intent.ACTION_GET_CONTENT);
        Intent mediaChooser = new Intent(Intent.ACTION_PICK, android.provider.MediaStore.Images.Media.EXTERNAL_CONTENT_URI);
        mediaChooser.setType("video/*, image/*");
        mediaChooser.putExtra(Intent.EXTRA_ALLOW_MULTIPLE, true);
//        mediaChooser.setAction(Intent.ACTION_GET_CONTENT);
        mGalleryForResult.launch(mediaChooser);
    }

    /* On Result Intent  */
    ActivityResultLauncher<Intent> mGalleryForResult = registerForActivityResult(new ActivityResultContracts.StartActivityForResult(),
            new ActivityResultCallback<ActivityResult>() {
                @Override
                public void onActivityResult(ActivityResult result) {
                    LoggerTradeIn.e(TAG, "onActivityResult");
                    if (result.getResultCode() == Activity.RESULT_OK) {
                        try {
                            if (result.getData().getData() == null) {
                                int imageUrlsCount = result.getData().getClipData().getItemCount();
                                LoggerTradeIn.e(TAG, imageUrlsCount + "");
                                for (int i = 0; i < imageUrlsCount; i++) {
                                    Uri browseImageUrl = result.getData().getClipData().getItemAt(i).getUri();
//                                    LoggerTradeIn.e(TAG, browseImageUrl + "");
                                    ConstantsActivity.alVMGridUri.add(browseImageUrl);
                                    MultiFile multiFile = new MultiFile();
                                    multiFile.init(browseImageUrl, new File(browseImageUrl.getPath()).getAbsolutePath(), FileTypes.IMAGE_TYPE);
                                    ConstantsBB.alMultiFile.add(multiFile);
                                    String strUriId = browseImageUrl.toString();
                                    int index = strUriId.lastIndexOf('/');
                                    ConstantsActivity.strUriCommon = strUriId.substring(0, index);
                                    ConstantsActivity.strUriIds = strUriId.substring(strUriId.lastIndexOf("/"));
                                    ConstantsActivity.strUriIds = ConstantsActivity.strUriIds.replace("/", "");
                                    LoggerTradeIn.e(TAG, ConstantsActivity.strUriIds + " @122");
                                }
                            } else {
                                Uri browseImageUrl = result.getData().getData();
                                ConstantsActivity.alVMGridUri.add(browseImageUrl);
                                MultiFile multiFile = new MultiFile();
                                multiFile.init(browseImageUrl, new File(browseImageUrl.getPath()).getAbsolutePath(), FileTypes.IMAGE_TYPE);
                                ConstantsBB.alMultiFile.add(multiFile);
                            }
                            vehicleMediaAdapter.notifyDataSetChanged();
                        } catch (Exception e) {
                            LoggerTradeIn.e(TAG, e.getMessage() + "");
                        }
                    }
                }
            });

    Uri cameraImageUri;

    /* Camera Operations */
    private void startCameraImage() {
        LoggerTradeIn.e(TAG, "start camera ");
        String fileName = "tradein.jpg";
        // Create parameters for Intent with filename
        ContentValues values = new ContentValues();
        values.put(MediaStore.Images.Media.TITLE, fileName);
        values.put(MediaStore.Images.Media.DESCRIPTION, "Image capture by camera");
        cameraImageUri =
                getContentResolver().insert(MediaStore.Images.Media.EXTERNAL_CONTENT_URI,
                        values);
        Intent intent = new Intent(MediaStore.ACTION_IMAGE_CAPTURE);
        intent.putExtra(MediaStore.EXTRA_OUTPUT, cameraImageUri);
        mCameraForResult.launch(intent);
    }

    /* Camera Operations */
    private void startCameraVideo() {
        LoggerTradeIn.e(TAG, "start camera ");
        String fileName = "tradein.jpg";
        // Create parameters for Intent with filename
        ContentValues values = new ContentValues();
        values.put(MediaStore.Images.Media.TITLE, fileName);
        values.put(MediaStore.Images.Media.DESCRIPTION, "Image capture by camera");
        cameraImageUri =
                getContentResolver().insert(MediaStore.Images.Media.EXTERNAL_CONTENT_URI,
                        values);
        Intent intent = new Intent(MediaStore.ACTION_VIDEO_CAPTURE);
        mCameraForResult.launch(intent);
    }

    private void startCameraImageVideo() {
        Intent takePictureIntent = new Intent(MediaStore.ACTION_IMAGE_CAPTURE);
        Intent takeVideoIntent = new Intent(MediaStore.ACTION_VIDEO_CAPTURE);
        Intent chooserIntent = Intent.createChooser(takePictureIntent, "Capture Image or Video");
        chooserIntent.putExtra(Intent.EXTRA_INITIAL_INTENTS, new Intent[]{takeVideoIntent});
        mCameraForResult.launch(chooserIntent);
//        startActivityForResult(chooserIntent, 1);

    }


    private void startCameraImageVideo2() {
        String fileName = "tradein.jpg";
        ContentValues values = new ContentValues();
        values.put(MediaStore.Images.Media.TITLE, fileName);
        values.put(MediaStore.Images.Media.DESCRIPTION, "Image capture by camera");
        cameraImageUri =
                getContentResolver().insert(MediaStore.Images.Media.EXTERNAL_CONTENT_URI,
                        values);

//        Intent intent = new Intent(MediaStore.INTENT_ACTION_STILL_IMAGE_CAMERA);
        Intent takePictureIntent = new Intent(MediaStore.ACTION_IMAGE_CAPTURE);
        Intent takeVideoIntent = new Intent(MediaStore.ACTION_VIDEO_CAPTURE);
        Intent chooserIntent = new Intent(Intent.ACTION_CHOOSER);
        Intent contentSelectionIntent = new Intent(Intent.ACTION_GET_CONTENT);
        contentSelectionIntent.addCategory(Intent.CATEGORY_OPENABLE);
        contentSelectionIntent.setType("*/*");
        Intent intentArray[] = new Intent[]{takePictureIntent, takeVideoIntent};
        chooserIntent.putExtra(Intent.EXTRA_INTENT, contentSelectionIntent);
        chooserIntent.putExtra(Intent.EXTRA_TITLE, "Choose an action");
        chooserIntent.putExtra(Intent.EXTRA_INITIAL_INTENTS, intentArray);
        chooserIntent.putExtra(MediaStore.EXTRA_OUTPUT, cameraImageUri);
        mCameraForResult.launch(chooserIntent);
//        startActivityForResult(chooserIntent, 1);
    }

    //
    private void startCameraImageVideo3() {
        Intent intent;
        intent = new Intent(Intent.ACTION_OPEN_DOCUMENT);
        intent.putExtra(Intent.EXTRA_ALLOW_MULTIPLE, true);
        intent.addFlags(Intent.FLAG_GRANT_PERSISTABLE_URI_PERMISSION);

        intent.putExtra(Intent.EXTRA_LOCAL_ONLY, true);
        intent.addFlags(Intent.FLAG_GRANT_READ_URI_PERMISSION);
        intent.setType("image/*");
        mCameraForResult.launch(intent);
//        startActivityForResult(Intent.createChooser(intent,""), 10);
    }

    /* On Result Intent  */
    ActivityResultLauncher<Intent> mCameraForResult = registerForActivityResult(new ActivityResultContracts.StartActivityForResult(),
            new ActivityResultCallback<ActivityResult>() {
                @Override
                public void onActivityResult(ActivityResult result) {
                    LoggerTradeIn.e(TAG, "onActivityResult");
                    if (result.getResultCode() == Activity.RESULT_OK) {
                        Uri browseImageUrl;
                        try {
                            browseImageUrl = result.getData().getData();
                        } catch (Exception e) {
                            browseImageUrl = null;
                        }
                        Log.e(TAG, browseImageUrl + " @281");

                       /* Intent intent = result.getData();
                        Log.e("intent", intent + "");
                        Bundle bundle = intent.getExtras();
                        if (bundle != null) {
                            for (String key : bundle.keySet()) {
                                Log.e(TAG, key + " : " + (bundle.get(key) != null ? bundle.get(key) : "NULL"));
                            }
                        }*/

                        /*if (browseImageUrl == null) {
                            getCameraImage(result);
                        } else {
                            getCameraVideo(result);
                        }*/

//                        getCameraImage(result);
                        Log.e(TAG, ConstantsDialog.FLAG_DIALOG_FLAG_CAPTURE + " @322");
                        if (ConstantsDialog.FLAG_DIALOG_FLAG_CAPTURE == ConstantsDialog.FLAG_DIALOG_IMAGE_CAPTURE) {
                            getCameraImage(result);
                        } else if (ConstantsDialog.FLAG_DIALOG_FLAG_CAPTURE == ConstantsDialog.FLAG_DIALOG_VIDEO_CAPTURE) {
                            getCameraVideo(result);
                        }
                    }
                }
            });

    public void dumpIntent(Intent i) {
        Bundle bundle = i.getExtras();
        if (bundle != null) {
            Set<String> keys = bundle.keySet();
            Iterator<String> it = keys.iterator();
            Log.e(TAG, "Dumping Intent start");
            while (it.hasNext()) {
                String key = it.next();
                Log.e(TAG, "[" + key + "=" + bundle.get(key) + "]");
            }
            Log.e(TAG, "Dumping Intent end");
        }
    }

    private void getCameraVideo(ActivityResult result) {
        LoggerTradeIn.e(TAG, cameraImageUri + " @288");
        Uri browseImageUrl = result.getData().getData();
        cameraImageUri = browseImageUrl;
        LoggerTradeIn.e(TAG, cameraImageUri + " @290");
        ContentResolver cR = getContentResolver();
        String type = cR.getType(cameraImageUri);
        Log.e("type@245", type + "");
        ConstantsActivity.alVMGridUri.add(cameraImageUri);
        MultiFile multiFile = new MultiFile();
//                        multiFile.init(cameraImageUri, new File(cameraImageUri.getPath()).getAbsolutePath(), FileTypes.IMAGE_TYPE);
        multiFile.init(cameraImageUri, new File(cameraImageUri.getPath()).getAbsolutePath(), FileTypes.VIDEO_MPEG_TYPE);
        ConstantsBB.alMultiFile.add(multiFile);
        vehicleMediaAdapter.notifyDataSetChanged();
        String strUriId = cameraImageUri.toString();
        int index = strUriId.lastIndexOf('/');
        ConstantsActivity.strUriCommon = strUriId.substring(0, index);
        ConstantsActivity.strUriIds = strUriId.substring(strUriId.lastIndexOf("/"));
        ConstantsActivity.strUriIds = ConstantsActivity.strUriIds.replace("/", "");
        LoggerTradeIn.e(TAG, ConstantsActivity.strUriIds + " @172");
    }

    private void getCameraImage(ActivityResult result) {

        LoggerTradeIn.e(TAG, cameraImageUri + " @311");
//        Uri browseImageUrl = result.getData().getData();
//        cameraImageUri = browseImageUrl;
        LoggerTradeIn.e(TAG, cameraImageUri + " @313");
        ContentResolver cR = getContentResolver();
        String type = cR.getType(cameraImageUri);
        Log.e("type@245", type + "");
        ConstantsActivity.alVMGridUri.add(cameraImageUri);
        MultiFile multiFile = new MultiFile();
        multiFile.init(cameraImageUri, new File(cameraImageUri.getPath()).getAbsolutePath(), FileTypes.IMAGE_TYPE);
//        multiFile.init(cameraImageUri, new File(cameraImageUri.getPath()).getAbsolutePath(), FileTypes.VIDEO_MPEG_TYPE);
        ConstantsBB.alMultiFile.add(multiFile);
        vehicleMediaAdapter.notifyDataSetChanged();
        String strUriId = cameraImageUri.toString();
        int index = strUriId.lastIndexOf('/');
        ConstantsActivity.strUriCommon = strUriId.substring(0, index);
        ConstantsActivity.strUriIds = strUriId.substring(strUriId.lastIndexOf("/"));
        ConstantsActivity.strUriIds = ConstantsActivity.strUriIds.replace("/", "");
        LoggerTradeIn.e(TAG, ConstantsActivity.strUriIds + " @172");

    }

    //
    public static boolean isVideoFile(String path) {
        String mimeType = URLConnection.guessContentTypeFromName(path);
        return mimeType != null && mimeType.startsWith("video");
    }

    /* Permission Camera and Storage */
    private void checkPermissions() {
        LoggerTradeIn.e(TAG, "check permissions ");
        if (checkSelfPermission(Manifest.permission.CAMERA)
                != PackageManager.PERMISSION_GRANTED ||
                checkSelfPermission(Manifest.permission.WRITE_EXTERNAL_STORAGE)
                        != PackageManager.PERMISSION_GRANTED ||
                checkSelfPermission(Manifest.permission.READ_EXTERNAL_STORAGE)
                        != PackageManager.PERMISSION_GRANTED
        ) {
            requestPermissions(new String[]{
                            Manifest.permission.CAMERA,
                            Manifest.permission.WRITE_EXTERNAL_STORAGE,
                            Manifest.permission.READ_EXTERNAL_STORAGE},
                    1);
        } else {
            populateVMGrid();
        }

    }

    /* Permission Request */
    @Override
    public void onRequestPermissionsResult(int requestCode, @NonNull String[] permissions, @NonNull int[] grantResults) {
        super.onRequestPermissionsResult(requestCode, permissions, grantResults);
        LoggerTradeIn.e(TAG, "onRequestPermissionsResult");
        checkPermissions();
    }

    private Context mContext;
    private VehicleMediaAdapter vehicleMediaAdapter;
    private RecyclerView vmRecyclerGrid;

    /* Initialize Grid View */
    private void populateVMGrid() {
        LoggerTradeIn.e(TAG, "populate grid view ");
        vmRecyclerGrid = findViewById(R.id.vm_recycler_view_images);
        vmRecyclerGrid.setHasFixedSize(true);

        GridLayoutManager vmGridLayoutManager = new GridLayoutManager(getApplicationContext(), 3);
        vmGridLayoutManager.setOrientation(LinearLayoutManager.VERTICAL); // set Horizontal Orientation
        vmRecyclerGrid.setLayoutManager(vmGridLayoutManager);

//        ConstantsActivity.alVMGridUri = new ArrayList<>();
//        alVMGridUri.add(Uri.parse("content://media/external/images/media/14993"));
//        alVMGridUri.add(Uri.parse("content://media/external/images/media/14995"));
//        alVMGridUri.add(Uri.parse("content://media/external/images/media/1"));

        LoggerTradeIn.e(TAG, "alVMGridUri = " + ConstantsActivity.alVMGridUri.size());
        vehicleMediaAdapter = new VehicleMediaAdapter(mContext, ConstantsActivity.alVMGridUri);
        vmRecyclerGrid.setAdapter(vehicleMediaAdapter);
        LoggerTradeIn.e(TAG, ConstantsActivity.alVMGridUri.size() + "@#");

    }

    /* Dialog Operations  */
    @Override
    public void sendDialogFlag(int flag) {
        LoggerTradeIn.e(TAG, "sendDialogFlag");
        ConstantsDialog.FLAG_DIALOG_FLAG_CAPTURE = flag;
        if (flag == ConstantsDialog.FLAG_DIALOG_CANCEL_YES) {
//            finish();
        }

        if (flag == ConstantsDialog.FLAG_DIALOG_IMAGE_CAPTURE) {
            startCameraImage();
        } else if (flag == ConstantsDialog.FLAG_DIALOG_VIDEO_CAPTURE) {
            startCameraVideo();
        }

    }

    @Override
    public void callActivity(String strResponse) {
        LoggerTradeIn.e(TAG, strResponse + " @266");

//        finish();
    }
}
