package com.concatsys.tradein.tradein_plugin.adapter;

import android.content.Context;
import android.view.Gravity;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.LinearLayout;
import android.widget.TextView;

import androidx.recyclerview.widget.RecyclerView;

import com.concatsys.tradein.tradein_plugin.R;

import java.util.ArrayList;

public class ChattingAdapter extends RecyclerView.Adapter<ChattingAdapter.RecyclerViewHolder> {

    static class RecyclerViewHolder extends RecyclerView.ViewHolder {

        TextView text_message_name;
        RecyclerViewHolder(View view) {
            super(view);
            text_message_name =  view.findViewById(R.id.text_message_name_v2);
        }
    }

    private ArrayList<String> alChatCustom;
    private ArrayList<String> alChatCustomTwo;
    private Context context;
    private int selectedPosition = -1;
    private int layoutId ;
    public ChattingAdapter(Context context, ArrayList<String> alChatCustom, ArrayList<String> alChatCustomTwo, int layoutId) {
        this.alChatCustom = alChatCustom;
        this.alChatCustomTwo = alChatCustomTwo;
        this.layoutId = layoutId;
        this.context = context;
    }

    @Override
    public RecyclerViewHolder onCreateViewHolder(ViewGroup viewGroup, int i) {
        View v = LayoutInflater.from(viewGroup.getContext()).inflate(layoutId, viewGroup, false);
        return new RecyclerViewHolder(v);
    }

    @Override
    public void onBindViewHolder(final RecyclerViewHolder holder, final int i) {
        LinearLayout.LayoutParams params = new LinearLayout.LayoutParams(ViewGroup.LayoutParams.WRAP_CONTENT, ViewGroup.LayoutParams.MATCH_PARENT);
        /*if(i%2 == 0){
            params.gravity = Gravity.RIGHT;
        } else {
            params.gravity = Gravity.LEFT;
        }*/
        if(alChatCustom.get(i).equals("send")){
            params.gravity = Gravity.RIGHT;
            holder.text_message_name.setBackgroundResource(R.drawable.chat_receive_message);
        } else {
            params.gravity = Gravity.LEFT;
            holder.text_message_name.setBackgroundResource(R.drawable.chat_send_message);
        }
        holder.text_message_name.setLayoutParams(params);
        holder.text_message_name.setText(alChatCustom.get(i));

    }

    //On selecting any view set the current position to selectedPositon and notify adapter
    private void itemCheckChanged(View v) {
        selectedPosition = (Integer) v.getTag();
        notifyDataSetChanged();
    }


    @Override
    public int getItemCount() {
        return alChatCustom.size();
    }

    //Return the selectedPosition item
    public String getSelectedItem() {
        if (selectedPosition != -1) {
//            Toast.makeText(context, "Selected Item : " + alRadioCustom.get(selectedPosition), Toast.LENGTH_SHORT).show();
            return alChatCustom.get(selectedPosition);
        }
        return "";
    }

    //Delete the selected position from the arrayList
    public void deleteSelectedPosition() {
        if (selectedPosition != -1) {
            alChatCustom.remove(selectedPosition);
            selectedPosition = -1;//after removing selectedPosition set it back to -1
            notifyDataSetChanged();
        }
    }
    /*public class ViewHolder extends RecyclerView.ViewHolder {
        ViewHolder(@NonNull View itemView) {
            super(itemView);

        }
    }*/

}
