package com.concatsys.tradein.tradein_plugin.adapter;

import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.TextView;

import androidx.annotation.NonNull;
import androidx.recyclerview.widget.DiffUtil;
import androidx.recyclerview.widget.ListAdapter;
import androidx.recyclerview.widget.RecyclerView;

import com.concatsys.tradein.tradein_plugin.R;
import com.concatsys.tradein.tradein_plugin.db.DBVehiclesModel;

public class DBMessageAdapter  extends ListAdapter<DBVehiclesModel, DBMessageAdapter.ViewHolder> {
    //creating a variable for on item click listner.
    private DBMessageAdapter.OnItemClickListener itemClickListener;

    //creating a constructor class for our adapter class.
    public DBMessageAdapter() {
        super(DIFF_CALLBACK);
    }

    //creating a call back for item of recycler view.
    private static final DiffUtil.ItemCallback<DBVehiclesModel> DIFF_CALLBACK = new DiffUtil.ItemCallback<DBVehiclesModel>() {
        @Override
        public boolean areItemsTheSame(DBVehiclesModel oldItem, DBVehiclesModel newItem) {
            return oldItem.getVehicle_id() == newItem.getVehicle_id();
        }

        @Override
        public boolean areContentsTheSame(DBVehiclesModel oldItemDBVehiclesModel, DBVehiclesModel newItemDBVehiclesModel) {
            //below line is to check the  name, description and  duration.
            return oldItemDBVehiclesModel.getVehicle_year().equals(newItemDBVehiclesModel.getVehicle_make()) &&
                    oldItemDBVehiclesModel.getVehicle_model().equals(newItemDBVehiclesModel.getVehicle_trim()) &&
                    oldItemDBVehiclesModel.getVehicle_mileage().equals(newItemDBVehiclesModel.getVehicle_vin());
        }
    };

    @NonNull
    @Override
    public DBMessageAdapter.ViewHolder onCreateViewHolder(@NonNull ViewGroup parent, int viewType) {
        //below line is use to inflate our layout file for each item of our recycler view.
        View item = LayoutInflater.from(parent.getContext())
                .inflate(R.layout.view_item_message_chat, parent, false);
        return new DBMessageAdapter.ViewHolder(item);
    }

    @Override
    public void onBindViewHolder(@NonNull DBMessageAdapter.ViewHolder holder, int position) {
        //below line of code is use to set data to each item of our recycler view.
        DBVehiclesModel model = getValuesInAt(position);
    }

    //creating a method to get  model for a specific position.
    public DBVehiclesModel getValuesInAt(int position) {
        return getItem(position);
    }

    public class ViewHolder extends RecyclerView.ViewHolder {
        //view holder class to create a variable for each view.
        TextView tvMessageName , tvMessageTrim;
        ViewHolder(@NonNull View itemView) {
            super(itemView);
            //initializing each view of our recycler view.
            tvMessageName = itemView.findViewById(R.id.text_message_name);
            tvMessageTrim = itemView.findViewById(R.id.text_message_trim);

            //adding on click listner for each item of recycler view.
            /*itemView.setOnClickListener(new View.OnClickListener() {
                @Override
                public void onClick(View v) {
                    //inside on click listner we are passing position to our item of recycler view.
                    int position = getAdapterPosition();
                    if (itemClickListener != null && position != RecyclerView.NO_POSITION) {
                        itemClickListener.onItemClick(getItem(position));
                    }
                }
            });*/

        }
    }

    public interface OnItemClickListener {
        void onItemClick(DBVehiclesModel model);
    }

    /* On Click */
    public void setOnItemClickListener(DBMessageAdapter.OnItemClickListener listener) {
        this.itemClickListener = listener;
    }
}

