package com.concatsys.tradein.tradein_plugin.adapter;

import android.content.Context;
import android.content.Intent;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.LinearLayout;

import androidx.recyclerview.widget.RecyclerView;

import com.concatsys.tradein.tradein_plugin.R;
import com.concatsys.tradein.tradein_plugin.activity.ChattingMessageActivity;
import com.concatsys.tradein.tradein_plugin.logs.LoggerTradeIn;

import java.util.ArrayList;

public class DummyDataAdapter extends RecyclerView.Adapter<DummyDataAdapter.RecyclerViewHolder> {
    private String TAG = getClass().getSimpleName();
    static class RecyclerViewHolder extends RecyclerView.ViewHolder {
        LinearLayout lyt_message_chat;
        RecyclerViewHolder(View view) {
            super(view);
            lyt_message_chat = view.findViewById(R.id.lyt_message_chat);
        }
    }

    private ArrayList<String> alRadioCustom;
    private ArrayList<String> alRadioCustomTwo;
    private Context mContext;
    private int selectedPosition = -1;
    private int layoutId ;
    public DummyDataAdapter(Context mContext, ArrayList<String> alRadioCustom, ArrayList<String> alRadioCustomTwo, int layoutId) {
        this.alRadioCustom = alRadioCustom;
        this.alRadioCustomTwo = alRadioCustomTwo;
        this.layoutId = layoutId;
        this.mContext = mContext;
    }

    @Override
    public DummyDataAdapter.RecyclerViewHolder onCreateViewHolder(ViewGroup viewGroup, int i) {
        View v = LayoutInflater.from(viewGroup.getContext()).inflate(layoutId, viewGroup, false);
        /*v.setId(i);
        v.setTag(i);
        v.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                LoggerTradeIn.e(TAG, v.getId()+"");
            }
        });*/
        return new DummyDataAdapter.RecyclerViewHolder(v);
    }

    @Override
    public void onBindViewHolder(final DummyDataAdapter.RecyclerViewHolder holder, final int i) {
        holder.lyt_message_chat.setId(i);
        holder.lyt_message_chat.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                LoggerTradeIn.e(TAG, v.getId()+"");
                Intent in = new Intent(mContext, ChattingMessageActivity.class);
                mContext.startActivity(in);
            }
        });
    }

    //On selecting any view set the current position to selectedPositon and notify adapter
    private void itemCheckChanged(View v) {
        selectedPosition = (Integer) v.getTag();
        notifyDataSetChanged();
    }


    @Override
    public int getItemCount() {
        return 4;
    }

    //Return the selectedPosition item
    public String getSelectedItem() {
        if (selectedPosition != -1) {
//            Toast.makeText(context, "Selected Item : " + alRadioCustom.get(selectedPosition), Toast.LENGTH_SHORT).show();
            return alRadioCustom.get(selectedPosition);
        }
        return "";
    }

    //Delete the selected position from the arrayList
    public void deleteSelectedPosition() {
        if (selectedPosition != -1) {
            alRadioCustom.remove(selectedPosition);
            selectedPosition = -1;//after removing selectedPosition set it back to -1
            notifyDataSetChanged();
        }
    }
}
