package com.concatsys.tradein.tradein_plugin.adapter;

import android.content.Context;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.LinearLayout;
import android.widget.RadioButton;
import android.widget.TextView;

import androidx.recyclerview.widget.RecyclerView;

import com.concatsys.tradein.tradein_plugin.R;
import com.concatsys.tradein.tradein_plugin.activity.ConstantsActivity;
import com.concatsys.tradein.tradein_plugin.activity.RadioCustomActivity;

import java.util.ArrayList;
import java.util.HashMap;

public class RadioCustomAdapter extends RecyclerView.Adapter<RadioCustomAdapter.RecyclerViewHolder> {

    static class RecyclerViewHolder extends RecyclerView.ViewHolder {

        private TextView tvRadioOne, tvRadioTwo;
        private RadioButton radioButton;
        private LinearLayout lytRadioCustom;

        RecyclerViewHolder(View view) {
            super(view);
            tvRadioOne = (TextView) view.findViewById(R.id.tvRadioOne);
            tvRadioTwo = (TextView) view.findViewById(R.id.tvRadioTwo);
            radioButton = (RadioButton) view.findViewById(R.id.radio_button_custom);
            lytRadioCustom = view.findViewById(R.id.lyt_radio_custom);
        }
    }

    private ArrayList<HashMap<String, String>> alRadioCustom;
    private ArrayList<String> alRadioCustomTwo;
    private Context context;
    private int selectedPosition = -1;

    public RadioCustomAdapter(Context context, ArrayList<HashMap<String, String>> alRadioCustom, ArrayList<String> alRadioCustomTwo) {
        this.alRadioCustom = alRadioCustom;
        this.alRadioCustomTwo = alRadioCustomTwo;
        this.context = context;
    }

    @Override
    public RecyclerViewHolder onCreateViewHolder(ViewGroup viewGroup, int i) {
        View v = LayoutInflater.from(viewGroup.getContext()).inflate(R.layout.view_radio_item, viewGroup, false);
        return new RecyclerViewHolder(v);
    }

    @Override
    public void onBindViewHolder(final RecyclerViewHolder holder, final int i) {

        holder.tvRadioOne.setText(alRadioCustom.get(i).get(ConstantsActivity.SELECT_OPTION_PASS));
        holder.tvRadioTwo.setText(alRadioCustomTwo.get(i));

        //check the radio button if both position and selectedPosition matches
        holder.radioButton.setChecked(i == selectedPosition);

        //Set the position tag to both radio button and label
        holder.radioButton.setTag(i);
        holder.tvRadioOne.setTag(i);
        holder.tvRadioTwo.setTag(i);
        holder.lytRadioCustom.setTag(i);
        Log.e("i@68", i + "");
        Log.e("radioPosition@68", RadioCustomActivity.radioPosition + "");
        if (i == RadioCustomActivity.radioPosition) {
            if (RadioCustomActivity.flagRadio) {
                RadioCustomActivity.flagRadio = false;
                holder.radioButton.setChecked(true);
            }
        }

        holder.radioButton.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                itemCheckChanged(v);
            }
        });

        holder.tvRadioOne.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                itemCheckChanged(v);
            }
        });

        holder.tvRadioTwo.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                itemCheckChanged(v);
            }
        });

        holder.lytRadioCustom.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                itemCheckChanged(v);
            }
        });
    }

    //On selecting any view set the current position to selectedPositon and notify adapter
    private void itemCheckChanged(View v) {
        selectedPosition = (Integer) v.getTag();
        notifyDataSetChanged();
    }


    @Override
    public int getItemCount() {
        return (null != alRadioCustom ? alRadioCustom.size() : 0);
    }

    //Return the selectedPosition item
    public String getSelectedItem() {
        if (selectedPosition != -1) {
//            Toast.makeText(context, "Selected Item : " + alRadioCustom.get(selectedPosition), Toast.LENGTH_SHORT).show();
            return alRadioCustom.get(selectedPosition).get(ConstantsActivity.SELECT_OPTION_PASS);
        }
        return "";
    }

    //Delete the selected position from the arrayList
    public void deleteSelectedPosition() {
        if (selectedPosition != -1) {
            alRadioCustom.remove(selectedPosition);
            selectedPosition = -1;//after removing selectedPosition set it back to -1
            notifyDataSetChanged();
        }
    }

}