package com.concatsys.tradein.tradein_plugin.adapter;

import android.content.Context;
import android.net.Uri;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ImageView;
import android.widget.Toast;

import androidx.recyclerview.widget.RecyclerView;

import com.concatsys.tradein.tradein_plugin.backblaze.fileuploader.ConstantsBB;
import com.bumptech.glide.Glide;
import com.bumptech.glide.load.engine.DiskCacheStrategy;
import com.bumptech.glide.request.RequestOptions;
import com.concatsys.tradein.tradein_plugin.R;
import com.concatsys.tradein.tradein_plugin.activity.ConstantsActivity;
import com.concatsys.tradein.tradein_plugin.logs.LoggerTradeIn;

import java.io.InputStream;
import java.util.ArrayList;

public class VehicleMediaAdapter extends RecyclerView.Adapter<VehicleMediaAdapter.GridViewViewHolder> {
    private String TAG = getClass().getSimpleName();

    static class GridViewViewHolder extends RecyclerView.ViewHolder {

        private ImageView ivVMGalleryImages, ivVMDelete;

        GridViewViewHolder(View view) {
            super(view);
            ivVMGalleryImages = view.findViewById(R.id.iv_vm_images_videos);
            ivVMDelete = view.findViewById(R.id.iv_vm_delete);
        }

    }

    private ArrayList<Uri> alVMImages;
    private Context mContext;
    private int selectedPosition = -1;

    public VehicleMediaAdapter(Context mContext, ArrayList<Uri> alVMImages) {
        this.alVMImages = alVMImages;
        this.mContext = mContext;
    }

    @Override
    public GridViewViewHolder onCreateViewHolder(ViewGroup viewGroup, int i) {
        View v = LayoutInflater.from(viewGroup.getContext()).inflate(R.layout.view_vm_grid_item, viewGroup, false);
        return new GridViewViewHolder(v);
    }

    @Override
    public void onBindViewHolder(final GridViewViewHolder holder, final int position) {
        holder.ivVMGalleryImages.setId(position);
        holder.ivVMDelete.setId(position);

//        Glide.with(mContext).load(arrayList.get(i)).into(holder.iv_media_images_videos);
        LoggerTradeIn.e(TAG, "alVMImages " + alVMImages.get(position));
        int mediaImgWidthHeight = 200;
        if (ConstantsActivity.ACTIVITY_UPDATE_FLAG.equals(ConstantsActivity.ACTIVITY_UPDATE_FLAG_API)) {
            Glide.with(mContext)
                    .load(alVMImages.get(position).toString())
//                    .apply(new RequestOptions().override(mediaImgWidthHeight, mediaImgWidthHeight))
//                    .placeholder(R.drawable.placeholder_image)
                    .thumbnail( 0.5f )
                    .diskCacheStrategy( DiskCacheStrategy.ALL )
                    .into(holder.ivVMGalleryImages);
        } else {
            if (checkUri(alVMImages.get(position))) {
                Glide.with(mContext).load(alVMImages.get(position)).into(holder.ivVMGalleryImages);
            } else {
                Uri uri = Uri.parse("android.resource://" + mContext.getPackageName() + "/" + R.drawable.ic_image_not_found);
                Glide.with(mContext).load(uri).into(holder.ivVMGalleryImages);
            }
        }

        holder.ivVMGalleryImages.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                LoggerTradeIn.e(TAG, "Gallery Clicked");
                selectedPosition = v.getId();
                getSelectedItem(selectedPosition);
                Toast.makeText(mContext, "" + v.getId(), Toast.LENGTH_SHORT).show();
            }
        });

        holder.ivVMDelete.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                LoggerTradeIn.e(TAG, "Delete Clicked");
                selectedPosition = v.getId();
                deleteSelectedPosition(selectedPosition);
                Toast.makeText(mContext, "" + v.getId(), Toast.LENGTH_SHORT).show();
            }
        });
    }

    //On selecting any view set the current position to selectedPositon and notify adapter
    private void itemCheckChanged(View v) {
//        selectedPosition = (Integer) v.getTag();
//        notifyDataSetChanged();
    }


    @Override
    public int getItemCount() {
        return (null != alVMImages ? alVMImages.size() : 0);
    }

    //Return the selectedPosition item
    public String getSelectedItem(int clickPositionItem) {
        if (this.selectedPosition != -1) {
            Toast.makeText(mContext, "Selected Item : " + alVMImages.get(this.selectedPosition), Toast.LENGTH_SHORT).show();
            return alVMImages.get(this.selectedPosition) + "";
        }
        return "";
    }

    /* URI Validation */
    private boolean checkUri(Uri imageUrl) {
        InputStream is = null;
        try {
            is = mContext.getContentResolver().openInputStream(imageUrl);
            return true;
        } catch (Exception e) {
            e.printStackTrace();
            return false;
        }
    }

    //Delete the selected position from the arrayList
    public void deleteSelectedPosition(int clickPositionItem) {
        if (this.selectedPosition != -1) {
            alVMImages.remove(this.selectedPosition);
            ConstantsBB.alMultiFile.remove(this.selectedPosition);
            this.selectedPosition = -1;//after removing selectedPosition set it back to -1
            notifyDataSetChanged();
        }
    }
}