package com.concatsys.tradein.tradein_plugin.api;

import android.content.Context;
import android.os.StrictMode;
import android.widget.Toast;

import com.concatsys.tradein.tradein_plugin.backblaze.fileuploader.ConstantsBB;
import com.concatsys.tradein.tradein_plugin.interfaces.ApiCallback;
import com.concatsys.tradein.tradein_plugin.logs.LoggerTradeIn;

import org.json.JSONArray;
import org.json.JSONObject;

import java.io.BufferedInputStream;
import java.io.BufferedReader;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.net.HttpURLConnection;
import java.net.URL;


public class ApiHttpCall {
    private Context mContext;
    private String TAG = getClass().getSimpleName();
    private static ApiHttpCall instance = null;

    private ApiHttpCall() {
    }

    public static ApiHttpCall getInstance() {
        if (instance == null) {
            instance = new ApiHttpCall();
        }
        return instance;
    }

    /*ApiServiceCall(Context context) {
        mContext = context;
    }*/

    //
    public void httpUrlCalls() {
        LoggerTradeIn.e(TAG, "httpUrlCalls");
        try {
            StrictMode.ThreadPolicy policy =
                    new StrictMode.ThreadPolicy.Builder().permitAll().build();
            StrictMode.setThreadPolicy(policy);
//            String strUrl = ConstantsApi.BASE_URL + ConstantsApi.CONTACTS_URL;
            String strUrl = ConstantsApi.API_CALL_URL;
            LoggerTradeIn.e(TAG, strUrl + "");
            URL url = new URL(strUrl);
//            HttpsURLConnection urlConnection = (HttpsURLConnection) url.openConnection();
            HttpURLConnection urlConnection = (HttpURLConnection) url.openConnection();
            urlConnection.setRequestProperty("Content-Type", "application/json");
            urlConnection.setRequestMethod("GET");   //POST or GET
            urlConnection.connect();
            urlConnection.setConnectTimeout(ConstantsApi.API_CONNECTION_TIME_OUT);
            urlConnection.setReadTimeout(ConstantsApi.API_CONNECTION_TIME_OUT);
            // Check the connection status.
            LoggerTradeIn.e(TAG, "5");
            int statusCode = urlConnection.getResponseCode();
            LoggerTradeIn.e(TAG, statusCode + " @63");
            if (statusCode == 200) {
                InputStream inputStream = new BufferedInputStream(urlConnection.getInputStream());
                InputStreamReader inputStreamReader = new InputStreamReader(inputStream);
                BufferedReader bufferedReader = new BufferedReader(inputStreamReader);
                StringBuilder stringBuilder = new StringBuilder();
                String responseBits;
                while ((responseBits = bufferedReader.readLine()) != null) {
                    stringBuilder.append(responseBits);
                }
                String responseData = stringBuilder.toString();
//                LoggerTradeIn.e(TAG,responseData+"@73");
//                return responseData;
                ConstantsApi.apiResponseData = responseData;
//                LoggerTradeIn.e(TAG, ConstantsApi.apiResponseData+"");
                LoggerTradeIn.e(TAG, "apiResponseData");

            } else {
//                Toast.makeText(mContext, "Error Code : " + statusCode, Toast.LENGTH_SHORT).show();
                LoggerTradeIn.e(TAG, "Error Code : " + statusCode);
            }
        } catch (Exception e) {
            e.printStackTrace();
            LoggerTradeIn.e(TAG, e.getMessage() + " @70");
            LoggerTradeIn.e(TAG, e + " @70");
        }
    }

    //
    public void httpUrlCallS(Context context) {
        mContext = context;
        LoggerTradeIn.e(TAG, "HTTP httpUrlCalls");
        LoggerTradeIn.e(TAG, ConstantsApi.API_GET_POST);
        try {
            StrictMode.ThreadPolicy policy =
                    new StrictMode.ThreadPolicy.Builder().permitAll().build();
            StrictMode.setThreadPolicy(policy);
//            String strUrl = ConstantsApi.BASE_URL + ConstantsApi.CONTACTS_URL;
            String strUrl = ConstantsApi.API_CALL_URL;
            LoggerTradeIn.e(TAG, strUrl + " ##**");
            URL url = new URL(strUrl);
            HttpURLConnection urlConnection = (HttpURLConnection) url.openConnection();
            urlConnection.setRequestProperty("Content-Type", "application/json");
            urlConnection.setRequestMethod(ConstantsApi.API_GET_POST);   //POST or GET
            urlConnection.setDoOutput(true);
            urlConnection.setDoInput(true);

            if (ConstantsApi.FLAG_API_NAME.equalsIgnoreCase(ConstantsApi.FLAG_API_MEDIA)) {
                JSONArray jsonArray = new JSONArray();
                for (int i = 0; i < ConstantsBB.alImageNameExtension.size(); i++) {
                    String strUrlPath = ConstantsBB.BLACK_BASE_URL+ConstantsBB.alImageNameExtension.get(i);
//                    strUrlPath = strUrlPath.replaceAll("\\\\", "").trim();
                    LoggerTradeIn.e(TAG, "url - "+strUrlPath);
                    JSONObject jsonObject = new JSONObject();
                    jsonObject.put("url", strUrlPath);
                    jsonObject.put("description", "TradeIn");
                    jsonArray.put(jsonObject);
                }
                LoggerTradeIn.e(TAG, jsonArray + " @70");
                String strJsonArray = jsonArray.toString().replaceAll("\\\\", "").trim();
                LoggerTradeIn.e(TAG, strJsonArray + " @123");
// Write Request to output stream to server.
                OutputStreamWriter out = new OutputStreamWriter(urlConnection.getOutputStream());
//                out.write(jsonArray.toString().replaceAll("\\\\", "").trim());
                out.write(strJsonArray);
                out.close();
            }

            urlConnection.connect();
            urlConnection.setConnectTimeout(ConstantsApi.API_CONNECTION_TIME_OUT);
            urlConnection.setReadTimeout(ConstantsApi.API_CONNECTION_TIME_OUT);
            // Check the connection status.
            int statusCode = urlConnection.getResponseCode();
            LoggerTradeIn.e(TAG, statusCode + " @136");
            if (statusCode == 200) {
                InputStream inputStream = new BufferedInputStream(urlConnection.getInputStream());
                InputStreamReader inputStreamReader = new InputStreamReader(inputStream);
                BufferedReader bufferedReader = new BufferedReader(inputStreamReader);
                StringBuilder stringBuilder = new StringBuilder();
                String responseBits;
                while ((responseBits = bufferedReader.readLine()) != null) {
                    stringBuilder.append(responseBits);
                }
                String responseData = stringBuilder.toString();
//                LoggerTradeIn.e(TAG, responseData + " @****");
                LoggerTradeIn.e(TAG, "responseData" + " @****");
//                return responseData;
                ConstantsApi.apiResponseData = responseData;
//                LoggerTradeIn.e(TAG, ConstantsApi.apiResponseData+"");
                LoggerTradeIn.e(TAG, "apiResponseData");
                callBackStart();
            } else {
                Toast.makeText(mContext, "Error Code : " + statusCode, Toast.LENGTH_SHORT).show();
            }
        } catch (Exception e) {
            e.printStackTrace();
            LoggerTradeIn.e(TAG, e.getMessage() + " @70");
            LoggerTradeIn.e(TAG, e + " @70");
        }
    }

    private ApiCallback apiCallback;

    public void callBackStart() {
        LoggerTradeIn.e(TAG, " @callBackStart");
        apiCallback = (ApiCallback) mContext;
        apiCallback.sendResponse(ConstantsApi.apiResponseData + "");
    }
}
