package com.concatsys.tradein.tradein_plugin.api;

import android.app.ActivityManager;
import android.app.Service;
import android.content.Context;
import android.content.Intent;
import android.os.Handler;
import android.os.IBinder;
import android.widget.Toast;

import androidx.annotation.Nullable;

import com.concatsys.tradein.tradein_plugin.R;
import com.concatsys.tradein.tradein_plugin.activity.MyVehicleActivity;
import com.concatsys.tradein.tradein_plugin.activity.OffersActivity;
import com.concatsys.tradein.tradein_plugin.activity.SummaryActivity;
import com.concatsys.tradein.tradein_plugin.activity.UserProfileActivity;
import com.concatsys.tradein.tradein_plugin.activity.VehicleMediaActivity;
import com.concatsys.tradein.tradein_plugin.dialogsandviews.ToastCustomize;
import com.concatsys.tradein.tradein_plugin.interfaces.ActivityCallBack;
import com.concatsys.tradein.tradein_plugin.interfaces.ApiCallback;
import com.concatsys.tradein.tradein_plugin.logs.LoggerTradeIn;
import com.concatsys.tradein.tradein_plugin.utils.NetworkCheck;

public class ApiService extends Service implements ApiCallback {
    private String TAG = getClass().getSimpleName();
    Context mContext;

    @Nullable
    @Override
    public IBinder onBind(Intent intent) {
        LoggerTradeIn.e(TAG, "IBinder");
        return null;
    }

    @Override
    public int onStartCommand(Intent intent, int flags, int startId) {
        LoggerTradeIn.e(TAG, "onStartCommand");
        startApiCall();
        return super.onStartCommand(intent, flags, startId);
    }

    private void startApiCall() {
        LoggerTradeIn.e(TAG, "service startApiCall");
        NetworkCheck networkCheck = NetworkCheck.getInstance();
        if (networkCheck.isNetworkConnected(this)) {
            ApiAsyncTask apiAsyncTask = null;
            if (apiAsyncTask != null) {
                apiAsyncTask.cancel(true);
            }
//            ConstantsApi.API_CALL_URL = ConstantsApi.BASE_URL + ConstantsApi.DROP_DOWN_URL;
            LoggerTradeIn.e(TAG, "API = " + ConstantsApi.FLAG_API_NAME);
            ConstantsApi.API_GET_POST = "GET";
            if (ConstantsApi.FLAG_API_NAME.equalsIgnoreCase(ConstantsApi.FLAG_API_DROP_DOWN)) {
                ConstantsApi.SUB_URL = ConstantsApi.DROP_DOWN_URL;
            } else if (ConstantsApi.FLAG_API_NAME.equalsIgnoreCase(ConstantsApi.FLAG_API_Model)) {
                ConstantsApi.MODEL_URL = "GetModelWithMake&MAKE_ID=" + ConstantsApi.MAKE_ID;
                ConstantsApi.SUB_URL = ConstantsApi.MODEL_URL;
            } else if (ConstantsApi.FLAG_API_NAME.equalsIgnoreCase(ConstantsApi.FLAG_API_USER_PROFILE)) {
                ConstantsApi.API_GET_POST = "POST";
                ConstantsApi.USER_PROFILE_URL = "" +
                        "SaveLead&LEAD_KEY=" + ConstantsApi.LEAD_KEY_UP_URL +
                        "&FIRSTNAME=" + ConstantsApi.FIRST_NAME_UP_URL +
                        "&LASTNAME=" + ConstantsApi.LAST_NAME_UP_URL +
                        "&EMAIL=" + ConstantsApi.EMAIL_UP_URL +
                        "&PHONE=" + ConstantsApi.PHONE_UP_URL +
                        "&ZIPCODE=" + ConstantsApi.ZIP_UP_URL +
                        "&LEAD_USER_ID=" + ConstantsApi.USER_ID_UP_URL +
                        "&LEAD_CLIENT_ID=" + ConstantsApi.CLIENT_ID_UP_URL;
                ConstantsApi.SUB_URL = ConstantsApi.USER_PROFILE_URL;
            } else if (ConstantsApi.FLAG_API_NAME.equalsIgnoreCase(ConstantsApi.FLAG_API_MEDIA)) {
                ConstantsApi.API_GET_POST = "POST";
                ConstantsApi.MEDIA_URL = "" +
                        "SaveVehicleMedia" +
                        "&VEHICLE_KEY=" + ConstantsApi.VEHICLE_KEY_UP_URL;
                ConstantsApi.SUB_URL = ConstantsApi.MEDIA_URL;
            } else if (ConstantsApi.FLAG_API_NAME.equalsIgnoreCase(ConstantsApi.FLAG_API_GET_MEDIA)) {
                ConstantsApi.VEHICLE_KEY_UP_URL = "31583178-16A2-EF59-B5F1-18F4FA3C5DED";
                ConstantsApi.MEDIA_GET_URL= "" +
                        "GetVehicleMedia" +
                        "&VEHICLE_KEY=" + ConstantsApi.VEHICLE_KEY_UP_URL;
                ConstantsApi.SUB_URL = ConstantsApi.MEDIA_GET_URL;
            } else if (ConstantsApi.FLAG_API_NAME.equalsIgnoreCase(ConstantsApi.FLAG_API_SAVE_VEHICLE)) {
                ConstantsApi.API_GET_POST = "POST";
                LoggerTradeIn.e(TAG, ConstantsApi.SUMMARY_TRANSMISSION + " @72");
                ConstantsApi.SUB_URL = ConstantsApi.SAVE_VEHICLE_URL;
            } else if (ConstantsApi.FLAG_API_NAME.equalsIgnoreCase(ConstantsApi.FLAG_API_GET_ALL_VEHICLE)) {
                ConstantsApi.GET_ALL_VEHICLES_URL = "GetAllVehicles" +
                        "&LEAD_KEY=" + ConstantsApi.LEAD_KEY_UP_URL;
                ConstantsApi.SUB_URL = ConstantsApi.GET_ALL_VEHICLES_URL;
            } else if (ConstantsApi.FLAG_API_NAME.equalsIgnoreCase(ConstantsApi.FLAG_API_GET_ONE_VEHICLE)) {
                ConstantsApi.GET_VEHICLE_URL = "GetVehicle" +
                        "&VEHICLE_KEY=" + ConstantsApi.VEHICLE_KEY_UP_URL;
                ConstantsApi.SUB_URL = ConstantsApi.GET_VEHICLE_URL;
            } else if (ConstantsApi.FLAG_API_NAME.equalsIgnoreCase(ConstantsApi.FLAG_API_OFFERS)) {
                ConstantsApi.OFFERS_URL = "" +
                        "GetVehiclesOffers" +
                        "&LEAD_KEY=" + ConstantsApi.LEAD_KEY_UP_URL;
                ConstantsApi.SUB_URL = ConstantsApi.OFFERS_URL;
            } else if (ConstantsApi.FLAG_API_NAME.equalsIgnoreCase(ConstantsApi.FLAG_API_OFFERS_ACCEPT_REJECT)) {
                ConstantsApi.API_GET_POST = "POST";
                ConstantsApi.SUB_URL = ConstantsApi.OFFERS_ACCEPT_REJECT_URL;
            } else if (ConstantsApi.FLAG_API_NAME.equalsIgnoreCase(ConstantsApi.FLAG_API_CONTACT_US)) {
                ConstantsApi.SUB_URL = ConstantsApi.CONTACT_US_URL;
            } else if (ConstantsApi.FLAG_API_NAME.equalsIgnoreCase(ConstantsApi.FLAG_API_GET_USER)) {
                LoggerTradeIn.e(TAG, "Lead = " + ConstantsApi.LEAD_KEY_UP_URL);
                ConstantsApi.GET_USER_URL = "GetLead" +
                        "&LEAD_KEY=" + ConstantsApi.LEAD_KEY_UP_URL;
                ConstantsApi.SUB_URL = ConstantsApi.GET_USER_URL;
            }

            ConstantsApi.API_CALL_URL = ConstantsApi.BASE_URL + ConstantsApi.SUB_URL;
            ApiHttpCall apiHttpCall = ApiHttpCall.getInstance();
            apiHttpCall.httpUrlCallS(this);
            LoggerTradeIn.e(TAG, "end startApiCall");

        }
    }

    private ActivityCallBack activityCallback;

    public void callBackActivity() {
        LoggerTradeIn.e(TAG, " @callBackStart");
        if (ConstantsApi.FLAG_API_NAME.equalsIgnoreCase(ConstantsApi.FLAG_API_MEDIA)) {
            VehicleMediaActivity vehicleMediaActivity = VehicleMediaActivity.vehicleMediaActivity;
            activityCallback = (ActivityCallBack) vehicleMediaActivity;
            activityCallback.callActivity("1");
        } else if (ConstantsApi.FLAG_API_NAME.equalsIgnoreCase(ConstantsApi.FLAG_API_USER_PROFILE)) {
//            AppCompatActivity userProfileContext = UserProfileActivity.userProfileActivity;
            UserProfileActivity userProfileContext = UserProfileActivity.userProfileActivity;
            activityCallback = (ActivityCallBack) userProfileContext;
            activityCallback.callActivity("1");
        } else if (ConstantsApi.FLAG_API_NAME.equalsIgnoreCase(ConstantsApi.FLAG_API_SAVE_VEHICLE)) {
//            OffersActivity offersActivity = OffersActivity.offersActivity;
            activityCallback = (ActivityCallBack) SummaryActivity.summaryActivity;
            activityCallback.callActivity("1");
        } else if (ConstantsApi.FLAG_API_NAME.equalsIgnoreCase(ConstantsApi.FLAG_API_GET_ALL_VEHICLE)) {
            activityCallback = (ActivityCallBack) MyVehicleActivity.myVehicleActivity;
            activityCallback.callActivity("1");
        } else if (ConstantsApi.FLAG_API_NAME.equalsIgnoreCase(ConstantsApi.FLAG_API_OFFERS)) {
            OffersActivity offersActivity = OffersActivity.offersActivity;
            activityCallback = (ActivityCallBack) offersActivity;
            activityCallback.callActivity("1");
        } else if (ConstantsApi.FLAG_API_NAME.equalsIgnoreCase(ConstantsApi.FLAG_API_GET_ONE_VEHICLE)) {
            activityCallback = (ActivityCallBack) MyVehicleActivity.myVehicleActivity;
            activityCallback.callActivity("2");
        }  else if (ConstantsApi.FLAG_API_NAME.equalsIgnoreCase(ConstantsApi.FLAG_API_GET_USER)) {
            activityCallback = (ActivityCallBack) MyVehicleActivity.myVehicleActivity;
            activityCallback.callActivity("3");
        }
//            mContext = UserProfileActivity.userProfileActivity;
//            UserProfileActivity userProfileContext = UserProfileActivity.userProfileActivity;
//            userProfileContext.callUserProfile();
    }

    @Override
    public void sendResponse(String strResponse) {
        try {
            LoggerTradeIn.e(TAG, "sendResponse@149*");
//            LoggerTradeIn.e(TAG, strResponse);
//            jsonOperation(strResponse.trim());
            ApiListOperations apiListOperations = ApiListOperations.getInstance();
            if (ConstantsApi.FLAG_API_NAME.equalsIgnoreCase(ConstantsApi.FLAG_API_DROP_DOWN)) {
                apiListOperations.jsonOperationAllDropDowns(strResponse.trim());
            } else if (ConstantsApi.FLAG_API_NAME.equalsIgnoreCase(ConstantsApi.FLAG_API_Model)) {
                apiListOperations.jsonOperationModel(strResponse.trim());
            } else if (ConstantsApi.FLAG_API_NAME.equalsIgnoreCase(ConstantsApi.FLAG_API_USER_PROFILE)) {
                apiListOperations.jsonOperationUserProfile(strResponse.trim());
            } else if (ConstantsApi.FLAG_API_NAME.equalsIgnoreCase(ConstantsApi.FLAG_API_MEDIA)) {
                apiListOperations.jsonOperationMedia(strResponse.trim());
            }  else if (ConstantsApi.FLAG_API_NAME.equalsIgnoreCase(ConstantsApi.FLAG_API_GET_MEDIA)) {
                apiListOperations.jsonOperationGetMedia(strResponse.trim());
                /*runOnUiThread(new Runnable(){
                    public void run() {
                        // UI code goes here
                    }
                });*/
                /*Handler mainHandler = new Handler(getMainLooper());
                mainHandler.post(new Runnable() {
                    @Override
                    public void run() {
                        // Do your stuff here related to UI, e.g. show toast
                    }
                });*/
            } else if (ConstantsApi.FLAG_API_NAME.equalsIgnoreCase(ConstantsApi.FLAG_API_SAVE_VEHICLE)) {
                apiListOperations.jsonOperationSaveVehicle(strResponse.trim());
            } else if (ConstantsApi.FLAG_API_NAME.equalsIgnoreCase(ConstantsApi.FLAG_API_GET_ALL_VEHICLE)) {
                apiListOperations.jsonOperationGetVehicles(strResponse.trim());
            } else if (ConstantsApi.FLAG_API_NAME.equalsIgnoreCase(ConstantsApi.FLAG_API_OFFERS)) {
                apiListOperations.jsonOperationOffers(strResponse.trim());
            } else if (ConstantsApi.FLAG_API_NAME.equalsIgnoreCase(ConstantsApi.FLAG_API_GET_ONE_VEHICLE)) {
                apiListOperations.jsonOperationGetOneVehicle(strResponse.trim());
            } else if (ConstantsApi.FLAG_API_NAME.equalsIgnoreCase(ConstantsApi.FLAG_API_GET_USER)) {
                apiListOperations.jsonOperationGetUser(strResponse.trim());
            }

            callBackActivity();

            stopService();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    private void callSummaryActivity() {

    }

    private void stopService() {
        Intent serviceIntent = new Intent(this, ApiService.class);
        stopService(serviceIntent);
    }

    private boolean isMyServiceRunning(Class<?> serviceClass) {
        ActivityManager manager = (ActivityManager) getSystemService(Context.ACTIVITY_SERVICE);
        for (ActivityManager.RunningServiceInfo service : manager.getRunningServices(Integer.MAX_VALUE)) {
            if (serviceClass.getName().equals(service.service.getClassName())) {
                return true;
            }
        }
        return false;
    }
}
