package com.concatsys.tradein.tradein_plugin.backblaze.fileuploader;

import android.content.ContentResolver;
import android.content.Context;
import android.net.Uri;
import android.util.Log;
import android.webkit.MimeTypeMap;

import com.concatsys.tradein.tradein_plugin.backblaze.client.BlazeClient;
import com.concatsys.tradein.tradein_plugin.backblaze.client.ClientListener;
import com.concatsys.tradein.tradein_plugin.backblaze.client.ClientModel;
import com.concatsys.tradein.tradein_plugin.backblaze.upload_auth.UploadAuth;
import com.concatsys.tradein.tradein_plugin.backblaze.upload_models.UploadResponse;

import org.json.JSONObject;


import java.io.ByteArrayOutputStream;

import java.io.IOException;
import java.io.InputStream;

import java.net.MalformedURLException;
import java.net.URL;
import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Formatter;
import java.util.concurrent.Callable;

import retrofit2.Call;
import retrofit2.Callback;
import retrofit2.Response;

public class BlazeFileUploader {


    private Context context;
    private BlazeClient blazeClient;
    private String bucketId;
    private UploadListener uploadingListener;
    private boolean isAuthed = false;
    private String accountAuthorizationToken, apiUrl;
    private String contentType = "";

    private ArrayList<MultiFile> files;

    //Upload Auth
    private String uploadUrl;
    private String uploadAuthorizationToken;

    private boolean isMultiUpload = false;

    public BlazeFileUploader(BlazeClient blazeClient, String bucketId) {
        this.context = blazeClient.getContext();
        this.blazeClient = blazeClient;
        this.bucketId = bucketId;
        isAuthed = false;

    }


    public void startUploadingMultipleFiles(ArrayList<MultiFile> files) {
        Log.e("uploadMultiImages","startUploadingMultipleFiles");

        this.files = files;
        isMultiUpload = true;


        try {
            uploadMultiImages(new ArrayList<>());
        } catch (IOException e) {
            e.printStackTrace();
        }

    }

    private void uploadMultiImages(ArrayList<MultiFile> file) throws IOException {
        Log.e("uploadMultiImages","uploadMultiImages");
        MultiFile fileModel = files.get(file.size());
        if (!isAuthed) {
            Log.e("uploadMultiImages","isAuthed");


            if (fileModel.getFileUri() != null)
                getClientData(fileModel.getFileUri(), fileModel.getFileName(), fileModel.getContentType());
            else
                getClientData(fileModel.getFileBytes(), fileModel.getFileName(), fileModel.getContentType());

        } else {
            Log.e("uploadMultiImages","else@98");
            byte[] inputData =null;
            if (fileModel.getFileUri() != null){
                Log.e("uploadMultiImages","if fileModel");
                getImageName(fileModel.getFileUri());

                InputStream iStream = context.getContentResolver().openInputStream(fileModel.getFileUri());
          inputData = getBytes(iStream);
                Log.e("fileModel@97",fileModel.getFileName()+"");
                Log.e("uploadFile","3");
//                fileModel.getFileName()
                uploadFile(fileModel.getFileUri(), ConstantsBB.IMAGE_NAME_EXTENSION,
                        inputData, fileModel.getContentType(), () -> {

                            file.add(fileModel);
                            if (file.size() == files.size()) {
                                Log.e("uploadMultiImages","files.size");

                                UploadResponse uploadResponse = new UploadResponse();

                                if (uploadingListener != null)
                                    uploadingListener.onUploadFinished(uploadResponse, true);
                            } else {
                                Log.e("uploadMultiImages","else@117");
                                uploadMultiImages(file);
                            }

                            return null;
                        });
            }else{
                Log.e("uploadMultiImages","else@123");
                Log.e("fileModel@118",fileModel.getFileName()+"");
//                fileModel.getFileName()
                Log.e("uploadFile","4");
                uploadFile(fileModel.getFileBytes(), fileModel.getFileName(), fileModel.getContentType(), () -> {

                            file.add(fileModel);
                            if (file.size() == files.size()) {

                                UploadResponse uploadResponse = new UploadResponse();

                                if (uploadingListener != null)
                                    uploadingListener.onUploadFinished(uploadResponse, true);
                            } else {
                                uploadMultiImages(file);
                            }

                            return null;
                        });
            }


        }
    }


    public void startUploading(Uri fileUri, String fileName, String contentType) {
        this.contentType = contentType;
        isMultiUpload = false;
        try {

            InputStream iStream = context.getContentResolver().openInputStream(fileUri);
            byte[] inputData = getBytes(iStream);
            if (uploadingListener != null)
                uploadingListener.onUploadStarted();


            checkIfAuthed(fileUri, fileName, inputData);

        } catch (IOException e) {
            e.printStackTrace();
        }
    }


    public void startUploading(byte[] fileBytes, String fileName, String contentType) {
        this.contentType = contentType;
        isMultiUpload = false;


        if (uploadingListener != null)
            uploadingListener.onUploadStarted();


        checkIfAuthed(fileBytes, fileName);

    }

    public void startUploading(byte[] fileBytes, String fileName) {
        isMultiUpload = false;


        if (uploadingListener != null)
            uploadingListener.onUploadStarted();


        checkIfAuthed(fileBytes, fileName);

    }

    public void startUploading(Uri fileUri, String fileName) {
        isMultiUpload = false;
        try {
            Log.e("uploadMultiImages",fileUri +" @91a");

            InputStream iStream = context.getContentResolver().openInputStream(fileUri);
            byte[] inputData = getBytes(iStream);
            if (uploadingListener != null)
                uploadingListener.onUploadStarted();


            checkIfAuthed(fileUri, fileName, inputData);

        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    private void checkIfAuthed(byte[] filebytes, String fileName) {
        if (!isAuthed) {

            getClientData(filebytes, fileName, contentType);
        } else {
            Log.e("uploadFile","5");
            uploadFile(filebytes, fileName, contentType, null);
        }
    }

    private void checkIfAuthed(Uri fileUri, String fileName, byte[] inputData) {
        if (!isAuthed) {

            getClientData(fileUri, fileName, contentType);
        } else {
            Log.e("uploadFile","6");
            uploadFile(fileUri, fileName, inputData, contentType, null);
        }
    }

    private void uploadFile(Uri fileUri, String fileName, byte[] inputData, String contentType, Callable<Void> onFinish) {
        URL url = null;
        String path = null;
        try {
            url = new URL(uploadUrl);
            path = url.getPath();
            path = path.replaceFirst("/", "");

        } catch (MalformedURLException e) {
            e.printStackTrace();
        }


        String baseUrl = url.getProtocol() + "://" + url.getHost();
        Log.e("baseUrl@249",url+"");

        UploadInterface uploadInterface = ApiClient.getClient(baseUrl).create(UploadInterface.class);

        UploadProgressRequestBody requestBody = new UploadProgressRequestBody(
                context,
                new UploadProgressRequestBody.UploadInfo(fileUri, inputData.length),
                (progress, total) -> {


                    int percentage = (int) ((progress * 100.0f) / total);

                    if (uploadingListener != null)
                        uploadingListener.onUploadProgress(percentage, progress, total);

                }
        );
        requestBody.setContentType(contentType);

// Upload
        Log.e("fileName@260", fileName+"");
        ConstantsBB.alImageNameExtension.add(fileName);
        /*if(fileName.length()>0){
            Log.e("return", "return");
            return;
        }*/
        Log.e("uploadFile","1");
        Call<UploadResponse> call = uploadInterface.uploadFile(path, requestBody, uploadAuthorizationToken,
                SHAsum(inputData), fileName);
        /*Call<UploadResponse> call = uploadInterface.uploadFile(path, requestBody, uploadAuthorizationToken,
                SHAsum(inputData), "" + ConstantsBB.IMAGE_NAME + ".png");*/

        /*Calendar cal = Calendar.getInstance();
        ConstantsBB.IMAGE_NAME = cal.getTimeInMillis() + "";
        Log.e("IMAGE_NAME@269", ConstantsBB.IMAGE_NAME + "");
        Call<UploadResponse> call = uploadInterface.uploadFile(path, requestBody, uploadAuthorizationToken,
                SHAsum(inputData), "" + ConstantsBB.IMAGE_NAME + ConstantsBB.IMAGE_NAME + "."+ConstantsBB.IMAGE_EXTENSION);*/
        call.enqueue(new Callback<UploadResponse>() {
            @Override
            public void onResponse(Call<UploadResponse> call, Response<UploadResponse> response) {


                if (uploadingListener != null) {
                    uploadingListener.onUploadFinished(response.body(), !isMultiUpload);
                    call.cancel();


                }
                if (onFinish != null) {
                    try {
                        onFinish.call();
                    } catch (Exception e) {
                        e.printStackTrace();
                    }
                }

            }

            @Override
            public void onFailure(Call<UploadResponse> call, Throwable t) {
                if (uploadingListener != null)
                    uploadingListener.onUploadFailed((Exception) t);

            }
        });

    }

    private void getImageName(Uri selectedImageURI) {
        Calendar cal = Calendar.getInstance();
        ConstantsBB.IMAGE_NAME = cal.getTimeInMillis() + "";
        Log.e("IMAGE_NAME", ConstantsBB.IMAGE_NAME + "");
        Log.e("IMAGE_EXTENSION", ConstantsBB.IMAGE_EXTENSION + "");
        String strFileExtension = getFileExtension(selectedImageURI);
        ConstantsBB.IMAGE_EXTENSION = strFileExtension;
        Log.e("strFilePath2", strFileExtension + "");
        ConstantsBB.IMAGE_NAME_EXTENSION = ConstantsBB.IMAGE_NAME + "."+ConstantsBB.IMAGE_EXTENSION;
    }
    private String getFileExtension(Uri uri) {
        String extension;
        ContentResolver contentResolver = context.getContentResolver();
        MimeTypeMap mimeTypeMap = MimeTypeMap.getSingleton();
        extension = mimeTypeMap.getExtensionFromMimeType(contentResolver.getType(uri));
        return extension;
    }

    private void uploadFile(byte[] fileBytes, String fileName, String contentType, Callable<Void> onFinish) {
        URL url = null;
        String path = null;
        try {
            url = new URL(uploadUrl);
            path = url.getPath();
            path = path.replaceFirst("/", "");

        } catch (MalformedURLException e) {
            e.printStackTrace();
        }


        String baseUrl = url.getProtocol() + "://" + url.getHost();

        Log.e("baseUrl@317",baseUrl+"");
        UploadInterface uploadInterface = ApiClient.getClient(baseUrl).create(UploadInterface.class);

        UploadProgressRequestBody requestBody = new UploadProgressRequestBody(
                context,
                new UploadProgressRequestBody.UploadInfo(fileBytes, fileBytes.length),
                (progress, total) -> {


                    int percentage = (int) ((progress * 100.0f) / total);

                    if (uploadingListener != null)
                        uploadingListener.onUploadProgress(percentage, progress, total);

                }
        );
        requestBody.setContentType(contentType);


// Upload
//        getImageName(fileModel.getFileUri());

        Log.e("uploadFile",  "2");
        Call<UploadResponse> call = uploadInterface.uploadFile(path, requestBody, uploadAuthorizationToken,
                SHAsum(fileBytes), fileName);
        /*Calendar cal = Calendar.getInstance();
        ConstantsBB.IMAGE_NAME = cal.getTimeInMillis() + "";
        Log.e("IMAGE_NAME@346", ConstantsBB.IMAGE_NAME + "");
        Call<UploadResponse> call = uploadInterface.uploadFile(path, requestBody, uploadAuthorizationToken,
                SHAsum(fileBytes), ConstantsBB.IMAGE_NAME+ "."+ConstantsBB.IMAGE_EXTENSION);*/
        call.enqueue(new Callback<UploadResponse>() {
            @Override
            public void onResponse(Call<UploadResponse> call, Response<UploadResponse> response) {
                Log.e("whynull" , response.body().toString());



                if (uploadingListener != null) {
                    uploadingListener.onUploadFinished(response.body(), !isMultiUpload);


                }
                if (onFinish != null) {
                    try {
                        onFinish.call();
                    } catch (Exception e) {
                        e.printStackTrace();
                    }
                }

            }

            @Override
            public void onFailure(Call<UploadResponse> call, Throwable t) {
                if (uploadingListener != null)
                    uploadingListener.onUploadFailed((Exception) t);

            }
        });

    }

    private void getClientData(byte[] fileBytes, String fileName, String contentType) {

        blazeClient.setClientListener(new ClientListener() {
            @Override
            public void onConnectionStarted() {

            }

            @Override
            public void onRetrievingData(ClientModel data, JSONObject response) {

                Log.e("whynull" , response.toString());
                accountAuthorizationToken = data.getAuthorizationToken();
                apiUrl = data.getApiUrl();
                UploadAuth uploadAuth = new UploadAuth(context, bucketId, accountAuthorizationToken, apiUrl);
                uploadAuth.getUploadAuthData();
                uploadAuth.setUploadAuthListener(uploadAuthModel -> {

                    uploadUrl = uploadAuthModel.getUploadUrl();
                    uploadAuthorizationToken = uploadAuthModel.getAuthorizationToken();
                    isAuthed = true;
                    if (!isMultiUpload)
                        startUploading(fileBytes, fileName, contentType);
                    else
                        startUploadingMultipleFiles(files);
                });

            }

            @Override
            public void onFailure(Exception e) {
                if (uploadingListener != null)
                    uploadingListener.onUploadFailed(e);
            }
        });
    }


    private void getClientData(Uri fileUri, String fileName, String contentType) {

        blazeClient.setClientListener(new ClientListener() {
            @Override
            public void onConnectionStarted() {

            }

            @Override
            public void onRetrievingData(ClientModel data, JSONObject response) {

                accountAuthorizationToken = data.getAuthorizationToken();
                apiUrl = data.getApiUrl();
                UploadAuth uploadAuth = new UploadAuth(context, bucketId, accountAuthorizationToken, apiUrl);

                uploadAuth.getUploadAuthData();
                uploadAuth.setUploadAuthListener(uploadAuthModel -> {
                    uploadUrl = uploadAuthModel.getUploadUrl();
                    uploadAuthorizationToken = uploadAuthModel.getAuthorizationToken();
                    isAuthed = true;
                    if (!isMultiUpload)
                        startUploading(fileUri, fileName, contentType);
                    else
                        startUploadingMultipleFiles(files);
                });

            }

            @Override
            public void onFailure(Exception e) {
                if (uploadingListener != null)
                    uploadingListener.onUploadFailed(e);
            }
        });
    }


    public void setOnUploadingListener(UploadListener uploadingListener) {
        this.uploadingListener = uploadingListener;
    }


    private static String SHAsum(byte[] convertme) {
        MessageDigest md = null;
        try {
            md = MessageDigest.getInstance("SHA-1");
        } catch (NoSuchAlgorithmException e) {
            e.printStackTrace();
        }
        return byteArray2Hex(md.digest(convertme));
    }

    private static String byteArray2Hex(final byte[] hash) {
        Formatter formatter = new Formatter();
        for (byte b : hash) {
            formatter.format("%02x", b);
        }
        return formatter.toString();
    }


    public byte[] getBytes(InputStream inputStream) throws IOException {
        ByteArrayOutputStream byteBuffer = new ByteArrayOutputStream();
        int bufferSize = 1024;
        byte[] buffer = new byte[bufferSize];

        int len = 0;
        while ((len = inputStream.read(buffer)) != -1) {
            byteBuffer.write(buffer, 0, len);
        }
        return byteBuffer.toByteArray();
    }


}
