package com.concatsys.tradein.tradein_plugin.db;

import android.app.Activity;
import android.app.Application;
import android.content.Context;
import android.content.Intent;
import android.net.Uri;
import android.widget.Toast;

import androidx.lifecycle.LifecycleOwner;
import androidx.lifecycle.Observer;
import androidx.lifecycle.ViewModelProvider;

import com.concatsys.tradein.tradein_plugin.backblaze.FileTypes;
import com.concatsys.tradein.tradein_plugin.backblaze.fileuploader.ConstantsBB;
import com.concatsys.tradein.tradein_plugin.backblaze.fileuploader.MultiFile;
import com.concatsys.tradein.tradein_plugin.activity.ConstantsActivity;
import com.concatsys.tradein.tradein_plugin.api.ConstantsApi;
import com.concatsys.tradein.tradein_plugin.logs.LoggerTradeIn;

import java.io.File;
import java.sql.Date;
import java.util.ArrayList;
import java.util.List;

public class DBOperations {
    private String TAG = getClass().getSimpleName();
    private static DBOperations instance = null;

    private DBOperations() {
    }

    public static DBOperations getInstance() {
        if (instance == null) {
            instance = new DBOperations();
        }
        return instance;
    }

    Application applicationContext;
    DataBaseRoomInstance app = null;
    DBUsersViewModel dbUsersViewModel;
    DBRoofTopViewModel dbRoofTopViewModel;
    DBAccountsViewModel dbAccountsViewModel;
    DBVehiclesViewModel dbVehiclesViewModel;
    DBVehicleOptionsViewModel dbVehicleOptionsViewModel;
    DBVehicleMediaViewModel dbVehicleMediaViewModel;
    DBSdkViewModel dbSdkViewModel;

    //    insert users
    public void insertUsers(Context context,
                            String user_guid, String user_device_udid, String user_rooftop_id, String user_first_name, String user_last_name, String user_email_id, String user_phone_number, String user_zipcode, Date user_created_at, Date user_modified_at) {
        applicationContext = (Application) context.getApplicationContext();
        dbUsersViewModel = ViewModelProvider.AndroidViewModelFactory.getInstance(applicationContext).create(DBUsersViewModel.class);
        DBUsersModel dbModel = new DBUsersModel();
        dbModel.setAllTableColumns(user_guid, user_device_udid, user_rooftop_id, user_first_name, user_last_name, user_email_id, user_phone_number, user_zipcode, user_created_at, user_modified_at);
        dbUsersViewModel.insert(dbModel);
    }

    //  update users
    public void updateUsers(Context context, int user_id, String user_guid, String user_device_udid, String user_rooftop_id,
                            String user_first_name, String user_last_name, String user_email_id, String user_phone_number, String user_zipcode, Date user_created_at, Date user_modified_at) {
        applicationContext = (Application) context.getApplicationContext();
        dbUsersViewModel = ViewModelProvider.AndroidViewModelFactory.getInstance(applicationContext).create(DBUsersViewModel.class);
        if (user_id == -1) {
            Toast.makeText(context, "Can't be updated", Toast.LENGTH_SHORT).show();
            return;
        }
        DBUsersModel dbModel = new DBUsersModel();
        dbModel.setUser_id(user_id);
        dbModel.setAllTableColumns(user_guid, user_device_udid, user_rooftop_id, user_first_name, user_last_name, user_email_id, user_phone_number, user_zipcode, user_created_at, user_modified_at);
        dbUsersViewModel.update(dbModel);
    }

    //     print users
    public void getUserValues(Context context) {
        try {
            int dbIndexGet = ConstantsDB.dbVehicleIndex - 1;
//            int dbIndexGet = ConstantsDB.dbVehicleIndex;
            LoggerTradeIn.e(TAG, "3dbIndexGet = " + dbIndexGet);
            app = DataBaseRoomInstance.getInstance(context);
            List<DBUsersModel> listUsersValues = app.DaoUsers().getUserSize();
//        List<DBUsersModel> getBooks = (List<DBUsersModel>) app.DaoUsers().getAllTableValues();
            String userFirstName = listUsersValues.get(dbIndexGet).getUser_first_name();
            String userLastName = listUsersValues.get(dbIndexGet).getUser_last_name();
            String userEmail = listUsersValues.get(dbIndexGet).getUser_email_id();
            String userPhoneNumber = listUsersValues.get(dbIndexGet).getUser_phone_number();
            String userZipCode = listUsersValues.get(dbIndexGet).getUser_zipcode();

            ConstantsActivity.hmUsers.put(ConstantsApi.KEYS_VEHICLE_ONE_USER_ARRAY[1], userFirstName);
            ConstantsActivity.hmUsers.put(ConstantsApi.KEYS_VEHICLE_ONE_USER_ARRAY[2], userLastName);
            ConstantsActivity.hmUsers.put(ConstantsApi.KEYS_VEHICLE_ONE_USER_ARRAY[3], userEmail);
            ConstantsActivity.hmUsers.put(ConstantsApi.KEYS_VEHICLE_ONE_USER_ARRAY[4], userPhoneNumber);
            ConstantsActivity.hmUsers.put(ConstantsApi.KEYS_VEHICLE_ONE_USER_ARRAY[5], userZipCode);

           /* ConstantsActivity.hmUsers.put("user_first_name", userFirstName);
            ConstantsActivity.hmUsers.put("user_last_name", userLastName);
            ConstantsActivity.hmUsers.put("user_email", userEmail);
            ConstantsActivity.hmUsers.put("user_phone_number", userPhoneNumber);
            ConstantsActivity.hmUsers.put("user_zip_code", userZipCode);*/

        /*for (DBUsersModel m : listUsersValues) {
            LoggerTradeIn.e(TAG, m.getUser_first_name().toString());
        }*/

        } catch (Exception e) {
            e.printStackTrace();
            LoggerTradeIn.e(TAG, e.getMessage() + " @104");
            LoggerTradeIn.e(TAG, e + " @104");
        }
    }

    //    display user
    public void displayUsersAll(Context context) {
        applicationContext = (Application) context.getApplicationContext();
        dbUsersViewModel = ViewModelProvider.AndroidViewModelFactory.getInstance(applicationContext).create(DBUsersViewModel.class);
        dbUsersViewModel.getAllValues().observe((LifecycleOwner) context, new Observer<List<DBUsersModel>>() {
            @Override
            public void onChanged(List<DBUsersModel> models) {
                //when the data is changed in our models we are adding that list to our adapter class.
                LoggerTradeIn.e(TAG, models.size() + "");
                for (int i = 0; i < models.size(); i++) {
                    LoggerTradeIn.e(TAG, models.get(i).getUser_id() + "");
                    LoggerTradeIn.e(TAG, models.get(i).getUser_created_at() + "");
                }
            }
        });
    }

    //    insert rooftop
    public void insertRoofTop(Context context,
                              String rooftop_name, String rooftop_guid, String rooftop_account_id, String rooftop_settings, Date rooftop_created_at, Date rooftop_modified_at) {
        applicationContext = (Application) context.getApplicationContext();
        dbRoofTopViewModel = ViewModelProvider.AndroidViewModelFactory.getInstance(applicationContext).create(DBRoofTopViewModel.class);
        DBRoofTopModel dbModel = new DBRoofTopModel();
        dbModel.setAllTableColumns(rooftop_name, rooftop_guid, rooftop_account_id, rooftop_settings, rooftop_created_at, rooftop_modified_at);
        dbRoofTopViewModel.insert(dbModel);
    }

    //  update rooftop
    public void updateRoofTop(Context context,
                              int rooftop_id, String rooftop_name, String rooftop_guid, String rooftop_account_id, String rooftop_settings, Date rooftop_created_at, Date rooftop_modified_at) {
        applicationContext = (Application) context.getApplicationContext();
        dbRoofTopViewModel = ViewModelProvider.AndroidViewModelFactory.getInstance(applicationContext).create(DBRoofTopViewModel.class);
        if (rooftop_id == -1) {
            Toast.makeText(context, "Can't be updated", Toast.LENGTH_SHORT).show();
            return;
        }
        DBRoofTopModel dbModel = new DBRoofTopModel();
        dbModel.setRooftop_id(rooftop_id);
        dbModel.setAllTableColumns(rooftop_name, rooftop_guid, rooftop_account_id, rooftop_settings, rooftop_created_at, rooftop_modified_at);
        dbRoofTopViewModel.update(dbModel);
    }

    //    display rooftop
    public void displayAllRoofTop(Context context) {
        applicationContext = (Application) context.getApplicationContext();
        dbRoofTopViewModel = ViewModelProvider.AndroidViewModelFactory.getInstance(applicationContext).create(DBRoofTopViewModel.class);
        dbRoofTopViewModel.getAllValues().observe((LifecycleOwner) context, new Observer<List<DBRoofTopModel>>() {
            @Override
            public void onChanged(List<DBRoofTopModel> models) {
                //when the data is changed in our models we are adding that list to our adapter class.
                LoggerTradeIn.e(TAG, models.size() + "");
                for (int i = 0; i < models.size(); i++) {
                    LoggerTradeIn.e(TAG, models.get(i).getRooftop_account_id() + "");
                    LoggerTradeIn.e(TAG, models.get(i).getRooftop_created_at() + "");
                }
            }
        });
    }

    //    insert account
    public void insertAccount(Context context,
                              String account_guid, String account_settings, Date account_created_at, Date account_modified_at) {
        applicationContext = (Application) context.getApplicationContext();
        dbAccountsViewModel = ViewModelProvider.AndroidViewModelFactory.getInstance(applicationContext).create(DBAccountsViewModel.class);
        DBAccountsModel dbModel = new DBAccountsModel();
        dbModel.setAllTableColumns(account_guid, account_settings, account_created_at, account_modified_at);
        dbAccountsViewModel.insert(dbModel);
    }

    //  update account
    public void updateAccount(Context context,
                              int account_id, String account_guid, String account_settings, Date account_created_at, Date account_modified_at) {
        applicationContext = (Application) context.getApplicationContext();
        dbAccountsViewModel = ViewModelProvider.AndroidViewModelFactory.getInstance(applicationContext).create(DBAccountsViewModel.class);
        if (account_id == -1) {
            Toast.makeText(context, "Can't be updated", Toast.LENGTH_SHORT).show();
            return;
        }
        DBAccountsModel dbModel = new DBAccountsModel();
        dbModel.setAccount_id(account_id);
        dbModel.setAllTableColumns(account_guid, account_settings, account_created_at, account_modified_at);
        dbAccountsViewModel.update(dbModel);
    }

    //    insert sdk
    public void insertSdk(Context context,
                          String sdk_ilot_id, String sdk_token, String sdk_mobile_token, String sdk_user_name, String sdk_device_udid, String sdk_device_make, String sdk_device_model, String sdk_device_os, String sdk_device_app, String sdk_device_app_version, Date sdk_created_at, Date sdk_modified_at) {
        applicationContext = (Application) context.getApplicationContext();
        dbSdkViewModel = ViewModelProvider.AndroidViewModelFactory.getInstance(applicationContext).create(DBSdkViewModel.class);
        DBSdkModel dbModel = new DBSdkModel();
        dbModel.setAllTableColumns(sdk_ilot_id, sdk_token, sdk_mobile_token, sdk_user_name, sdk_device_udid, sdk_device_make, sdk_device_model, sdk_device_os, sdk_device_app, sdk_device_app_version, sdk_created_at, sdk_modified_at);
        dbSdkViewModel.insert(dbModel);
    }

    //  update vehicle sdk
    public void updateSdk(Context context,
                          int sdk_id, String sdk_ilot_id, String sdk_token, String sdk_mobile_token, String sdk_user_name, String sdk_device_udid, String sdk_device_make, String sdk_device_model, String sdk_device_os, String sdk_device_app, String sdk_device_app_version, Date sdk_created_at, Date sdk_modified_at) {
        applicationContext = (Application) context.getApplicationContext();
        dbSdkViewModel = ViewModelProvider.AndroidViewModelFactory.getInstance(applicationContext).create(DBSdkViewModel.class);
        if (sdk_id == -1) {
            Toast.makeText(context, "Can't be updated", Toast.LENGTH_SHORT).show();
            return;
        }
        DBSdkModel dbModel = new DBSdkModel();
        dbModel.setSdk_id(sdk_id);
        dbModel.setAllTableColumns(sdk_ilot_id, sdk_token, sdk_mobile_token, sdk_user_name, sdk_device_udid, sdk_device_make, sdk_device_model, sdk_device_os, sdk_device_app, sdk_device_app_version, sdk_created_at, sdk_modified_at);
        dbSdkViewModel.update(dbModel);
    }

    //    insert vehicle options
    public void insertVehicleOptions(Context context,
                                     String option_vehicle_id, int option_type, String option_name, Date option_created_at, Date option_modified_at) {
        applicationContext = (Application) context.getApplicationContext();
        dbVehicleOptionsViewModel = ViewModelProvider.AndroidViewModelFactory.getInstance(applicationContext).create(DBVehicleOptionsViewModel.class);
        DBVehicleOptionsModel dbModel = new DBVehicleOptionsModel();
        dbModel.setAllTableColumns(option_vehicle_id, option_type, option_name, option_created_at, option_modified_at);
        dbVehicleOptionsViewModel.insert(dbModel);
    }

    //  update vehicle options
    public void updateVehicleVehicleOptions(Context context,
                                            int option_id, String option_vehicle_id, int option_type, String option_name, Date option_created_at, Date option_modified_at) {
        applicationContext = (Application) context.getApplicationContext();
        dbVehicleOptionsViewModel = ViewModelProvider.AndroidViewModelFactory.getInstance(applicationContext).create(DBVehicleOptionsViewModel.class);
        if (option_id == -1) {
            Toast.makeText(context, "Can't be updated", Toast.LENGTH_SHORT).show();
            return;
        }
        DBVehicleOptionsModel dbModel = new DBVehicleOptionsModel();
        dbModel.setOption_id(option_id);
        dbModel.setAllTableColumns(option_vehicle_id, option_type, option_name, option_created_at, option_modified_at);
        dbVehicleOptionsViewModel.update(dbModel);
    }

    //    insert vehicle media
    public void insertVehicleMedia(Context context,
                                   int media_vehicle_id, String media_guid, String media_url, ArrayList<String> media_urls, String media_type, String media_issequence, boolean media_is_uploaded, Date media_created_at, Date media_modified_at) {
        applicationContext = (Application) context.getApplicationContext();
        dbVehicleMediaViewModel = ViewModelProvider.AndroidViewModelFactory.getInstance(applicationContext).create(DBVehicleMediaViewModel.class);
        DBVehicleMediaModel dbModel = new DBVehicleMediaModel();
        dbModel.setAllTableColumns(media_vehicle_id, media_guid, media_url, media_urls, media_type, media_issequence, media_is_uploaded, media_created_at, media_modified_at);
        dbVehicleMediaViewModel.insert(dbModel);
    }

    //  update vehicle media
    public void updateVehicleMediaContext(Context context, int media_id, int media_vehicle_id,
                                          String media_guid, String media_url, ArrayList<String> media_urls, String media_type, String media_issequence, boolean media_is_uploaded, Date media_created_at, Date media_modified_at) {
        applicationContext = (Application) context.getApplicationContext();
        dbVehicleMediaViewModel = ViewModelProvider.AndroidViewModelFactory.getInstance(applicationContext).create(DBVehicleMediaViewModel.class);
        if (media_id == -1) {
            Toast.makeText(context, "Can't be updated", Toast.LENGTH_SHORT).show();
            return;
        }
        DBVehicleMediaModel dbModel = new DBVehicleMediaModel();
        dbModel.setMedia_id(media_id);
        dbModel.setAllTableColumns(media_vehicle_id, media_guid, media_url, media_urls, media_type, media_issequence, media_is_uploaded, media_created_at, media_modified_at);
        dbVehicleMediaViewModel.update(dbModel);
    }

    // Display all media data
    public void displayAllMedia(Context context) {
        applicationContext = (Application) context.getApplicationContext();
        dbVehicleMediaViewModel = ViewModelProvider.AndroidViewModelFactory.getInstance(applicationContext).create(DBVehicleMediaViewModel.class);
        dbVehicleMediaViewModel.getAllValues().observe((LifecycleOwner) context, new Observer<List<DBVehicleMediaModel>>() {
            @Override
            public void onChanged(List<DBVehicleMediaModel> models) {
                //when the data is changed in our models we are adding that list to our adapter class.
                LoggerTradeIn.e(TAG, models.size() + " @size");
                for (int i = 0; i < models.size(); i++) {
//                    LoggerTradeIn.e(TAG, models.get(i).getMedia_url() + " @url" + i);
                    LoggerTradeIn.e(TAG, models.get(i).getMedia_urls().size() + " @url262 " + i);
                    LoggerTradeIn.e(TAG, models.get(i).getMedia_modified_at() + " @url" + i);
                }
            }


        });
    }

    //    Media print
    public void getVehicleMediaValues(Context context) {
        try {
            int dbIndexGet = ConstantsDB.dbVehicleIndex - 1;
//            int dbIndexGet = ConstantsDB.dbVehicleIndex;
            LoggerTradeIn.e(TAG, "4dbIndexGet = " + dbIndexGet);
            app = DataBaseRoomInstance.getInstance(context);
            List<DBVehicleMediaModel> listVehicleMedia = app.DaoDBVehicleMedia().getMediaSize();
            if(null == listVehicleMedia.get(dbIndexGet).getMedia_urls() || listVehicleMedia.size()==0){
                LoggerTradeIn.e(TAG, " Null listVehicleMedia");
                return;
            }
            LoggerTradeIn.e(TAG, "4listVehicleMedia = " + listVehicleMedia.size());
            for (int i = 0; i < listVehicleMedia.get(dbIndexGet).getMedia_urls().size(); i++) {
                String strUri = listVehicleMedia.get(dbIndexGet).getMedia_urls().get(i);
                LoggerTradeIn.e(TAG, "strUri = " + strUri);
                if(!strUri.contains("http")){
                    Uri savedUri = Uri.parse(strUri);
//            ConstantsActivity.alVMGridStr.add(strUri) ;
                    ConstantsActivity.alVMGridUri.add(savedUri);
                    MultiFile multiFile = new MultiFile();
                    multiFile.init(savedUri, new File(savedUri.getPath()).getAbsolutePath(), FileTypes.IMAGE_TYPE);
                    ConstantsBB.alMultiFile.add(multiFile);
                }
            }
        /*for (DBVehicleMediaModel m : listVehicleMedia) {
            LoggerTradeIn.e(TAG, m.getMedia_created_at().toString());
        }*/
        } catch (Exception e) {
            e.printStackTrace();
            LoggerTradeIn.e(TAG, e.getMessage() + " @312");
            LoggerTradeIn.e(TAG, e + " @312");
        }
    }

    //    insert vehicle
    public void insertVehicle(Context context,
                              int vehicle_user_id, String vehicle_guid, boolean vehicle_is_uploaded, double vehicle_info_percentage, String vehicle_year, String vehicle_make, String vehicle_make_name, String vehicle_model, String vehicle_model_name, String vehicle_trim, String vehicle_mileage, String vehicle_vin, String vehicle_exterior_color, String vehicle_interior_color, String vehicle_transmission, String vehicle_drivetrain, String vehicle_body_style, String vehicle_engine, String vehicle_seat_type, String vehicle_interior_condition, String vehicle_exterior_condition, boolean vehicle_smoked, boolean vehicle_accident, String vehicle_comment, String vehicle_options, String vehicle_packages, Date vehicle_created_at, Date vehicle_modified_at, String vehicle_flag) {
        applicationContext = (Application) context.getApplicationContext();
        dbVehiclesViewModel = ViewModelProvider.AndroidViewModelFactory.getInstance(applicationContext).create(DBVehiclesViewModel.class);
        DBVehiclesModel dbModel = new DBVehiclesModel();
        dbModel.setAllTableColumns(vehicle_user_id, vehicle_guid, vehicle_is_uploaded, vehicle_info_percentage, vehicle_year, vehicle_make, vehicle_make_name, vehicle_model, vehicle_model_name, vehicle_trim, vehicle_mileage, vehicle_vin, vehicle_exterior_color, vehicle_interior_color, vehicle_transmission, vehicle_drivetrain, vehicle_body_style, vehicle_engine, vehicle_seat_type, vehicle_interior_condition, vehicle_exterior_condition, vehicle_smoked, vehicle_accident, vehicle_comment, vehicle_options, vehicle_packages, vehicle_created_at, vehicle_modified_at, vehicle_flag);
        dbVehiclesViewModel.insert(dbModel);
    }

    //  update vehicle
    public void updateVehicle(Context context,
                              int vehicle_id, int vehicle_user_id, String vehicle_guid, boolean vehicle_is_uploaded, double vehicle_info_percentage, String vehicle_year, String vehicle_make, String vehicle_make_name, String vehicle_model, String vehicle_model_name, String vehicle_trim, String vehicle_mileage, String vehicle_vin, String vehicle_exterior_color, String vehicle_interior_color, String vehicle_transmission, String vehicle_drivetrain, String vehicle_body_style, String vehicle_engine, String vehicle_seat_type, String vehicle_interior_condition, String vehicle_exterior_condition, boolean vehicle_smoked, boolean vehicle_accident, String vehicle_comment, String vehicle_options, String vehicle_packages, Date vehicle_created_at, Date vehicle_modified_at, String vehicle_flag) {
        applicationContext = (Application) context.getApplicationContext();
        dbVehiclesViewModel = ViewModelProvider.AndroidViewModelFactory.getInstance(applicationContext).create(DBVehiclesViewModel.class);
        if (vehicle_id == -1) {
            Toast.makeText(context, "Can't be updated", Toast.LENGTH_SHORT).show();
            return;
        }
        DBVehiclesModel dbModel = new DBVehiclesModel();
        dbModel.setVehicle_id(vehicle_id);
        dbModel.setAllTableColumns(vehicle_user_id, vehicle_guid, vehicle_is_uploaded, vehicle_info_percentage, vehicle_year, vehicle_make, vehicle_make_name, vehicle_model, vehicle_model_name, vehicle_trim, vehicle_mileage, vehicle_vin, vehicle_exterior_color, vehicle_interior_color, vehicle_transmission, vehicle_drivetrain, vehicle_body_style, vehicle_engine, vehicle_seat_type, vehicle_interior_condition, vehicle_exterior_condition, vehicle_smoked, vehicle_accident, vehicle_comment, vehicle_options, vehicle_packages, vehicle_created_at, vehicle_modified_at, vehicle_flag);
        dbVehiclesViewModel.update(dbModel);
    }
    //  update vehicle info one
    //  update vehicle
    /*public void updateVehicleInfo1(Context context,
                                   int vehicle_id, int vehicle_user_id, String vehicle_guid, boolean vehicle_is_uploaded, double vehicle_info_percentage, String vehicle_year, String vehicle_make, String vehicle_model, String vehicle_trim, String vehicle_mileage, String vehicle_vin, String vehicle_exterior_color, String vehicle_interior_color, String vehicle_transmission, String vehicle_drivetrain, String vehicle_body_style, String vehicle_engine, String vehicle_seat_type, String vehicle_interior_condition, String vehicle_exterior_condition, boolean vehicle_smoked, boolean vehicle_accident, String vehicle_comment, String vehicle_packages, Date vehicle_created_at, Date vehicle_modified_at) {
        applicationContext = (Application) context.getApplicationContext();
        dbVehiclesViewModel = ViewModelProvider.AndroidViewModelFactory.getInstance(applicationContext).create(DBVehiclesViewModel.class);
        dbVehiclesViewModel.updateVI1(vehicle_id, vehicle_user_id, vehicle_guid, vehicle_is_uploaded, vehicle_info_percentage, vehicle_year,  vehicle_make,  vehicle_model,  vehicle_trim,  vehicle_mileage,  vehicle_vin,  vehicle_exterior_color);
    }*/

    //    update vehicle info 1
    public void updateVehicleInfo1(Context context, int vehicle_id, int vehicle_user_id, String vehicle_guid, boolean vehicle_is_uploaded, double vehicle_info_percentage, String vehicle_year, String vehicle_make, String vehicle_make_name, String vehicle_model, String vehicle_model_name, String vehicle_trim, String vehicle_mileage, String vehicle_vin, String vehicle_exterior_color) {
        applicationContext = (Application) context.getApplicationContext();
        dbVehiclesViewModel = ViewModelProvider.AndroidViewModelFactory.getInstance(applicationContext).create(DBVehiclesViewModel.class);
        dbVehiclesViewModel.updateVI1(vehicle_id, vehicle_user_id, vehicle_guid, vehicle_is_uploaded, vehicle_info_percentage, vehicle_year, vehicle_make, vehicle_make_name, vehicle_model,  vehicle_model_name, vehicle_trim, vehicle_mileage, vehicle_vin, vehicle_exterior_color);
    }

    //    update vehicle info 2
    public void updateVehicleInfo2(Context context, int vehicle_id, int vehicle_user_id, String vehicle_guid, boolean vehicle_is_uploaded, double vehicle_info_percentage,
                                   String vehicle_interior_color, String vehicle_transmission, String vehicle_drivetrain, String vehicle_body_style, String vehicle_engine, String vehicle_seat_type) {
        applicationContext = (Application) context.getApplicationContext();
        dbVehiclesViewModel = ViewModelProvider.AndroidViewModelFactory.getInstance(applicationContext).create(DBVehiclesViewModel.class);
        dbVehiclesViewModel.updateVI2(vehicle_id, vehicle_user_id, vehicle_guid, vehicle_is_uploaded, vehicle_info_percentage, vehicle_interior_color, vehicle_transmission, vehicle_drivetrain, vehicle_body_style, vehicle_engine, vehicle_seat_type);
    }

    //    update vehicle options
    public void updateVehicleOptions(Context context,
                                     int vehicle_id, int vehicle_user_id, String vehicle_guid, boolean vehicle_is_uploaded, double vehicle_info_percentage,
                                     String vehicle_comment, String vehicle_options, String vehicle_packages) {
        applicationContext = (Application) context.getApplicationContext();
        dbVehiclesViewModel = ViewModelProvider.AndroidViewModelFactory.getInstance(applicationContext).create(DBVehiclesViewModel.class);
        dbVehiclesViewModel.updateVehicleOptions(vehicle_id, vehicle_user_id, vehicle_guid, vehicle_is_uploaded, vehicle_info_percentage, vehicle_comment, vehicle_options, vehicle_packages);
    }

    //    update vehicle Conditions
    public void updateVehicleCondition(Context context, int vehicle_id, int vehicle_user_id, String vehicle_guid, boolean vehicle_is_uploaded, double vehicle_info_percentage,
                                       String vehicle_interior_condition, String vehicle_exterior_condition, String vehicle_smoked, String vehicle_accident, String vehicle_comment) {
        applicationContext = (Application) context.getApplicationContext();
        dbVehiclesViewModel = ViewModelProvider.AndroidViewModelFactory.getInstance(applicationContext).create(DBVehiclesViewModel.class);
        dbVehiclesViewModel.updateVehicleCondition(vehicle_id, vehicle_user_id, vehicle_guid, vehicle_is_uploaded, vehicle_info_percentage, vehicle_interior_condition, vehicle_exterior_condition, vehicle_smoked, vehicle_accident, vehicle_comment);
    }

    //    display vehicles
    public void displayVehicles(Context context) {
        applicationContext = (Application) context.getApplicationContext();
        dbVehiclesViewModel = ViewModelProvider.AndroidViewModelFactory.getInstance(applicationContext).create(DBVehiclesViewModel.class);
        dbVehiclesViewModel.getAllValues().observe((LifecycleOwner) context, new Observer<List<DBVehiclesModel>>() {
            @Override
            public void onChanged(List<DBVehiclesModel> models) {
                //when the data is changed in our models we are adding that list to our adapter class.
                LoggerTradeIn.e(TAG, models.size() + " @size");
                for (int i = 0; i < models.size(); i++) {
                    LoggerTradeIn.e(TAG, models.get(i).getVehicle_id() + " @id" + i);
                    LoggerTradeIn.e(TAG, models.get(i).getVehicle_year() + " @year" + i);
                    LoggerTradeIn.e(TAG, models.get(i).getVehicle_interior_color() + " @color" + i);
                    LoggerTradeIn.e(TAG, models.get(i).getVehicle_guid() + " @color" + i);
                }
            }


        });
    }

    //    Vehicles Id
    public String getVehicleIdsList(Context context) {
        app = DataBaseRoomInstance.getInstance(context);
        List<DBVehiclesModel> listVehicles = app.DaoVehicle().getVehicleSize();
        int dbIndexGet = listVehicles.size() - 1;
        String strId = listVehicles.get(dbIndexGet).getVehicle_id() + "";
        LoggerTradeIn.e(TAG, "strId v= " + strId);
        ConstantsDB.dbVehicleIndex = Integer.parseInt(strId);
        for (int i = 0; i < listVehicles.size(); i++) {
            LoggerTradeIn.e(TAG, "ids v= " + listVehicles.get(i).getVehicle_id() + "");
        }
        return strId;
    }

    //    Media Id
    public String getMediaId(Context context) {
        app = DataBaseRoomInstance.getInstance(context);
        List<DBVehicleMediaModel> listVehicles = app.DaoDBVehicleMedia().getMediaSize();
        int dbIndexGet = listVehicles.size() - 1;
        String strId = listVehicles.get(dbIndexGet).getMedia_id() + "";
        LoggerTradeIn.e(TAG, "strId = " + strId);
//        ConstantsDB.me = Integer.parseInt(strId);
        return strId;
    }

    //    user Id
    public String getUserId(Context context) {
        app = DataBaseRoomInstance.getInstance(context);
        List<DBUsersModel> listVehicles = app.DaoUsers().getUserSize();
        int dbIndexGet = listVehicles.size() - 1;
        String strId = listVehicles.get(dbIndexGet).getUser_id() + "";
        LoggerTradeIn.e(TAG, "strId u= " + strId);
        ConstantsDB.dbUserIndex = Integer.parseInt(strId);
        return strId;
    }

    //    Vehicles Id
    public String getVehicleId(Context context) {
        app = DataBaseRoomInstance.getInstance(context);
        List<DBVehiclesModel> listVehicles = app.DaoVehicle().getVehicleSize();
        int dbIndexGet = listVehicles.size() - 1;
        String strId = listVehicles.get(dbIndexGet).getVehicle_id() + "";
        LoggerTradeIn.e(TAG, "strId v= " + strId);
        ConstantsDB.dbVehicleIndex = Integer.parseInt(strId);
        return strId;
    }

    //    Vehicles print
    public void getVehicleValues(Context context) {
        try {
            int dbIndexGet = ConstantsDB.dbVehicleIndex - 1;
//            int dbIndexGet = ConstantsDB.dbVehicleIndex;
            LoggerTradeIn.e(TAG, "1dbIndexGet = " + dbIndexGet);
            app = DataBaseRoomInstance.getInstance(context);
            List<DBVehiclesModel> listVehicles = app.DaoVehicle().getVehicleSize();

            String strYear = listVehicles.get(dbIndexGet).getVehicle_year();
            String strMake = listVehicles.get(dbIndexGet).getVehicle_make();
            String strMakeName = listVehicles.get(dbIndexGet).getVehicle_make_name();
            String strModel = listVehicles.get(dbIndexGet).getVehicle_model();
            String strModelName = listVehicles.get(dbIndexGet).getVehicle_model_name();
            String strTrim = listVehicles.get(dbIndexGet).getVehicle_trim();
            String strMileage = listVehicles.get(dbIndexGet).getVehicle_mileage();
            String strVin = listVehicles.get(dbIndexGet).getVehicle_vin();
            String strExteriorColor = listVehicles.get(dbIndexGet).getVehicle_exterior_color();

            String strInteriorColor = listVehicles.get(dbIndexGet).getVehicle_interior_color();
            String strTransmission = listVehicles.get(dbIndexGet).getVehicle_transmission();
            String strDriveTrain = listVehicles.get(dbIndexGet).getVehicle_drivetrain();
            String strBodyStyle = listVehicles.get(dbIndexGet).getVehicle_body_style();
            String strEngine = listVehicles.get(dbIndexGet).getVehicle_engine();
            String strSeatType = listVehicles.get(dbIndexGet).getVehicle_seat_type();

            String strOptions = listVehicles.get(dbIndexGet).getVehicle_options();
            String strPackages = listVehicles.get(dbIndexGet).getVehicle_packages();

            String strConditionInterior = listVehicles.get(dbIndexGet).getVehicle_interior_condition();
            String strConditionExterior = listVehicles.get(dbIndexGet).getVehicle_exterior_condition();
            String strConditionSmoked = listVehicles.get(dbIndexGet).isVehicle_smoked() + "";
            String strConditionAccident = listVehicles.get(dbIndexGet).isVehicle_accident() + "";
            String strConditionComment = listVehicles.get(dbIndexGet).getVehicle_comment();

            ConstantsActivity.hmDBVehicles.put(ConstantsApi.KEYS_VEHICLE_ONE_ARRAY[4], strYear);
            ConstantsActivity.hmDBVehicles.put(ConstantsApi.KEYS_VEHICLE_ONE_ARRAY[5], strMake);
            ConstantsActivity.hmDBVehicles.put(ConstantsApi.KEYS_VEHICLE_ONE_ARRAY[27], strMakeName);
            ConstantsActivity.hmDBVehicles.put(ConstantsApi.KEYS_VEHICLE_ONE_ARRAY[6], strModel);
            ConstantsActivity.hmDBVehicles.put(ConstantsApi.KEYS_VEHICLE_ONE_ARRAY[26], strModelName);
            ConstantsActivity.hmDBVehicles.put(ConstantsApi.KEYS_VEHICLE_ONE_ARRAY[7], strTrim);
            ConstantsActivity.hmDBVehicles.put(ConstantsApi.KEYS_VEHICLE_ONE_ARRAY[8], strMileage);
            ConstantsActivity.hmDBVehicles.put(ConstantsApi.KEYS_VEHICLE_ONE_ARRAY[9], strVin);
            ConstantsActivity.hmDBVehicles.put(ConstantsApi.KEYS_VEHICLE_ONE_ARRAY[10], strExteriorColor);

            ConstantsActivity.hmDBVehicles.put(ConstantsApi.KEYS_VEHICLE_ONE_ARRAY[11], strInteriorColor);
            ConstantsActivity.hmDBVehicles.put(ConstantsApi.KEYS_VEHICLE_ONE_ARRAY[12], strTransmission);
            ConstantsActivity.hmDBVehicles.put(ConstantsApi.KEYS_VEHICLE_ONE_ARRAY[13], strDriveTrain);
            ConstantsActivity.hmDBVehicles.put(ConstantsApi.KEYS_VEHICLE_ONE_ARRAY[14], strBodyStyle);
            ConstantsActivity.hmDBVehicles.put(ConstantsApi.KEYS_VEHICLE_ONE_ARRAY[15], strEngine);
            ConstantsActivity.hmDBVehicles.put(ConstantsApi.KEYS_VEHICLE_ONE_ARRAY[16], strSeatType);

//            ConstantsActivity.hmDBVehicles.put(ConstantsApi.KEYS_VEHICLE_ONE_ARRAY[17], strOptions);
            ConstantsActivity.hmDBVehicles.put("vehicle_options", strOptions);
            ConstantsActivity.hmDBVehicles.put(ConstantsApi.KEYS_VEHICLE_ONE_ARRAY[17], strPackages);

            ConstantsActivity.hmDBVehicles.put(ConstantsApi.KEYS_VEHICLE_ONE_ARRAY[18], strConditionInterior);
            ConstantsActivity.hmDBVehicles.put(ConstantsApi.KEYS_VEHICLE_ONE_ARRAY[19], strConditionExterior);
            ConstantsActivity.hmDBVehicles.put(ConstantsApi.KEYS_VEHICLE_ONE_ARRAY[20], strConditionSmoked);
            ConstantsActivity.hmDBVehicles.put(ConstantsApi.KEYS_VEHICLE_ONE_ARRAY[21], strConditionAccident);
            ConstantsActivity.hmDBVehicles.put(ConstantsApi.KEYS_VEHICLE_ONE_ARRAY[28], strConditionComment);

            /*ConstantsActivity.hmDBVehicles.put("year", strYear);
            ConstantsActivity.hmDBVehicles.put("make", strMake);
            ConstantsActivity.hmDBVehicles.put("make_name", strMakeName);
            ConstantsActivity.hmDBVehicles.put("model_name", strModelName);
            ConstantsActivity.hmDBVehicles.put("model", strModel);
            ConstantsActivity.hmDBVehicles.put("trim", strTrim);
            ConstantsActivity.hmDBVehicles.put("mileage", strMileage);
            ConstantsActivity.hmDBVehicles.put("vin", strVin);
            ConstantsActivity.hmDBVehicles.put("exterior_color", strExteriorColor);

            ConstantsActivity.hmDBVehicles.put("interior_color", strInteriorColor);
            ConstantsActivity.hmDBVehicles.put("transmission", strTransmission);
            ConstantsActivity.hmDBVehicles.put("drive_train", strDriveTrain);
            ConstantsActivity.hmDBVehicles.put("body_style", strBodyStyle);
            ConstantsActivity.hmDBVehicles.put("engine", strEngine);
            ConstantsActivity.hmDBVehicles.put("seat_type", strSeatType);

            ConstantsActivity.hmDBVehicles.put("options", strOptions);
            ConstantsActivity.hmDBVehicles.put("packages", strPackages);

            ConstantsActivity.hmDBVehicles.put("interior_condition", strConditionInterior);
            ConstantsActivity.hmDBVehicles.put("exterior_condition", strConditionExterior);
            ConstantsActivity.hmDBVehicles.put("smoked", strConditionSmoked);
            ConstantsActivity.hmDBVehicles.put("accident", strConditionAccident);
            ConstantsActivity.hmDBVehicles.put("comment", strConditionComment);*/
        } catch (Exception e) {
            e.printStackTrace();
            LoggerTradeIn.e(TAG, e.getMessage() + " @538");
            LoggerTradeIn.e(TAG, e + " @540");
        }
    }

    //    Vehicles print
    public void printAllVehicleOptions(Context context) {
        app = DataBaseRoomInstance.getInstance(context);
        List<DBVehicleOptionsModel> listVehicles = app.DaoVehicleOptions().getVehicleOptionsSize();
    }

    //    update vehicle media not required
    public void updateVehicleMedia(Context context,
                                   int media_vehicle_id, String media_guid, String media_url, String media_type, String media_issequence, boolean media_is_uploaded, Date media_created_at, Date media_modified_at
    ) {
        applicationContext = (Application) context.getApplicationContext();
        dbVehicleMediaViewModel = ViewModelProvider.AndroidViewModelFactory.getInstance(applicationContext).create(DBVehicleMediaViewModel.class);
        dbVehicleMediaViewModel.updateVehicleMedia(media_vehicle_id, media_guid, media_url, media_type, media_issequence, media_is_uploaded);
    }

    //    my vehicles
    public List<DBVehiclesModel> getMyVehicleSize(Context context) {
        app = DataBaseRoomInstance.getInstance(context);
        ConstantsDB.listVehiclesModel = app.DaoVehicle().getVehicleSize();
        return ConstantsDB.listVehiclesModel;
    }

    //    my vehicles
    public int getMyVehicleSize2(Context context) {
        app = DataBaseRoomInstance.getInstance(context);
        List<DBVehiclesModel> listVehiclesModel2 = app.DaoVehicle().getVehicleSize();
        return listVehiclesModel2.size();
    }

    //    my users
    public int getMyUserSize2(Context context) {
        app = DataBaseRoomInstance.getInstance(context);
        List<DBUsersModel> listVehiclesModel2 = app.DaoUsers().getUserSize();
        return listVehiclesModel2.size();
    }
    //    my media
    public int getMyMediaSize2(Context context) {
        app = DataBaseRoomInstance.getInstance(context);
        List<DBVehicleMediaModel> listVehiclesModel2 = app.DaoDBVehicleMedia().getMediaSize();
        return listVehiclesModel2.size();
    }
    //
    Context mContext;
    Activity mActivity;

    //    update vehicle Conditions
    public void updateVehicleFlag(Context context, int vehicle_id, String vehicle_flag, Class editScreen, boolean navigationFlag) {
        applicationContext = (Application) context.getApplicationContext();
        dbVehiclesViewModel = ViewModelProvider.AndroidViewModelFactory.getInstance(applicationContext).create(DBVehiclesViewModel.class);
        dbVehiclesViewModel.updateVehicleFlag(vehicle_id, vehicle_flag);
        if(navigationFlag){
            dbSaveLater(context,editScreen);
        }
    }

    public void updateVehiclePercentage(Context context, int vehicle_id, double vehicle_percentage) {
        applicationContext = (Application) context.getApplicationContext();
        dbVehiclesViewModel = ViewModelProvider.AndroidViewModelFactory.getInstance(applicationContext).create(DBVehiclesViewModel.class);
        dbVehiclesViewModel.updateVehiclePercentage(vehicle_id, vehicle_percentage);
    }

    public void dbSubmitCall(Context context) {
//        int dbIndexGet = ConstantsDB.dbVehicleIndex - 1;
        LoggerTradeIn.e(TAG, "dbSubmitCall " + ConstantsDB.dbVehicleIndex);
        applicationContext = (Application) context.getApplicationContext();
        DBVehiclesModel dbModel = new DBVehiclesModel();
        dbModel.setVehicle_id(ConstantsDB.dbVehicleIndex);
        dbVehiclesViewModel.delete(dbModel);

        DBVehicleMediaModel dbVehicleMediaModel = new DBVehicleMediaModel();
        dbVehicleMediaModel.setMedia_id(ConstantsDB.dbMediaIndex);
        dbVehicleMediaViewModel.delete(dbVehicleMediaModel);

        DBUsersModel dbUsersModel = new DBUsersModel();
        dbUsersModel.setUser_id(ConstantsDB.dbUserIndex);
        dbUsersViewModel.delete(dbUsersModel);
    }

    public void dbSaveLater(Context context, Class editScreen) {
        mContext = context;
        mActivity = (Activity) mContext;
        Intent intent = new Intent(mActivity, editScreen);
        intent.setFlags(Intent.FLAG_ACTIVITY_NEW_TASK | Intent.FLAG_ACTIVITY_CLEAR_TASK);
        mActivity.startActivity(intent);
        mActivity.finish();
    }
}
