package com.concatsys.tradein.tradein_plugin.db;

import androidx.lifecycle.LiveData;
import androidx.room.Delete;
import androidx.room.Insert;
import androidx.room.Query;
import androidx.room.Update;

import java.util.List;

@androidx.room.Dao
public interface DBRoofTopDAO {
    //below method is use to add data to database.
    @Insert
    void insert(DBRoofTopModel model);

    //below method is use to update the data in our database.
    @Update
    void update(DBRoofTopModel model);

    //below line is use to delete a specific  in our database.
    @Delete
    void delete(DBRoofTopModel model);

    //on below line we are making query to delete all  from our databse.
    @Query("DELETE FROM "+ ConstantsDB.TABLE_NAME_TI_ROOFTOP_SETTINGS)
    void deleteAllTableValues();

    //below line is to read all the  from our database.
    //in this we are ordering our  in ascending order with our  name.
    @Query("SELECT * FROM "+ ConstantsDB.TABLE_NAME_TI_ROOFTOP_SETTINGS)
    LiveData<List<DBRoofTopModel>> getAllTableValues();

}
