package com.concatsys.tradein.tradein_plugin.db;

import android.app.Application;

import androidx.annotation.NonNull;
import androidx.lifecycle.AndroidViewModel;
import androidx.lifecycle.LiveData;

import java.util.List;

public class DBRoofTopViewModel extends AndroidViewModel implements Comparable<DBRoofTopViewModel> {
    //creating a new variable for  repository.
    private DBRoofTopRepository repository;
    //below line is to create a variable for live data where all the  are present.
    private LiveData<List<DBRoofTopModel>> allTableValues;

    //constructor for our view model.
    public DBRoofTopViewModel(@NonNull Application application) {
        super(application);
        repository = new DBRoofTopRepository(application);
        allTableValues = repository.getAllValues();
    }


    //below method is use to insert the data to our repository.
    public void insert(DBRoofTopModel model) {
        repository.insert(model);
    }

    //below line is to update data in our repository.
    public void update(DBRoofTopModel model) {
        repository.update(model);
    }

    //below line is to delete the data in our repository.
    public void delete(DBRoofTopModel model) {
        repository.delete(model);
    }

    //below method is to delete all the  in our list.
    public void deleteAllValues() {
        repository.deleteAllValues();
    }

    //below method is to get all the  in our list.
    public LiveData<List<DBRoofTopModel>> getAllValues() {
        return allTableValues;
    }

    @Override
    public int compareTo(DBRoofTopViewModel o) {
        return 0;
    }
}



