package com.concatsys.tradein.tradein_plugin.db;

import android.app.Application;

import androidx.annotation.NonNull;
import androidx.lifecycle.AndroidViewModel;
import androidx.lifecycle.LiveData;

import java.util.List;

public class DBSdkViewModel extends AndroidViewModel implements Comparable<DBSdkViewModel> {
    //creating a new variable for  repository.
    private DBSdkRepository repository;
    //below line is to create a variable for live data where all the  are present.
    private LiveData<List<DBSdkModel>> allTableValues;

    //constructor for our view model.
    public DBSdkViewModel(@NonNull Application application) {
        super(application);
        repository = new DBSdkRepository(application);
        allTableValues = repository.getAllValues();
    }


    //below method is use to insert the data to our repository.
    public void insert(DBSdkModel model) {
        repository.insert(model);
    }

    //below line is to update data in our repository.
    public void update(DBSdkModel model) {
        repository.update(model);
    }

    //below line is to delete the data in our repository.
    public void delete(DBSdkModel model) {
        repository.delete(model);
    }

    //below method is to delete all the  in our list.
    public void deleteAllValues() {
        repository.deleteAllValues();
    }

    //below method is to get all the  in our list.
    public LiveData<List<DBSdkModel>> getAllValues() {
        return allTableValues;
    }

    @Override
    public int compareTo(DBSdkViewModel o) {
        return 0;
    }
}


