package com.concatsys.tradein.tradein_plugin.db;

import androidx.lifecycle.LiveData;
import androidx.room.Delete;
import androidx.room.Insert;
import androidx.room.Query;
import androidx.room.Update;

import java.util.List;

@androidx.room.Dao
public interface DBVehicleMediaDAO {
    //below method is use to add data to database.
    @Insert
    void insert(DBVehicleMediaModel model);

    //below method is use to update the data in our database.
    @Update
    void update(DBVehicleMediaModel model);

    //below line is use to delete a specific  in our database.
    @Delete
    void delete(DBVehicleMediaModel model);

    //on below line we are making query to delete all  from our databse.
    @Query("DELETE FROM "+ ConstantsDB.TABLE_NAME_TI_VEHICLE_MEDIA)
    void deleteAllTableValues();

    //below line is to read all the  from our database.
    //in this we are ordering our  in ascending order with our  name.
    @Query("SELECT * FROM "+ ConstantsDB.TABLE_NAME_TI_VEHICLE_MEDIA)
    LiveData<List<DBVehicleMediaModel>> getAllTableValues();


    @Query("UPDATE tradein_vehicle_media SET  media_guid= :media_guid, media_url = :media_url, media_type = :media_type, media_issequence = :media_issequence, media_is_uploaded = :media_is_uploaded WHERE media_vehicle_id = :media_vehicle_id ;")
    void updateVehicleMedia(int media_vehicle_id,
                            String media_guid, String media_url, String media_type, String media_issequence, boolean media_is_uploaded);

    @Query("SELECT * FROM tradein_vehicle_media")
    List<DBVehicleMediaModel> getMediaSize();
}
