package com.concatsys.tradein.tradein_plugin.db;

import android.app.Application;

import androidx.annotation.NonNull;
import androidx.lifecycle.AndroidViewModel;
import androidx.lifecycle.LiveData;

import java.sql.Date;
import java.util.List;

public class DBVehicleMediaViewModel extends AndroidViewModel implements Comparable<DBVehicleMediaViewModel> {
    //creating a new variable for  repository.
    private DBVehicleMediaRepository repository;
    //below line is to create a variable for live data where all the  are present.
    private LiveData<List<DBVehicleMediaModel>> allTableValues;

    //constructor for our view model.
    public DBVehicleMediaViewModel(@NonNull Application application) {
        super(application);
        repository = new DBVehicleMediaRepository(application);
        allTableValues = repository.getAllValues();
    }


    //below method is use to insert the data to our repository.
    public void insert(DBVehicleMediaModel model) {
        repository.insert(model);
    }

    //below line is to update data in our repository.
    public void update(DBVehicleMediaModel model) {
        repository.update(model);
    }

    //below line is to delete the data in our repository.
    public void delete(DBVehicleMediaModel model) {
        repository.delete(model);
    }

    //below method is to delete all the  in our list.
    public void deleteAllValues() {
        repository.deleteAllValues();
    }

    //below method is to get all the  in our list.
    public LiveData<List<DBVehicleMediaModel>> getAllValues() {
        return allTableValues;
    }

    public void updateVehicleMedia(int media_vehicle_id, String media_guid, String media_url, String media_type, String media_issequence, boolean media_is_uploaded){
        repository.updateVehicleMedia(media_vehicle_id, media_guid, media_url, media_type, media_issequence,media_is_uploaded);
    }

    @Override
    public int compareTo(DBVehicleMediaViewModel o) {
        return 0;
    }
}


