package com.concatsys.tradein.tradein_plugin.db;

import androidx.lifecycle.LiveData;
import androidx.room.Delete;
import androidx.room.Insert;
import androidx.room.Query;
import androidx.room.Update;

import java.util.List;

@androidx.room.Dao
public interface DBVehiclesDAO {
    //below method is use to add data to database.
    @Insert
    void insert(DBVehiclesModel model);

    //below method is use to update the data in our database.
    @Update
    void update(DBVehiclesModel model);

    //below line is use to delete a specific  in our database.
    @Delete
    void delete(DBVehiclesModel model);

    //on below line we are making query to delete all  from our databse.
    @Query("DELETE FROM "+ ConstantsDB.TABLE_NAME_TI_VEHICLE)
    void deleteAllTableValues();

    //below line is to read all the  from our database.
    //in this we are ordering our  in ascending order with our  name.
    @Query("SELECT * FROM "+ ConstantsDB.TABLE_NAME_TI_VEHICLE)
    LiveData<List<DBVehiclesModel>> getAllTableValues();

    /*@Query("Update tradein_vehicle SET " +
            "vehicle_year = vehicle_year," +
            "vehicle_make = vehicle_make," +
            "vehicle_model = vehicle_model," +
            "vehicle_trim = vehicle_trim," +
            "vehicle_mileage = vehicle_mileage," +
            "vehicle_vin = vehicle_vin," +
            "vehicle_exterior_color = vehicle_exterior_color " +
            "where vehicle_id = vehicle_id")
    void updateVehicleInfo(String vehicle_year, String vehicle_make, String vehicle_model,
                String vehicle_trim,  String vehicle_mileage,  String vehicle_vin, String vehicle_exterior_color );
*/
//    @Query("UPDATE tradein_vehicle SET vehicle_year = '6' WHERE vehicle_id = 1 ;")
//    @Query("UPDATE tradein_vehicle SET vehicle_year = :vehicle_year, vehicle_make = :vehicle_make, vehicle_model = :vehicle_model, vehicle_trim = :vehicle_trim, vehicle_mileage = :vehicle_mileage, vehicle_vin = :vehicle_vin, vehicle_exterior_color = :vehicle_exterior_color WHERE vehicle_id = 1 ;")
    @Query("UPDATE tradein_vehicle SET vehicle_year = :vehicle_year, vehicle_make = :vehicle_make, vehicle_make_name = :vehicle_make_name, vehicle_model = :vehicle_model, vehicle_model_name = :vehicle_model_name, vehicle_trim = :vehicle_trim, vehicle_mileage = :vehicle_mileage, vehicle_vin = :vehicle_vin, vehicle_exterior_color = :vehicle_exterior_color WHERE vehicle_id = :vehicle_id ;")
    void updateVI1(int vehicle_id, String vehicle_year, String vehicle_make, String vehicle_make_name, String vehicle_model, String vehicle_model_name, String vehicle_trim, String vehicle_mileage, String vehicle_vin, String vehicle_exterior_color);

    @Query("UPDATE tradein_vehicle SET vehicle_interior_color = :vehicle_interior_color, vehicle_transmission = :vehicle_transmission, vehicle_drivetrain = :vehicle_drivetrain, vehicle_body_style = :vehicle_body_style, vehicle_engine = :vehicle_engine, vehicle_seat_type = :vehicle_seat_type WHERE vehicle_id = :vehicle_id ;")
    void updateVI2(int vehicle_id,
                   String vehicle_interior_color, String vehicle_transmission, String vehicle_drivetrain, String vehicle_body_style, String vehicle_engine, String vehicle_seat_type);

    @Query("UPDATE tradein_vehicle SET vehicle_comment = :vehicle_comment, vehicle_options = :vehicle_options, vehicle_packages = :vehicle_packages WHERE vehicle_id = :vehicle_id ;")
    void updateVehicleOptions(int vehicle_id,
                              String vehicle_comment, String vehicle_options, String vehicle_packages);

    @Query("UPDATE tradein_vehicle SET vehicle_interior_condition = :vehicle_interior_condition, vehicle_exterior_condition = :vehicle_exterior_condition, vehicle_smoked = :vehicle_smoked, vehicle_accident = :vehicle_accident, vehicle_comment = :vehicle_comment WHERE vehicle_id = :vehicle_id ;")
    void updateVehicleConditions(int vehicle_id,
                                 String vehicle_interior_condition, String vehicle_exterior_condition, boolean vehicle_smoked, boolean vehicle_accident, String vehicle_comment);

    @Query("UPDATE tradein_vehicle SET vehicle_flag = :vehicle_flag WHERE vehicle_id = :vehicle_id ;")
    void updateVehicleFlag(int vehicle_id, String vehicle_flag);

    @Query("UPDATE tradein_vehicle SET vehicle_info_percentage = :vehicle_percentage WHERE vehicle_id = :vehicle_id ;")
    void updateVehiclePercent(int vehicle_id, double vehicle_percentage);

    @Query("SELECT * FROM tradein_vehicle")
    List<DBVehiclesModel> getVehicleSize();
}
