package com.concatsys.tradein.tradein_plugin.db;

import android.app.Application;

import androidx.annotation.NonNull;
import androidx.lifecycle.AndroidViewModel;
import androidx.lifecycle.LiveData;

import java.sql.Date;
import java.util.List;

public class DBVehiclesViewModel extends AndroidViewModel implements Comparable<DBVehiclesViewModel> {
    //creating a new variable for  repository.
    private DBVehiclesRepository repository;
    //below line is to create a variable for live data where all the  are present.
    private LiveData<List<DBVehiclesModel>> allTableValues;

    //constructor for our view model.
    public DBVehiclesViewModel(@NonNull Application application) {
        super(application);
        repository = new DBVehiclesRepository(application);
        allTableValues = repository.getAllValues();
    }


    //below method is use to insert the data to our repository.
    public void insert(DBVehiclesModel model) {
        repository.insert(model);
    }

    //below line is to update data in our repository.
    public void update(DBVehiclesModel model) {
        repository.update(model);
    }

    public void updateVI1(int vehicle_id, int vehicle_user_id, String vehicle_guid, boolean vehicle_is_uploaded, double vehicle_info_percentage, String vehicle_year, String vehicle_make, String vehicle_make_name, String vehicle_model, String vehicle_model_name, String vehicle_trim, String vehicle_mileage, String vehicle_vin, String vehicle_exterior_color){
        repository.updateVI1(vehicle_id, vehicle_user_id, vehicle_guid, vehicle_is_uploaded, vehicle_info_percentage, vehicle_year,  vehicle_make, vehicle_make_name, vehicle_model, vehicle_model_name, vehicle_trim,  vehicle_mileage,  vehicle_vin,  vehicle_exterior_color);
    }

    public void updateVI2(int vehicle_id, int vehicle_user_id, String vehicle_guid, boolean vehicle_is_uploaded, double vehicle_info_percentage,
                          String vehicle_interior_color, String vehicle_transmission, String vehicle_drivetrain, String vehicle_body_style, String vehicle_engine, String vehicle_seat_type){
        repository.updateVI2(vehicle_id, vehicle_user_id, vehicle_guid, vehicle_is_uploaded, vehicle_info_percentage, vehicle_interior_color,  vehicle_transmission,  vehicle_drivetrain,  vehicle_body_style,  vehicle_engine,  vehicle_seat_type);

    }

    public void updateVehicleOptions(int vehicle_id, int vehicle_user_id, String vehicle_guid, boolean vehicle_is_uploaded, double vehicle_info_percentage,
                                     String vehicle_comment, String vehicle_options, String vehicle_packages){
        repository.updateVehicleOptions(vehicle_id, vehicle_user_id, vehicle_guid, vehicle_is_uploaded, vehicle_info_percentage,vehicle_comment,vehicle_options,vehicle_packages);

    }

    public void updateVehicleCondition(int vehicle_id, int vehicle_user_id, String vehicle_guid, boolean vehicle_is_uploaded, double vehicle_info_percentage,
                                       String vehicle_interior_condition,String vehicle_exterior_condition,String vehicle_smoked,String vehicle_accident,String vehicle_comment){
        repository.updateVehicleCondition(vehicle_id, vehicle_user_id, vehicle_guid, vehicle_is_uploaded, vehicle_info_percentage,vehicle_interior_condition,vehicle_exterior_condition,vehicle_smoked,vehicle_accident,vehicle_comment);

    }

    public void updateVehicleFlag(int vehicle_id, String vehicle_comment){
        repository.updateVehicleFlag(vehicle_id, vehicle_comment);

    }

    public void updateVehiclePercentage(int vehicle_id, double vehicle_percentage){
        repository.updateVehiclePercentage(vehicle_id, vehicle_percentage);

    }
    //below line is to delete the data in our repository.
    public void delete(DBVehiclesModel model) {
        repository.delete(model);
    }

    //below method is to delete all the  in our list.
    public void deleteAllValues() {
        repository.deleteAllValues();
    }

    //below method is to get all the  in our list.
    public LiveData<List<DBVehiclesModel>> getAllValues() {
        return allTableValues;
    }

    @Override
    public int compareTo(DBVehiclesViewModel o) {
        return 0;
    }
}


