package com.concatsys.tradein.tradein_plugin.dialogsandviews;

import android.app.Activity;
import android.app.Dialog;
import android.content.Context;
import android.view.View;
import android.view.Window;
import android.widget.Button;
import android.widget.LinearLayout;
import android.widget.TextView;

import com.concatsys.tradein.tradein_plugin.R;
import com.concatsys.tradein.tradein_plugin.activity.AddVehicleActivity;
import com.concatsys.tradein.tradein_plugin.activity.MyProfileActivity;
import com.concatsys.tradein.tradein_plugin.activity.MyVehicleActivity;
import com.concatsys.tradein.tradein_plugin.activity.ProfileStatusActivity;
import com.concatsys.tradein.tradein_plugin.db.ConstantsDB;
import com.concatsys.tradein.tradein_plugin.db.DBOperations;
import com.concatsys.tradein.tradein_plugin.interfaces.DialogCallBack;

public class DialogCustomize {

    private static DialogCustomize instance = null;

    private DialogCustomize() {
    }

    public static DialogCustomize getInstance() {
        if (instance == null) {
            instance = new DialogCustomize();
        }
        return instance;
    }

    private Dialog dialogDisplay;
    private Context mContext;
    private Activity mActivity;
    /*public DialogCustom(Context context) {
        mContext = context;
//        mActivity = (Activity) mContext;
    }*/

    /* progress dialog */
    public void displayProgressDialog(Context context, String flagDisplayDismiss) {
        if (flagDisplayDismiss.equals(ConstantsDialog.FLAG_DIALOG_DISPLAY)) {
            dialogDisplay = new Dialog(context);
            if (!dialogDisplay.isShowing()) {
                dialogDisplay.setCancelable(false);
                dialogDisplay.requestWindowFeature(Window.FEATURE_NO_TITLE);
                dialogDisplay.setContentView(R.layout.dialog_progress);
                dialogDisplay.show();
            }
        } else if (flagDisplayDismiss.equals(ConstantsDialog.FLAG_DIALOG_DISMISS)) {
            if (dialogDisplay.isShowing()) {
                dialogDisplay.dismiss();
            }
        }

    }

    /* dialog display */
    public void displayDialog(Context context, String flagDisplayDismiss, String title, String msg) {
        if (flagDisplayDismiss.equals(ConstantsDialog.FLAG_DIALOG_DISPLAY)) {
            dialogDisplay = new Dialog(context);
            if (!dialogDisplay.isShowing()) {
                dialogDisplay.setCancelable(false);
                dialogDisplay.requestWindowFeature(Window.FEATURE_NO_TITLE);
                dialogDisplay.setContentView(R.layout.dialog_alert_info);
                TextView tv_d_title = dialogDisplay.findViewById(R.id.tv_d_title);
                TextView tv_d_msg = dialogDisplay.findViewById(R.id.tv_d_msg);
                tv_d_title.setText(title);
                tv_d_msg.setText(msg);
                Button btn_d_ok = dialogDisplay.findViewById(R.id.tv_d_ok);
                btn_d_ok.setOnClickListener(new View.OnClickListener() {
                    @Override
                    public void onClick(View v) {
                        dialogDisplay.dismiss();
                    }
                });
                dialogDisplay.show();
            }
        } else if (flagDisplayDismiss.equals(ConstantsDialog.FLAG_DIALOG_DISMISS)) {
            if (dialogDisplay.isShowing()) {
                dialogDisplay.dismiss();
            }
        }
    }

    /* dialog validation */
    public void displayValidationDialog(Context context, String flagDisplayDismiss, String title, String msg) {
        mContext = context;
        dialogCallBack = (DialogCallBack) context;
        if (flagDisplayDismiss.equals(ConstantsDialog.FLAG_DIALOG_DISPLAY)) {
            dialogDisplay = new Dialog(context);
            if (!dialogDisplay.isShowing()) {
                dialogDisplay.setCancelable(false);
                dialogDisplay.requestWindowFeature(Window.FEATURE_NO_TITLE);
                dialogDisplay.setContentView(R.layout.dialog_alert_validations);
                TextView tv_d_title = dialogDisplay.findViewById(R.id.tv_d_title);
                TextView tv_d_msg = dialogDisplay.findViewById(R.id.tv_d_msg);
                tv_d_title.setText(title);
                tv_d_msg.setText(msg);
                TextView tv_d_ok = dialogDisplay.findViewById(R.id.tv_d_ok);
                tv_d_ok.setOnClickListener(new View.OnClickListener() {
                    @Override
                    public void onClick(View v) {
                        dialogDisplay.dismiss();
                        if(ConstantsDB.TABLE_NAME_SCREEN.equals(mContext.getString(R.string.summary))){
                            dialogCallBack.sendDialogFlag(ConstantsDialog.FLAG_DIALOG_SUBMIT_VEHICLE);
                        }
                    }
                });
                dialogDisplay.show();
            }
        } else if (flagDisplayDismiss.equals(ConstantsDialog.FLAG_DIALOG_DISMISS)) {
            if (dialogDisplay.isShowing()) {
                dialogDisplay.dismiss();
            }
        }
    }
    /* dialog with save or cancel */
    private DialogCallBack dialogCallBack;
    public void displayCancelDialog(Context context, String flagDisplayDismiss, String title, String msg) {
        mContext = context;
        dialogCallBack = (DialogCallBack) context;
        if (flagDisplayDismiss.equals(ConstantsDialog.FLAG_DIALOG_DISPLAY)) {
            dialogDisplay = new Dialog(context);
            if (!dialogDisplay.isShowing()) {
                dialogDisplay.setCancelable(true);
                dialogDisplay.requestWindowFeature(Window.FEATURE_NO_TITLE);
                dialogDisplay.setContentView(R.layout.dialog_cancel);
                TextView tv_d_title = dialogDisplay.findViewById(R.id.tv_d_title);
//                TextView tv_d_msg = dialogDisplay.findViewById(R.id.tv_d_msg);
                tv_d_title.setText(title);
//                tv_d_msg.setText(msg);
                TextView tv_d_yes_discard = dialogDisplay.findViewById(R.id.tv_d_yes_discard);
                tv_d_yes_discard.setOnClickListener(new View.OnClickListener() {
                    @Override
                    public void onClick(View v) {
                        dialogDisplay.dismiss();
                        activityDiscard();
//                        dialogCallBack.sendDialogFlag(ConstantsDialog.FLAG_DIALOG_CANCEL_YES);
                    }
                });
                TextView tv_d_save_later = dialogDisplay.findViewById(R.id.tv_d_save_later);
                tv_d_save_later.setOnClickListener(new View.OnClickListener() {
                    @Override
                    public void onClick(View v) {
                        dialogDisplay.dismiss();
                        activitySaveLater();
//                        dialogCallBack.sendDialogFlag(ConstantsDialog.FLAG_DIALOG_CANCEL_NO);
                    }
                });
                dialogDisplay.show();
            }
        } else if (flagDisplayDismiss.equals(ConstantsDialog.FLAG_DIALOG_DISMISS)) {
            if (dialogDisplay.isShowing()) {
                dialogDisplay.dismiss();
            }
        }
    }

    /* dialog display */
    public void displayDialogCamera(Context context, String flagDisplayDismiss, String title, String msg) {
        mContext = context;
        dialogCallBack = (DialogCallBack) context;
        if (flagDisplayDismiss.equals(ConstantsDialog.FLAG_DIALOG_DISPLAY)) {
            dialogDisplay = new Dialog(context);
            if (!dialogDisplay.isShowing()) {
                dialogDisplay.setCancelable(true);
                dialogDisplay.requestWindowFeature(Window.FEATURE_NO_TITLE);
                dialogDisplay.setContentView(R.layout.dialog_camera);

                LinearLayout lyt_image_capture = dialogDisplay.findViewById(R.id.lyt_image_capture);
                lyt_image_capture.setOnClickListener(new View.OnClickListener() {
                    @Override
                    public void onClick(View v) {
                        dialogCallBack.sendDialogFlag(ConstantsDialog.FLAG_DIALOG_IMAGE_CAPTURE);
                        dialogDisplay.dismiss();
                    }
                });

                LinearLayout lyt_video_capture = dialogDisplay.findViewById(R.id.lyt_video_capture);
                lyt_video_capture.setOnClickListener(new View.OnClickListener() {
                    @Override
                    public void onClick(View v) {
                        dialogCallBack.sendDialogFlag(ConstantsDialog.FLAG_DIALOG_VIDEO_CAPTURE);
                        dialogDisplay.dismiss();
                    }
                });
                dialogDisplay.show();
            }
        } else if (flagDisplayDismiss.equals(ConstantsDialog.FLAG_DIALOG_DISMISS)) {
            if (dialogDisplay.isShowing()) {
                dialogDisplay.dismiss();
            }
        }
    }

    /* Activity Discard Intent  */
    public void activityDiscard(){
        DBOperations dbOperations = DBOperations.getInstance();
//        dbOperations.dbDiscardUpdate(mContext, MyVehicleActivity.class);
        dbOperations.updateVehicleFlag(mContext,ConstantsDB.dbVehicleIndex,"gone", MyVehicleActivity.class, true);
    }
    public void activitySaveLater(){
        DBOperations dbOperations = DBOperations.getInstance();
//        dbOperations.dbSaveLater(mContext, MyProfileActivity.class);
        dbOperations.dbSaveLater(mContext, MyVehicleActivity.class);
    }
}
