package com.concatsys.tradein.tradein_plugin.logs;

import android.util.Log;

import com.concatsys.tradein.tradein_plugin.BuildConfig;


/* Custom Log Class with all operations */
public class LoggerTradeIn {

    private static LoggerTradeIn instance = null;
    private LoggerTradeIn() {}

    public static LoggerTradeIn getInstance() {
        if(instance == null) {
            instance = new LoggerTradeIn();
        }
        return instance;
    }
    public static void d(String tag, String data){
        if(BuildConfig.DEBUG) {
            Log.d(tag, data);
        }
    }

    public static void i(String tag, String data){
        if(BuildConfig.DEBUG) {
            Log.i(tag, data);
        }
    }

    public static void e(String tag, String data){
        if(BuildConfig.DEBUG) {
            Log.e(tag, data);
        }
    }

    public static void e(String tag, String data, Throwable t){
        if(BuildConfig.DEBUG) {
            Log.e(tag, data, t);
        }
    }

    public static void w(String tag, String data){
        if(BuildConfig.DEBUG) {
            Log.w(tag, data);
        }
    }

    public static void wtf(String tag, String data){
        if(BuildConfig.DEBUG) {
            Log.wtf(tag, data);
        }
    }

    public static boolean isDebugEnabled(String tag) {
        return BuildConfig.DEBUG;
    }
}
