package com.concatsys.tradein.tradein_plugin.sharedpreference;


import android.content.Context;
import android.content.SharedPreferences;

import com.concatsys.tradein.tradein_plugin.R;
import com.concatsys.tradein.tradein_plugin.db.ConstantsDB;

import java.io.ObjectStreamException;

/* Shared Preference Class Operations */
public class SharedPreferenceTI {
    private String TAG = getClass().getSimpleName();
    private static SharedPreferenceTI instance = null;
//    private static Context context;


    private SharedPreferenceTI() {
        //Prevent creating multiple instances from the reflection API.
        if (instance != null) {
            throw new RuntimeException("Use getInstance() method to get the instance of this class.");
        }
    }

    public static SharedPreferenceTI getInstance() {
        if (instance == null) {
            synchronized (SharedPreferenceTI.class) {
                if (instance == null) {
                    instance = new SharedPreferenceTI();
                }
            }
        }
        return instance;
    }

    private Object readResolve() throws ObjectStreamException {
        return instance;
    }

//    private SharedPreferenceTI(Context mContext) {
//        this.context = mContext;
//    }

//    public static SharedPreferenceTI getInstance() {
//        if (instance == null) {
//            instance = new SharedPreferenceTI();
//        }
//        return instance;
//    }
//
//    public static SharedPreferenceTI getInstance(Context mContext) {
//        if (instance == null) {
//            context = mContext;
//            instance = new SharedPreferenceTI(mContext);
//        }
//        return instance;
//    }

    /* save value with key */
    public void putStringValue(Context context, String key, String value) {
        SharedPreferences pref = context.getSharedPreferences(ConstantsDB.SHARED_PREFERENCE_NAME, 0);
        SharedPreferences.Editor editor = pref.edit();
        editor.putString(key, value);
        editor.apply();
        editor.commit();
    }

    /* retrieve string value with key */
    public String getStringValue(Context context,String key) {
        SharedPreferences pref = context.getSharedPreferences(ConstantsDB.SHARED_PREFERENCE_NAME, 0);
        String value = pref.getString(key,context.getString(R.string.add_vehicle));
        return value;
    }

    /* save int value with key */
    public void putIntValue(Context context, String key, int value) {
        SharedPreferences pref = context.getSharedPreferences(ConstantsDB.SHARED_PREFERENCE_NAME, 0);
        SharedPreferences.Editor editor = pref.edit();
        editor.putInt(key, value);
        editor.apply();
        editor.commit();
    }

    /* retrieve int value with key */
    public int getIntValue(Context context,String key) {
        SharedPreferences pref = context.getSharedPreferences(ConstantsDB.SHARED_PREFERENCE_NAME, 0);
        int value = pref.getInt(key, 999);
        return value;
    }
}
